'use strict'

vevo.directive 'ngActivateModal', ['$rootScope', '$timeout', 'API', 'Storage', 'ComScore'
, ($rootScope, $timeout, API, Storage, ComScore) ->

    restrict: 'A'
    scope: true

    controller: ($scope) ->

        $scope.init = =>
            $timeout -> $scope.handleInit()

        $scope.$on '$destroy', =>
            $scope.handleDestroy()

        $scope.$on 'TvInput.ngActivateModal.closeModal', =>
            $timeout -> $rootScope.modal = ''


    link: (scope, el, attrs) ->

        _loginInterval = ''

        ComScore.trackCustomEvent
            user_status_events: 'initiate_login'

        scope.handleInit = =>

            API.activate.getAuthenticate (data) =>

                if data.success
                    _setData data
                    _handleLoggedIn()

                else

                    activationCode = data.activationCode
                    $timeout -> scope.activationCode = activationCode

                    _loginInterval = setInterval =>
                        API.activate.getAuthenticate (data) =>
                            if data.success
                                clearInterval _loginInterval
                                _setData data
                                _handleLoggedIn()

                    , 4000

        scope.handleDestroy = =>
            clearInterval _loginInterval

        _handleLoggedIn = (data) =>

            ComScore.trackCustomEvent
                user_status_events: 'fb_login_success'

            ComScore.setUserStatus()

            $timeout -> $rootScope.modal = ''
            $rootScope.$broadcast 'ngActivateModal.Playlists.getUserPlaylistsAfterLogin'
            $rootScope.$broadcast 'ngActivateModal.ngPlaylists.userLoggedIn'
            $rootScope.$broadcast 'ngActivateModal.ngConfirmMessage.userLoggedIn'

        _setData = (data) =>
            username = data.result?.username
            username = if username then username.split(' ')[0] else ''
            obj =
                username: username
                sessionToken: data.session_token
                userId: data.user_id
                userData: data.result

            Storage.set obj


]


