'use strict'

vevo.directive 'ngBrowse', ['$rootScope', '$timeout', 'Nav', 'API', 'App', 'UI'
, ($rootScope, $timeout, Nav, API, App, UI) ->

    restrict: 'A'
    scope: true

    controller: ($scope) ->

        $scope.init = =>
            $timeout -> $scope.handleInit()

        $scope.$on 'Nav.ngBrowse.updateSectionFocus', (e, data) =>
            $scope.handleUpdateSectionFocus(data)

        $scope.$on 'TvInput.ngBrowse.handleReturnKey', =>
            $scope.handleReturnKey()

        $scope.$on 'app.updateNavZone', =>
            $scope.handleUpdateNavZone()

        $scope.$on 'Nav.ngBrowse.loadMoreBrowseVideo', (e, data) =>
            $scope.handleLoadMoreBrowseVideo(data)

        $scope.$on 'ngPlaylistCreateModal.ngBrowse.refocusOnSelected', =>
            $scope.handleRefocusOnSelected()

        $scope.$on 'TvInput.ngBrowse.playShow', (e, data) =>
            $scope.handlePlayShow(data)

        $scope.$on '$destroy', =>
            $scope.handleDestroy()

    link: (scope, el, attrs) ->

        scope.list = []

        _viewEl = el.find('#browse-view')
        _viewEl.css
            opacity: 0

        scope.handleInit = =>

            $rootScope.loading = $rootScope.strings.loading

            if App.VideoModal.browse.todayList.length
                _setRowWidth()
                $timeout -> scope.popGenre = App.VideoModal.browse.popGenre
                $timeout -> scope.hiphopGenre = App.VideoModal.browse.hiphopGenre
                $timeout -> scope.alternativeGenre = App.VideoModal.browse.alternativeGenre
                $timeout -> scope.countryGenre = App.VideoModal.browse.countryGenre
                $timeout -> scope.soulGenre = App.VideoModal.browse.soulGenre
                $timeout -> scope.rockGenre = App.VideoModal.browse.rockGenre
                $timeout -> scope.electronicGenre = App.VideoModal.browse.electronicGenre
                $timeout -> scope.jazzGenre = App.VideoModal.browse.jazzGenre
                $timeout -> scope.reggaeGenre = App.VideoModal.browse.reggaeGenre
                $timeout -> scope.latinoGenre = App.VideoModal.browse.latinoGenre
                $timeout -> scope.metalGenre = App.VideoModal.browse.metalGenre
                $timeout -> scope.classicalGenre = App.VideoModal.browse.classicalGenre
                $timeout -> scope.holidayGenre = App.VideoModal.browse.holidayGenre

                $timeout -> scope.premieresList = App.VideoModal.browse.premieresList
                $timeout -> scope.todayList = App.VideoModal.browse.todayList
                $timeout -> scope.weekList = App.VideoModal.browse.weekList
                $timeout -> scope.certifiedList = App.VideoModal.browse.certifiedList
                $timeout -> scope.liveList = App.VideoModal.browse.liveList
                $timeout -> scope.showsList = App.VideoModal.browse.showsList

                _handleLiftContent []
                $timeout ->
                    $rootScope.loading = false
                , 2000

                UI.animateIn _viewEl,
                    speed: 1500


            else
                API.browse.getAllBrowseData (data) =>
                    _setRowWidth data

                    $timeout -> App.VideoModal.browse.popGenre = scope.popGenre = data.popGenre
                    $timeout -> App.VideoModal.browse.hiphopGenre = scope.hiphopGenre = data.hiphopGenre
                    $timeout -> App.VideoModal.browse.alternativeGenre = scope.alternativeGenre = data.alternativeGenre
                    $timeout -> App.VideoModal.browse.countryGenre = scope.countryGenre = data.countryGenre
                    $timeout -> App.VideoModal.browse.soulGenre = scope.soulGenre = data.soulGenre
                    $timeout -> App.VideoModal.browse.rockGenre = scope.rockGenre = data.rockGenre
                    $timeout -> App.VideoModal.browse.electronicGenre = scope.electronicGenre = data.electronicGenre
                    $timeout -> App.VideoModal.browse.jazzGenre = scope.jazzGenre = data.jazzGenre
                    $timeout -> App.VideoModal.browse.reggaeGenre = scope.reggaeGenre = data.reggaeGenre
                    $timeout -> App.VideoModal.browse.latinoGenre = scope.latinoGenre = data.latinoGenre
                    $timeout -> App.VideoModal.browse.metalGenre = scope.metalGenre = data.metalGenre
                    $timeout -> App.VideoModal.browse.classicalGenre = scope.classicalGenre = data.classicalGenre
                    $timeout -> App.VideoModal.browse.holidayGenre = scope.holidayGenre = data.holidayGenre

                    $timeout -> App.VideoModal.browse.premieresList = scope.premieresList = data.premieres
                    $timeout -> App.VideoModal.browse.todayList = scope.todayList = data.today
                    $timeout -> App.VideoModal.browse.weekList = scope.weekList = data.week
                    $timeout -> App.VideoModal.browse.certifiedList = scope.certifiedList = data.certified
                    $timeout -> App.VideoModal.browse.liveList = scope.liveList = data.live
                    $timeout -> App.VideoModal.browse.showsList = scope.showsList = data.shows

                    _handleLiftContent data.lift


                    $timeout ->
                        $rootScope.loading = false
                    , 2000

                    UI.animateIn _viewEl,
                        speed: 1500

        _setRowWidth = (data) =>

            showsArr = if data then data.shows else App.VideoModal.browse.showsList

            showsSectionEl = el.find('.section-wrap').filter('[data-section=shows]')
            width = showsArr.length * 410
            showsSectionEl.css
                width: width


        _handleLiftContent = (arr) =>
            sectionEl = el.find('.section-wrap').filter('[data-section=lift]')

            if App.VideoModal.browse?.liftArtists?.length

                width = App.VideoModal.browse.liftArtists.length * 410
                sectionEl.css
                    width: width

                scope.liftList = App.VideoModal.browse.liftArtists
            else
                tempArr = arr

                _getVideos = (obj) =>
                    playlist_url = obj.playlist_url
                    playlist_url = playlist_url.split '/'
                    playlist_id = playlist_url[playlist_url.length - 1]
                    API.browse.getLiftArtistPlaylistVideos {playlistId: playlist_id}, (data) =>
                        obj.image_url = data.image_url
                        obj.videocount = data.videocount
                        obj.videos = data.videos
                        App.VideoModal.browse.liftArtists.push obj

                        width = App.VideoModal.browse.liftArtists.length * 410
                        scope.liftList = App.VideoModal.browse.liftArtists
                        sectionEl.css
                            width: width

                        if tempArr.length
                            _getVideos tempArr.shift()

                _getVideos tempArr.shift()





        scope.handleUpdateSectionFocus = (data) =>
            scope.$apply => scope.sectionFocus = data.list

        scope.handleReturnKey = =>
            _viewEl.attr('data-top', 0)
            _viewEl.animate
                top: 0
            angular.element('.nav-current-item-focus').removeClass 'nav-current-item-focus'
            scope.$apply => scope.sectionFocus = ''

            

        scope.handleUpdateNavZone = =>
            scope.$apply => scope.curNavZone = Nav.curNavZone

        scope.handleLoadMoreBrowseVideo = (data) =>

            list = data.list

            switch list
                when 'premieres'
                    return if scope.premieresList.length >= 25
                when 'today'
                    return if scope.todayList.length >= 25
                when 'week'
                    return if scope.weekList.length >= 25
                when 'certified'
                    return if scope.certifiedList.length >= 25
                when 'live'
                    return if scope.liveList.length >= 25


            obj =
                list: list

            API.browse.getBrowseData obj, (data) =>
                sectionEl = el.find('.section-wrap').filter('[data-section=' + list + ']')
                width = (API.browse.loadMoreBrowseData[list] + 5) * 410
                sectionEl.css
                    width: width
                switch list
                    when 'premieres'
                        $.merge scope.premieresList, data
                    when 'today'
                        $.merge scope.todayList, data
                    when 'week'
                        $.merge scope.weekList, data
                    when 'certified'
                        $.merge scope.certifiedList, data
                    when 'live'
                        $.merge scope.liveList, data


        scope.handleRefocusOnSelected = =>
            focusItemEl = el.find('.nav-current-item-focus:first')
            Nav.curNavFocusItemEl = focusItemEl
            Nav.curNavZone = focusItemEl.parent().attr 'id'

        scope.handlePlayShow = (data) =>

            showId = data.showId
            showName = data.showName
            showsList = App.VideoModal.browse.showsList
            selectedShow = {}
            for show in showsList
                if show.id is showId
                    selectedShow = show
                    break

            allEpisodesArr = []
            seasonsArr = selectedShow.seasons
            return if not seasonsArr.length

            for season in seasonsArr
                episodesArr = season.episodes
                for episode in episodesArr
                    obj = {}
                    if episode.playlist
                        obj.playlistId = episode.playlist
                        allEpisodesArr.push obj
                    else if episode.isrc
                        obj.isrc = episode.isrc
                        allEpisodesArr.push obj



            arr = []
            counter = 0
            App.VideoModal.shows = []

            getData = (item) =>
                if item.playlistId
                    # item is playlist
                    API.playlists.getSinglePlaylist {playlistId: item.playlistId}, (data) =>
                        videosArr = data.videos
                        tempArr = App.VideoModal.shows
                        App.VideoModal.shows = tempArr.concat(videosArr)
                        
                        if counter is 0
                            firstVideo = App.VideoModal.shows[0]
                            # init video modal
                            App.VideoModal.isrc = firstVideo.isrc
                            $timeout ->
                                $rootScope.app.modalView = 'browseShow'
                                $rootScope.app.videoModalType = 'shows'
                                $rootScope.app.videoModalShowsName = showName
                                $rootScope.modal = 'video'
                        else
                            # append to existing video modal slider
                            $rootScope.$broadcast 'ngBrowse.ngVideoModalBrowseSlider.updateShowsList'
                        counter++
                        if allEpisodesArr.length
                            getData allEpisodesArr.shift()
                else
                    API.video.getSingleVideoForShow {isrc: item.isrc}, (res) =>
                        tempArr = App.VideoModal.shows
                        tempArr.push res
                        App.VideoModal.shows = tempArr

                        if counter is 0
                            # init video modal
                            App.VideoModal.isrc = item.isrc
                            $timeout ->
                                $rootScope.app.modalView = 'browseShow'
                                $rootScope.app.videoModalType = 'shows'
                                $rootScope.app.videoModalShowsName = showName
                                $rootScope.modal = 'video'
                        else
                            # append to existing video modal slider
                            $rootScope.$broadcast 'ngBrowse.ngVideoModalBrowseSlider.updateShowsList'

                        counter++
                        if allEpisodesArr.length
                            getData allEpisodesArr.shift()

            getData allEpisodesArr.shift()
            
        scope.handleDestroy = =>

            App.VideoModal.browse.premieresList = App.VideoModal.browse.premieresList.slice(0, 6)
            App.VideoModal.browse.todayList = App.VideoModal.browse.todayList.slice(0, 6)
            App.VideoModal.browse.weekList = App.VideoModal.browse.weekList.slice(0, 6)
            App.VideoModal.browse.certifiedList = App.VideoModal.browse.certifiedList.slice(0, 6)
            App.VideoModal.browse.liveList = App.VideoModal.browse.liveList.slice(0, 6)


]


