'use strict'

vevo.directive 'ngBrowseSlider', ['$rootScope', '$timeout', ($rootScope, $timeout) ->

    restrict: 'A'
    scope: true

    controller: ($scope) ->

        $scope.$on 'Nav.ngBrowseSlider.initBrowseSlider', (e, data) =>
            $scope.handleInitBrowserSlider(data)

        $scope.$on 'Nav.ngBrowseSlider.browseNext', (e, data) =>
            $scope.handleBrowseNext(data)

        $scope.$on 'Nav.ngBrowseSlider.browsePrev', (e, data) =>
            $scope.handleBrowsePrev(data)

    link: (scope, el, attrs) ->

        curIndex = 0
        curIndexOnScreen = 0
        distance = 0
        viewEl = angular.element('#browse-view')
        _overlayEl = []

        scope.handleInitBrowserSlider = (data) =>
            return if el.attr('data-list') isnt data.list

            curIndexOnScreen = data.curIndexOnScreen
            curIndex = curIndex + data.indexDiff

            if data.direction is 'down' and data.rowIndex isnt 0
                top = Number(viewEl.attr('data-top')) - 416
                viewEl.attr('data-top', top)
                viewEl.css
                    top: top
            else if data.direction is 'up'
                top = Number(viewEl.attr('data-top')) + 416
                viewEl.attr('data-top', top)
                viewEl.css
                    top: top


        scope.handleBrowseNext = (data) =>
            return if el.attr('data-list') isnt data.list

            curIndex++

            if curIndexOnScreen is 2
                distance -= 394
                el.animate
                    left: distance

                $timeout ->
                    _overlayEl = el.find('.nav-item .overlay')
                    _overlayEl.removeClass 'active'
                    leftOverlayIndex = curIndex - 3
                    rightOverlayIndex = curIndex + 1
                    $(_overlayEl[leftOverlayIndex]).addClass 'active'
                    $(_overlayEl[rightOverlayIndex]).addClass 'active'
                , 300
            else
                curIndexOnScreen++


            el.attr 'data-cur-index-on-screen', curIndexOnScreen
            el.attr 'data-cur-index', curIndex



        scope.handleBrowsePrev = (data) =>
            return if el.attr('data-list') isnt data.list

            curIndex--

            if curIndexOnScreen is 0
                distance += 394
                el.animate
                    left: distance

                _overlayEl.removeClass 'active'
                leftOverlayIndex = curIndex - 1
                rightOverlayIndex = curIndex + 3
                $(_overlayEl[leftOverlayIndex]).addClass 'active'
                $(_overlayEl[rightOverlayIndex]).addClass 'active'
            else
                curIndexOnScreen--

            el.attr 'data-cur-index-on-screen', curIndexOnScreen
            el.attr 'data-cur-index', curIndex

                




]









