'use strict'

vevo.directive 'ngConfirmExplicitModal', ['$rootScope', '$timeout', 'Storage', ($rootScope, $timeout, Storage) ->

    restrict: 'A'
    scope: true

    controller: ($scope) ->


        $scope.$on 'TvInput.ngConfirmExplicitModal.navigate', (e, data) =>
            $scope.handleNavigate data

        $scope.$on 'TvInput.ngConfirmExplicitModal.enterKey', =>
            $scope.handleEnterKey()


    link: (scope, el, attrs) ->

        _button = 'confirm'
        scope.activeButton = 'confirm'

        scope.handleEnterKey = =>
            if _button is 'confirm'
                # store confirm explicit for user

                Storage.set
                    confirmExplicit: true

                $timeout -> $rootScope.subModal = ''
                $rootScope.$broadcast 'ngConfirmExplicitModal.ngVideoModal.doneConfirmingExplicit'
            else
                $timeout -> $rootScope.subModal = ''

                modalView = $rootScope.app.modalView
                switch modalView
                    when 'browse' then $rootScope.$broadcast 'ngConfirmExplicitModal.ngVideoModalBrowseSlider.autoPlayNext'
                    when 'browseShow' then $rootScope.$broadcast 'ngConfirmExplicitModal.ngVideoModalBrowseSlider.autoPlayNext'
                    when 'search' then $rootScope.$broadcast 'ngConfirmExplicitModal.ngVideoModalSearchSlider.autoPlayNext'
                    when 'playlists' then $rootScope.$broadcast 'ngConfirmExplicitModal.ngVideoModalPlaylistSlider.autoPlayNext'


        scope.handleNavigate = (data) =>

            key = data.key

            if key is 'left'
                _navigateLeft()
            else if key is 'right'
                _navigateRight()

        _navigateLeft = =>
            return if _button is 'confirm'
            _button = 'confirm'
            scope.$apply -> scope.activeButton = 'confirm'

        _navigateRight = =>
            return if _button is 'skip'
            _button = 'skip'
            scope.$apply -> scope.activeButton = 'skip'


]




