'use strict'

vevo.directive 'ngConfirmMessage', ['$rootScope', '$timeout', 'UI', 'K', ($rootScope, $timeout, UI, K) ->

    restrict: 'A'
    scope: true

    controller: ($scope) ->

        $scope.$on 'Playlists.ngConfirmMessage.addedToWatchLaterPlaylist', (e, data) =>
            $scope.handleAddedToWatchLaterPlaylist data

        $scope.$on 'ngPlaylistSelectModal.ngConfirmMessage.addedToPlaylist', (e, data) =>
            $scope.handleAddedToPlaylist data

        $scope.$on 'ngActivateModal.ngConfirmMessage.userLoggedIn', =>
            $scope.handleUserLoggedIn()

        $scope.$on 'Playlists.ngConfirmMessage.reachedMaxVideosInPublicPlaylist', =>
            $scope.handleReachedMaxVideosInPublicPlaylist()

        $scope.$on 'ngVideoModal.ngConfirmMessage.videoError', =>
            $scope.handleVideoError()

    link: (scope, el, attrs) ->

        scope.showIcon = false

        _showAndHideMessage = =>
            UI.animateIn el

            $timeout ->
                UI.animateOut el
            , 2000

        _showMessage = =>
            UI.animateIn el

        scope.handleAddedToPlaylist = (data) =>
            message = $rootScope.strings.playlistAddMessage
            message = message.replace '{videoTitle}', '"' + data.title + '"'
            message = message.replace '{playlistName}', '"' + data.playlistName + '"'
            scope.confirmMessage = message
            scope.showIcon = 'check'
            _showAndHideMessage()

        scope.handleAddedToWatchLaterPlaylist = (data) =>
            message = $rootScope.strings.playlistAddMessage
            message = message.replace '{videoTitle}', '"' + data.title + '"'
            message = message.replace '{playlistName}', '"Samsung Watch Later"'
            scope.confirmMessage = message
            scope.showIcon = 'check'
            _showAndHideMessage()

        scope.handleUserLoggedIn = =>
            scope.confirmMessage = $rootScope.strings.userLoggedIn
            scope.showIcon = 'check'
            _showAndHideMessage()

        scope.handleReachedMaxVideosInPublicPlaylist = =>
            scope.confirmMessage = $rootScope.strings.playlistReachedMax
            scope.showIcon = false
            _showAndHideMessage()

        scope.handleVideoError = =>
            scope.confirmMessage = $rootScope.strings.errLoadingVideo
            scope.showIcon = false
            _showMessage()
            $timeout ->
                _countDownTimer()

        _countDownTimer = =>

            counterEl = el.find('#confirmation-message-counter')
            counterEl.text 5

            countDown = =>
                $timeout ->

                    num = Number counterEl.text()
                    if num > 0
                        counterEl.text num - 1
                        countDown()
                    else
                        UI.animateOut el
                        modalView = $rootScope.app.modalView
                        switch modalView
                            when 'browse' then $rootScope.$broadcast 'ngConfirmMessage.ngVideoModalBrowseSlider.autoPlayNext'
                            when 'browseShow' then $rootScope.$broadcast 'ngConfirmMessage.ngVideoModalBrowseSlider.autoPlayNext'
                            when 'search' then $rootScope.$broadcast 'ngConfirmMessage.ngVideoModalSearchSlider.autoPlayNext'
                            when 'playlists' then $rootScope.$broadcast 'ngConfirmMessage.ngVideoModalPlaylistSlider.autoPlayNext'
                        
                , 1000

            countDown()

]



