// Generated by CoffeeScript 1.6.2
(function() {
  'use strict';  vevo.directive('ngConfirmMessage', [
    '$rootScope', '$timeout', 'UI', 'K', function($rootScope, $timeout, UI, K) {
      return {
        restrict: 'A',
        scope: true,
        controller: function($scope) {
          var _this = this;

          $scope.$on('Playlists.ngConfirmMessage.addedToWatchLaterPlaylist', function(e, data) {
            return $scope.handleAddedToWatchLaterPlaylist(data);
          });
          $scope.$on('ngPlaylistSelectModal.ngConfirmMessage.addedToPlaylist', function(e, data) {
            return $scope.handleAddedToPlaylist(data);
          });
          $scope.$on('ngActivateModal.ngConfirmMessage.userLoggedIn', function() {
            return $scope.handleUserLoggedIn();
          });
          $scope.$on('Playlists.ngConfirmMessage.reachedMaxVideosInPublicPlaylist', function() {
            return $scope.handleReachedMaxVideosInPublicPlaylist();
          });
          return $scope.$on('ngVideoModal.ngConfirmMessage.videoError', function() {
            return $scope.handleVideoError();
          });
        },
        link: function(scope, el, attrs) {
          var _countDownTimer, _showAndHideMessage, _showMessage,
            _this = this;

          scope.showIcon = false;
          _showAndHideMessage = function() {
            UI.animateIn(el);
            return $timeout(function() {
              return UI.animateOut(el);
            }, 2000);
          };
          _showMessage = function() {
            return UI.animateIn(el);
          };
          scope.handleAddedToPlaylist = function(data) {
            var message;

            message = $rootScope.strings.playlistAddMessage;
            message = message.replace('{videoTitle}', '"' + data.title + '"');
            message = message.replace('{playlistName}', '"' + data.playlistName + '"');
            scope.confirmMessage = message;
            scope.showIcon = 'check';
            return _showAndHideMessage();
          };
          scope.handleAddedToWatchLaterPlaylist = function(data) {
            var message;

            message = $rootScope.strings.playlistAddMessage;
            message = message.replace('{videoTitle}', '"' + data.title + '"');
            message = message.replace('{playlistName}', '"Samsung Watch Later"');
            scope.confirmMessage = message;
            scope.showIcon = 'check';
            return _showAndHideMessage();
          };
          scope.handleUserLoggedIn = function() {
            scope.confirmMessage = $rootScope.strings.userLoggedIn;
            scope.showIcon = 'check';
            return _showAndHideMessage();
          };
          scope.handleReachedMaxVideosInPublicPlaylist = function() {
            scope.confirmMessage = $rootScope.strings.playlistReachedMax;
            scope.showIcon = false;
            return _showAndHideMessage();
          };
          scope.handleVideoError = function() {
            scope.confirmMessage = $rootScope.strings.errLoadingVideo;
            scope.showIcon = false;
            _showMessage();
            return $timeout(function() {
              return _countDownTimer();
            });
          };
          return _countDownTimer = function() {
            var countDown, counterEl;

            counterEl = el.find('#confirmation-message-counter');
            counterEl.text(5);
            countDown = function() {
              return $timeout(function() {
                var modalView, num;

                num = Number(counterEl.text());
                if (num > 0) {
                  counterEl.text(num - 1);
                  return countDown();
                } else {
                  UI.animateOut(el);
                  modalView = $rootScope.app.modalView;
                  switch (modalView) {
                    case 'browse':
                      return $rootScope.$broadcast('ngConfirmMessage.ngVideoModalBrowseSlider.autoPlayNext');
                    case 'browseShow':
                      return $rootScope.$broadcast('ngConfirmMessage.ngVideoModalBrowseSlider.autoPlayNext');
                    case 'search':
                      return $rootScope.$broadcast('ngConfirmMessage.ngVideoModalSearchSlider.autoPlayNext');
                    case 'playlists':
                      return $rootScope.$broadcast('ngConfirmMessage.ngVideoModalPlaylistSlider.autoPlayNext');
                  }
                }
              }, 1000);
            };
            return countDown();
          };
        }
      };
    }
  ]);

}).call(this);
