'use strict'

vevo.directive 'ngKeypad', ['$rootScope', '$timeout', 'K', 'Nav', 'App', ($rootScope, $timeout, K, Nav, App) ->

    restrict: 'A'
    scope: true
    templateUrl: $rootScope.template.partial.keypad
    replace: false

    controller: ($scope) ->

        $scope.init = =>
            $timeout -> $scope.handleInit()

        $scope.$on 'ngSearch.ngKeypad.reopen', =>
            $scope.handleInit()

        $scope.$on 'TvInput.ngKeypad.enterKeypadKey', (e, data) =>
            $scope.handleEnterKeypadKey(data)

        $scope.$on 'TvInput.ngKeypad.enterKeypadSpace', (e, data) =>
            $scope.handleEnterKeypadSpace(data)

        $scope.$on 'TvInput.ngKeypad.enterKeypadDelete', (e, data) =>
            $scope.handleEnterKeypadDelete(data)

        $scope.$on 'TvInput.ngKeypad.enterKeypadClear', (e, data) =>
            $scope.handleEnterKeypadClear(data)

        $scope.$on 'TvInput.ngKeypad.enterKeypadCaps', (e, data) =>
            $scope.handleEnterKeypadCaps(data)

        $scope.$on 'TvInput.ngKeypad.enterKeypadShift', (e, data) =>
            $scope.handleEnterKeypadShift(data)

        $scope.$on 'onRepeatFinishRender.setCurFocusEl', =>
            $scope.handleSetCurFocusEl()

        $scope.$on 'ngSearch.ngKeypad.animateOut', =>
            $scope.handleAnimateOut()

    link: (scope, el, attrs) ->

        _toggleCapsOn = false
        _toggleShiftOn = false
        _curIndexKeypad = 0
        _curView = App.getView()
        _subModal = $rootScope.subModal
        _initLoad = true

        scope.curIndexKeypad = 0

        navSearchKeysEl = el.find('#nav-keypad')


        scope.handleInit = =>
            $timeout -> _setRegularKeypad()

        scope.handleSetCurFocusEl = =>
            if _curIndexKeypad >= 0
                navSearchKeysEl.find('.nav-item.nav-current-item-focus').removeClass 'nav-current-item-focus'
                newItemEl = navSearchKeysEl.find('.nav-item').eq _curIndexKeypad
                Nav.curNavFocusItemEl = newItemEl
                newItemEl.addClass 'nav-current-item-focus'



        _setRegularKeypad = =>

            arr = []
            arr = arr.concat K.Keypad.letters
            arr = arr.concat K.Keypad.numbers
            arr = arr.concat K.Keypad.specialChars

            if _toggleShiftOn or _toggleCapsOn
                curFocusEl = navSearchKeysEl.find('.nav-current-item-focus:first')
                if curFocusEl.size()
                    _curIndexKeypad = curFocusEl.index()
                else
                    _curIndexKeypad = -1

                scope.$apply ->
                    scope.curIndexKeypad = _curIndexKeypad


            if _initLoad
                _initLoad = false
            else
                scope.$apply ->
                    scope.keys = []

            scope.$apply ->
                scope.keys = arr


        _setCapsKeypad = =>
            arr = []
            arr = arr.concat K.Keypad.capLetters
            arr = arr.concat K.Keypad.numbers
            arr = arr.concat K.Keypad.specialChars

            if _toggleShiftOn or _toggleCapsOn
                curFocusEl = navSearchKeysEl.find('.nav-current-item-focus:first')
                if curFocusEl.size()
                    _curIndexKeypad = curFocusEl.index()
                else
                    _curIndexKeypad = -1
                scope.$apply ->
                    scope.curIndexKeypad = _curIndexKeypad

            scope.$apply ->
                scope.keys = []

            scope.$apply ->
                scope.keys = arr

        scope.handleEnterKeypadKey = (data) =>
            if _toggleShiftOn
                _setRegularKeypad()
                _toggleShiftOn = false

            _emitEvent
                action: 'add'
                char: data.char

        scope.handleEnterKeypadSpace = (data) =>
            _emitEvent
                action: 'space'

        scope.handleEnterKeypadDelete = (data) =>
            _emitEvent
                action: 'delete'

        scope.handleEnterKeypadClear = (data) =>
            _emitEvent
                action: 'clear'

        _emitEvent = (params) =>
            if _subModal is 'playlistCreate'
                scope.$emit 'ngKeypad.ngPlaylistCreateModal.updateKeypadStr', params
            else if _curView is 'search'
                scope.$emit 'ngKeypad.ngSearch.updateKeypadStr', params


        scope.handleEnterKeypadCaps = (data) =>
            if _toggleCapsOn
                _toggleCapsOn = false
                _setRegularKeypad()
            else
                _toggleCapsOn = true
                _setCapsKeypad()



        scope.handleEnterKeypadShift = (data) =>
            if _toggleShiftOn
                _toggleShiftOn = false
                _setRegularKeypad()
            else
                _toggleShiftOn = true
                _setCapsKeypad()

        scope.handleAnimateOut = =>
            _curIndexKeypad = 0
            _toggleCapsOn = false
            _toggleShiftOn = false

]

