// Generated by CoffeeScript 1.6.2
(function() {
  'use strict';  vevo.directive('ngKeypad', [
    '$rootScope', '$timeout', 'K', 'Nav', 'App', function($rootScope, $timeout, K, Nav, App) {
      return {
        restrict: 'A',
        scope: true,
        templateUrl: $rootScope.template.partial.keypad,
        replace: false,
        controller: function($scope) {
          var _this = this;

          $scope.init = function() {
            return $timeout(function() {
              return $scope.handleInit();
            });
          };
          $scope.$on('ngSearch.ngKeypad.reopen', function() {
            return $scope.handleInit();
          });
          $scope.$on('TvInput.ngKeypad.enterKeypadKey', function(e, data) {
            return $scope.handleEnterKeypadKey(data);
          });
          $scope.$on('TvInput.ngKeypad.enterKeypadSpace', function(e, data) {
            return $scope.handleEnterKeypadSpace(data);
          });
          $scope.$on('TvInput.ngKeypad.enterKeypadDelete', function(e, data) {
            return $scope.handleEnterKeypadDelete(data);
          });
          $scope.$on('TvInput.ngKeypad.enterKeypadClear', function(e, data) {
            return $scope.handleEnterKeypadClear(data);
          });
          $scope.$on('TvInput.ngKeypad.enterKeypadCaps', function(e, data) {
            return $scope.handleEnterKeypadCaps(data);
          });
          $scope.$on('TvInput.ngKeypad.enterKeypadShift', function(e, data) {
            return $scope.handleEnterKeypadShift(data);
          });
          $scope.$on('onRepeatFinishRender.setCurFocusEl', function() {
            return $scope.handleSetCurFocusEl();
          });
          return $scope.$on('ngSearch.ngKeypad.animateOut', function() {
            return $scope.handleAnimateOut();
          });
        },
        link: function(scope, el, attrs) {
          var navSearchKeysEl, _curIndexKeypad, _curView, _emitEvent, _initLoad, _setCapsKeypad, _setRegularKeypad, _subModal, _toggleCapsOn, _toggleShiftOn,
            _this = this;

          _toggleCapsOn = false;
          _toggleShiftOn = false;
          _curIndexKeypad = 0;
          _curView = App.getView();
          _subModal = $rootScope.subModal;
          _initLoad = true;
          scope.curIndexKeypad = 0;
          navSearchKeysEl = el.find('#nav-keypad');
          scope.handleInit = function() {
            return $timeout(function() {
              return _setRegularKeypad();
            });
          };
          scope.handleSetCurFocusEl = function() {
            var newItemEl;

            if (_curIndexKeypad >= 0) {
              navSearchKeysEl.find('.nav-item.nav-current-item-focus').removeClass('nav-current-item-focus');
              newItemEl = navSearchKeysEl.find('.nav-item').eq(_curIndexKeypad);
              Nav.curNavFocusItemEl = newItemEl;
              return newItemEl.addClass('nav-current-item-focus');
            }
          };
          _setRegularKeypad = function() {
            var arr, curFocusEl;

            arr = [];
            arr = arr.concat(K.Keypad.letters);
            arr = arr.concat(K.Keypad.numbers);
            arr = arr.concat(K.Keypad.specialChars);
            if (_toggleShiftOn || _toggleCapsOn) {
              curFocusEl = navSearchKeysEl.find('.nav-current-item-focus:first');
              if (curFocusEl.size()) {
                _curIndexKeypad = curFocusEl.index();
              } else {
                _curIndexKeypad = -1;
              }
              scope.$apply(function() {
                return scope.curIndexKeypad = _curIndexKeypad;
              });
            }
            if (_initLoad) {
              _initLoad = false;
            } else {
              scope.$apply(function() {
                return scope.keys = [];
              });
            }
            return scope.$apply(function() {
              return scope.keys = arr;
            });
          };
          _setCapsKeypad = function() {
            var arr, curFocusEl;

            arr = [];
            arr = arr.concat(K.Keypad.capLetters);
            arr = arr.concat(K.Keypad.numbers);
            arr = arr.concat(K.Keypad.specialChars);
            if (_toggleShiftOn || _toggleCapsOn) {
              curFocusEl = navSearchKeysEl.find('.nav-current-item-focus:first');
              if (curFocusEl.size()) {
                _curIndexKeypad = curFocusEl.index();
              } else {
                _curIndexKeypad = -1;
              }
              scope.$apply(function() {
                return scope.curIndexKeypad = _curIndexKeypad;
              });
            }
            scope.$apply(function() {
              return scope.keys = [];
            });
            return scope.$apply(function() {
              return scope.keys = arr;
            });
          };
          scope.handleEnterKeypadKey = function(data) {
            if (_toggleShiftOn) {
              _setRegularKeypad();
              _toggleShiftOn = false;
            }
            return _emitEvent({
              action: 'add',
              char: data.char
            });
          };
          scope.handleEnterKeypadSpace = function(data) {
            return _emitEvent({
              action: 'space'
            });
          };
          scope.handleEnterKeypadDelete = function(data) {
            return _emitEvent({
              action: 'delete'
            });
          };
          scope.handleEnterKeypadClear = function(data) {
            return _emitEvent({
              action: 'clear'
            });
          };
          _emitEvent = function(params) {
            if (_subModal === 'playlistCreate') {
              return scope.$emit('ngKeypad.ngPlaylistCreateModal.updateKeypadStr', params);
            } else if (_curView === 'search') {
              return scope.$emit('ngKeypad.ngSearch.updateKeypadStr', params);
            }
          };
          scope.handleEnterKeypadCaps = function(data) {
            if (_toggleCapsOn) {
              _toggleCapsOn = false;
              return _setRegularKeypad();
            } else {
              _toggleCapsOn = true;
              return _setCapsKeypad();
            }
          };
          scope.handleEnterKeypadShift = function(data) {
            if (_toggleShiftOn) {
              _toggleShiftOn = false;
              return _setRegularKeypad();
            } else {
              _toggleShiftOn = true;
              return _setCapsKeypad();
            }
          };
          return scope.handleAnimateOut = function() {
            _curIndexKeypad = 0;
            _toggleCapsOn = false;
            return _toggleShiftOn = false;
          };
        }
      };
    }
  ]);

}).call(this);
