'use strict'

vevo.directive 'ngTopNav', ['$rootScope', '$timeout', 'UI', 'Nav', ($rootScope, $timeout, UI, Nav) ->

    restrict: 'A'
    scope: true

    controller: ($scope) ->

        $scope.$on 'TvInput.ngTopNav.handleReturnKey', =>
            $scope.handleReturnKey()

        $scope.$on 'app.updateNavZone', =>
            $scope.handleUpdateNavZone()

        $scope.$on 'ngVevoTv.ngTopNav.hideTopNav', (e, data) =>
            $scope.handleHideTopNav(data)

        $scope.$on 'ngVevoTv.ngTopNav.showTopNav', (e, data) =>
            $scope.handleShowTopNav(data)

    link: (scope, el, attrs) ->

        accountDropdownEl = angular.element('.account-dropdown-wrap:first')


        scope.curNavZone = Nav.curNavZone

        scope.handleReturnKey = =>
            el.find('.nav-current-item-selected').addClass 'nav-current-item-focus'
            Nav.curNavFocusItemEl = el.find '.nav-current-item-focus'
            Nav.curNavZone = 'nav-top'
            $rootScope.$broadcast 'app.updateNavZone'

        scope.handleUpdateNavZone = =>
            scope.$apply => scope.curNavZone = Nav.curNavZone

        scope.handleHideTopNav = (data) =>
            UI.animateOut el, data
            if $rootScope.dropdown is 'account'
                UI.animateOut accountDropdownEl, data

        scope.handleShowTopNav = (data) =>
            UI.animateIn el, data
            if $rootScope.dropdown is 'account'
                UI.animateIn accountDropdownEl, data


]


