'use strict'

vevo.directive 'ngPlaylistCreateModal', ['$rootScope', '$timeout', 'App','UI', 'Nav', 'API', 'Playlists', 'ComScore', ($rootScope, $timeout, App, UI, Nav, API, Playlists, ComScore) ->

    restrict: 'A'
    scope: true

    controller: ($scope) ->

        $scope.init = =>
            $timeout -> $scope.handleInit()

        $scope.$on 'ngKeypad.ngPlaylistCreateModal.updateKeypadStr', (e, data) =>
            $scope.handleUpdateKeypadStr(data)

        $scope.$on 'TvInput.ngPlaylistCreateModal.createPlaylist', =>
            $scope.handleCreatePlaylist()

        $scope.$on '$destroy', =>
            $scope.handleDestroy()


    link: (scope, el, attrs) ->

        scope.playlistName = ''

        _cursorInterval = ''
        _keypadStr = ''

        playlistCursorEl = el.find('#playlist-cursor')
        keypadBoxEl = el.find('.keypad-box')


        scope.handleInit = =>
            Nav.curNavZone = 'nav-keypad'
            $timeout -> $rootScope.$broadcast 'app.updateNavZone'

            _cursorInterval = setInterval =>
                playlistCursorEl.animate {opacity: 0}, ->
                    playlistCursorEl.animate
                        opacity: 1
            , 1000

            UI.animateIn keypadBoxEl


        scope.handleUpdateKeypadStr = (data) =>
            action = data.action
            switch action
                when 'add'
                    char = data.char
                    _keypadStr += char
                when 'space'
                    _keypadStr += ' '
                when 'delete'
                    _keypadStr = _keypadStr.substring(0, _keypadStr.length - 1)
                when 'clear'
                    _keypadStr = ''
            scope.$apply => scope.playlistName = _keypadStr


        scope.handleCreatePlaylist = =>
            curView = App.getView()
            if not scope.playlistName
                if $rootScope.modal is 'video'
                    $timeout -> $rootScope.subModal = 'playlistSelect'
                else if curView is 'playlists'
                    $timeout -> $rootScope.subModal = ''
                return

            $timeout -> $rootScope.loading = 'Creating...'
            API.playlists.createPlaylistForUser {title: scope.playlistName}, (data) =>
                Playlists.addNewUserPlaylist data

                if $rootScope.modal is 'video'
                    $timeout -> $rootScope.subModal = 'playlistSelect'
                else if curView is 'playlists'
                    $timeout -> $rootScope.subModal = ''
                    $rootScope.$broadcast 'ngPlaylistCreateModal.ngPlaylists.reloadViewForUser'
                $timeout -> $rootScope.loading = false
                ComScore.trackCustomEvent
                    playlist_events: 'create_playlist'


        scope.handleDestroy = =>
            # clear setInterval
            clearInterval _cursorInterval

            curView = App.getView()

            if curView is 'browse'
                $rootScope.$broadcast 'ngPlaylistCreateModal.ngBrowse.refocusOnSelected'
            else if curView is 'search'
                $rootScope.$broadcast 'ngPlaylistCreateModal.ngSearch.refocusOnSelected'
            else if curView is 'playlists'
                if $rootScope.modal is 'video'
                    $rootScope.$broadcast 'ngPlaylistCreateModal.ngPlaylists.refocusOnSelected'
                else
                    $rootScope.$broadcast 'ngPlaylistCreateModal.ngPlaylists.shiftFocusToTopNav'

]


