// Generated by CoffeeScript 1.6.2
(function() {
  'use strict';  vevo.directive('ngPlaylistCreateModal', [
    '$rootScope', '$timeout', 'App', 'UI', 'Nav', 'API', 'Playlists', 'ComScore', function($rootScope, $timeout, App, UI, Nav, API, Playlists, ComScore) {
      return {
        restrict: 'A',
        scope: true,
        controller: function($scope) {
          var _this = this;

          $scope.init = function() {
            return $timeout(function() {
              return $scope.handleInit();
            });
          };
          $scope.$on('ngKeypad.ngPlaylistCreateModal.updateKeypadStr', function(e, data) {
            return $scope.handleUpdateKeypadStr(data);
          });
          $scope.$on('TvInput.ngPlaylistCreateModal.createPlaylist', function() {
            return $scope.handleCreatePlaylist();
          });
          return $scope.$on('$destroy', function() {
            return $scope.handleDestroy();
          });
        },
        link: function(scope, el, attrs) {
          var keypadBoxEl, playlistCursorEl, _cursorInterval, _keypadStr,
            _this = this;

          scope.playlistName = '';
          _cursorInterval = '';
          _keypadStr = '';
          playlistCursorEl = el.find('#playlist-cursor');
          keypadBoxEl = el.find('.keypad-box');
          scope.handleInit = function() {
            Nav.curNavZone = 'nav-keypad';
            $timeout(function() {
              return $rootScope.$broadcast('app.updateNavZone');
            });
            _cursorInterval = setInterval(function() {
              return playlistCursorEl.animate({
                opacity: 0
              }, function() {
                return playlistCursorEl.animate({
                  opacity: 1
                });
              });
            }, 1000);
            return UI.animateIn(keypadBoxEl);
          };
          scope.handleUpdateKeypadStr = function(data) {
            var action, char;

            action = data.action;
            switch (action) {
              case 'add':
                char = data.char;
                _keypadStr += char;
                break;
              case 'space':
                _keypadStr += ' ';
                break;
              case 'delete':
                _keypadStr = _keypadStr.substring(0, _keypadStr.length - 1);
                break;
              case 'clear':
                _keypadStr = '';
            }
            return scope.$apply(function() {
              return scope.playlistName = _keypadStr;
            });
          };
          scope.handleCreatePlaylist = function() {
            var curView;

            curView = App.getView();
            if (!scope.playlistName) {
              if ($rootScope.modal === 'video') {
                $timeout(function() {
                  return $rootScope.subModal = 'playlistSelect';
                });
              } else if (curView === 'playlists') {
                $timeout(function() {
                  return $rootScope.subModal = '';
                });
              }
              return;
            }
            $timeout(function() {
              return $rootScope.loading = 'Creating...';
            });
            return API.playlists.createPlaylistForUser({
              title: scope.playlistName
            }, function(data) {
              Playlists.addNewUserPlaylist(data);
              if ($rootScope.modal === 'video') {
                $timeout(function() {
                  return $rootScope.subModal = 'playlistSelect';
                });
              } else if (curView === 'playlists') {
                $timeout(function() {
                  return $rootScope.subModal = '';
                });
                $rootScope.$broadcast('ngPlaylistCreateModal.ngPlaylists.reloadViewForUser');
              }
              $timeout(function() {
                return $rootScope.loading = false;
              });
              return ComScore.trackCustomEvent({
                playlist_events: 'create_playlist'
              });
            });
          };
          return scope.handleDestroy = function() {
            var curView;

            clearInterval(_cursorInterval);
            curView = App.getView();
            if (curView === 'browse') {
              return $rootScope.$broadcast('ngPlaylistCreateModal.ngBrowse.refocusOnSelected');
            } else if (curView === 'search') {
              return $rootScope.$broadcast('ngPlaylistCreateModal.ngSearch.refocusOnSelected');
            } else if (curView === 'playlists') {
              if ($rootScope.modal === 'video') {
                return $rootScope.$broadcast('ngPlaylistCreateModal.ngPlaylists.refocusOnSelected');
              } else {
                return $rootScope.$broadcast('ngPlaylistCreateModal.ngPlaylists.shiftFocusToTopNav');
              }
            }
          };
        }
      };
    }
  ]);

}).call(this);
