'use strict'

vevo.directive 'ngPlaylistDeleteModal', ['$rootScope', '$timeout', 'Playlists', 'Nav', 'API', 'ComScore', ($rootScope, $timeout, Playlists, Nav, API, ComScore) ->

    restrict: 'A'
    scope: true

    controller: ($scope) ->

        $scope.init = =>
            $timeout -> $scope.handleInit()

        $scope.$on 'TvInput.ngPlaylistDeleteModal.navigate', (e, data) =>
            $scope.handleNavigate data

        $scope.$on 'TvInput.ngPlaylistDeleteModal.enterKey', =>
            $scope.handleEnterKey()


    link: (scope, el, attrs) ->

        _button = 'delete'
        scope.activeButton = 'delete'

        scope.handleInit = =>
            scope.$apply -> scope.playlistName = Playlists.playlistNameToDelete

        _deletePlaylist = =>
            $timeout -> $rootScope.loading = $rootScope.strings.deleting
            $timeout -> $rootScope.subModal = ''
            playlistId = Playlists.playlistIdToDelete

            API.playlists.deletePlaylist {playlistId: playlistId}, =>
                Playlists.deleteSinglePlaylist()
                $rootScope.$broadcast 'ngPlaylistDeleteModal.ngPlaylists.deletedPlaylist'
                $rootScope.$broadcast 'ngPlaylistDeleteModal.ngPlaylists.shiftFocusToTopNav'
                $timeout -> $rootScope.loading = false
                ComScore.trackCustomEvent
                    playlist_events: 'delete_playlist'

        scope.handleEnterKey = =>
            if _button is 'delete'
                _deletePlaylist()
            else
                $timeout -> $rootScope.subModal = ''


        scope.handleNavigate = (data) =>

            key = data.key

            if key is 'left'
                _navigateLeft()
            else if key is 'right'
                _navigateRight()

        _navigateLeft = =>
            return if _button is 'delete'
            _button = 'delete'
            scope.$apply -> scope.activeButton = 'delete'

        _navigateRight = =>
            return if _button is 'cancel'
            _button = 'cancel'
            scope.$apply -> scope.activeButton = 'cancel'



]



