// Generated by CoffeeScript 1.6.2
(function() {
  'use strict';  vevo.directive('ngPlaylistSelectModal', [
    '$rootScope', '$timeout', 'Playlists', 'API', 'ComScore', 'App', function($rootScope, $timeout, Playlists, API, ComScore, App) {
      return {
        restrict: 'A',
        scope: true,
        controller: function($scope) {
          var _this = this;

          $scope.init = function() {
            return $timeout(function() {
              return $scope.handleInit();
            });
          };
          $scope.$on('TvInput.ngPlaylistSelectModal.navigate', function(e, data) {
            return $scope.handleNavigate(data);
          });
          return $scope.$on('TvInput.ngPlaylistSelectModal.enterKey', function() {
            return $scope.handleEnterKey();
          });
        },
        link: function(scope, el, attrs) {
          var _createPlaylistNavEl, _curFocusEl, _distance, _getCurFocusEl, _navigateDown, _navigateUp, _playlists, _selectPlaylistNavEl, _wrapperEl,
            _this = this;

          _playlists = [];
          _createPlaylistNavEl = el.find('#nav-create-playlist');
          _selectPlaylistNavEl = el.find('#nav-select-playlist');
          _curFocusEl = '';
          _distance = 0;
          _wrapperEl = el.find('#playlist-select-modal-view > .wrapper');
          scope.handleInit = function() {
            var arr, obj, playlist, userPlaylists, _i, _len;

            $rootScope.$broadcast('ngPlaylistSelectModal.ngVideoModal.hideVideoElements');
            userPlaylists = Playlists.getUserPlaylists();
            arr = [];
            for (_i = 0, _len = userPlaylists.length; _i < _len; _i++) {
              playlist = userPlaylists[_i];
              obj = {
                id: playlist.playlist_id,
                title: playlist.title
              };
              arr.push(obj);
            }
            _playlists = arr;
            return scope.playlists = _playlists;
          };
          scope.handleNavigate = function(data) {
            var key;

            key = data.key;
            if (key === 'up') {
              return _navigateUp();
            } else if (key === 'down') {
              return _navigateDown();
            }
          };
          scope.handleEnterKey = function() {
            var event, itemEl, params, playlistId, playlistName, videoData;

            itemEl = _getCurFocusEl();
            event = itemEl.attr('data-enter');
            if (event === 'showCreatePlaylistModal') {
              return $timeout(function() {
                return $rootScope.subModal = 'playlistCreate';
              });
            } else if (event === 'selectPlaylistToAddVideo') {
              playlistId = _curFocusEl.attr('data-playlist-id');
              playlistName = _curFocusEl.attr('data-playlist-title');
              if (App.VideoModal.isAddCurPlayingVideoToPlaylist) {
                videoData = App.VideoModal.data;
              } else {
                videoData = App.VideoModal.videoList[App.VideoModal.curFocusOnSliderIndex];
              }
              params = {
                playlistId: playlistId,
                isrcs: videoData.isrc,
                image_url: videoData.image_url
              };
              return Playlists.addToUserPlaylist(params, function() {
                $rootScope.$broadcast('ngPlaylistSelectModal.ngConfirmMessage.addedToPlaylist', {
                  playlistName: playlistName,
                  title: videoData.title
                });
                $timeout(function() {
                  return $rootScope.subModal = '';
                });
                return ComScore.trackCustomEvent({
                  watch_page_events: 'add_to_playlist'
                });
              });
            }
          };
          _navigateDown = function() {
            var itemEl, nextItemEl;

            itemEl = _getCurFocusEl();
            if (itemEl.hasClass('create-playlist-item')) {
              itemEl.removeClass('cur-focus');
              nextItemEl = _selectPlaylistNavEl.find('.nav-item:first');
              nextItemEl.addClass('cur-focus');
              return _curFocusEl = nextItemEl;
            } else if (itemEl.hasClass('playlist-item')) {
              nextItemEl = itemEl.next('.nav-item');
              if (!nextItemEl.size()) {
                return;
              }
              itemEl.removeClass('cur-focus');
              nextItemEl.addClass('cur-focus');
              _curFocusEl = nextItemEl;
              _distance -= 64;
              return _wrapperEl.css({
                top: _distance
              });
            }
          };
          _navigateUp = function() {
            var itemEl, prevItemEl;

            itemEl = _getCurFocusEl();
            if (itemEl.hasClass('playlist-item')) {
              prevItemEl = itemEl.prev('.nav-item');
              if (prevItemEl.size()) {
                itemEl.removeClass('cur-focus');
                prevItemEl.addClass('cur-focus');
                _curFocusEl = prevItemEl;
                _distance += 64;
                return _wrapperEl.css({
                  top: _distance
                });
              } else {
                itemEl.removeClass('cur-focus');
                prevItemEl = _createPlaylistNavEl.find('.nav-item:first');
                prevItemEl.addClass('cur-focus');
                return _curFocusEl = prevItemEl;
              }
            }
          };
          return _getCurFocusEl = function() {
            if (_curFocusEl) {
              return _curFocusEl;
            }
            _curFocusEl = el.find('.cur-focus:first');
            return _curFocusEl;
          };
        }
      };
    }
  ]);

}).call(this);
