// Generated by CoffeeScript 1.6.2
(function() {
  'use strict';  vevo.directive('ngPlaylists', [
    '$rootScope', '$timeout', 'Playlists', 'API', 'Storage', 'UI', 'Nav', function($rootScope, $timeout, Playlists, API, Storage, UI, Nav) {
      return {
        restrict: 'A',
        scope: true,
        controller: function($scope) {
          var _this = this;

          $scope.init = function() {
            return $timeout(function() {
              return $scope.handleInit();
            });
          };
          $scope.$on('TvInput.ngPlaylists.userLoggedOut', function() {
            return $scope.handleUserLoggedOut();
          });
          $scope.$on('ngActivateModal.ngPlaylists.userLoggedIn', function() {
            return $scope.handleUserLoggedIn();
          });
          $scope.$on('Nav.ngPlaylists.navigateDown', function() {
            return $scope.handleNavigateDown();
          });
          $scope.$on('Nav.ngPlaylists.navigateUp', function() {
            return $scope.handleNavigateUp();
          });
          $scope.$on('Playlists.ngPlaylists.reloadViewAfterCreatingNewPublicPlaylistForUser', function() {
            return $scope.handleReloadViewForUser();
          });
          $scope.$on('TvInput.ngPlaylists.initVideoModalFromPlaylistForUser', function(e, data) {
            return $scope.handleInitVideoModalFromPlaylistForUser(data);
          });
          $scope.$on('TvInput.ngPlaylists.initVideoModalFromPlaylistForPublic', function() {
            return $scope.handleInitVideoModalFromPlaylistForPublic();
          });
          $scope.$on('Nav.ngPlaylists.hideDeleteOption', function() {
            return $scope.handleHideDeleteOption();
          });
          $scope.$on('Nav.ngPlaylists.showDeleteOption', function() {
            return $scope.handleShowDeleteOption();
          });
          $scope.$on('TvInput.ngPlaylists.showCreateModal', function() {
            return $scope.handleShowCreateModal();
          });
          $scope.$on('TvInput.ngPlaylists.showDeleteModal', function() {
            return $scope.handleShowDeleteModal();
          });
          $scope.$on('ngPlaylistCreateModal.ngPlaylists.shiftFocusToTopNav', function() {
            return $scope.handleShiftFocusToTopNav();
          });
          $scope.$on('ngPlaylistDeleteModal.ngPlaylists.shiftFocusToTopNav', function() {
            return $scope.handleShiftFocusToTopNav();
          });
          $scope.$on('TvInput.ngPlaylists.shiftFocusToTopNav', function() {
            return $scope.handleShiftFocusToTopNav();
          });
          $scope.$on('ngPlaylistCreateModal.ngPlaylists.refocusOnSelected', function() {
            return $scope.handleRefocusOnSelected();
          });
          $scope.$on('ngPlaylistDeleteModal.ngPlaylists.deletedPlaylist', function() {
            return $scope.handleDeletedPlaylist();
          });
          $scope.$on('ngPlaylistCreateModal.ngPlaylists.reloadViewForUser', function() {
            return $scope.handleReloadViewForUser();
          });
          return $scope.$on('$destroy', function() {});
        },
        link: function(scope, el, attrs) {
          var footerViewEl, viewEl,
            _this = this;

          viewEl = el.find('#playlists-view');
          footerViewEl = el.find('.footer-view:first');
          scope.handleInit = function() {
            if ($rootScope.storage.username) {
              return scope.showUserPlaylists();
            } else {
              return scope.showPublicPlaylist();
            }
          };
          scope.handleUserLoggedIn = function() {
            return Playlists.fetchUserPlaylists(function() {
              return scope.showUserPlaylists();
            });
          };
          scope.handleUserLoggedOut = function() {
            return scope.showPublicPlaylist();
          };
          scope.showPublicPlaylist = function() {
            var playlistArr, publicPlaylist;

            playlistArr = [];
            publicPlaylist = Playlists.getPublicPlaylist();
            playlistArr.push(publicPlaylist);
            return $timeout(function() {
              return scope.playlistArr = playlistArr;
            });
          };
          scope.showUserPlaylists = function() {
            var userPlaylists;

            userPlaylists = Playlists.getUserPlaylists();
            return $timeout(function() {
              return scope.playlistArr = userPlaylists;
            });
          };
          scope.handleNavigateDown = function() {
            var top;

            top = Number(viewEl.attr('data-top')) - 347;
            viewEl.attr('data-top', top);
            return viewEl.animate({
              top: top
            });
          };
          scope.handleNavigateUp = function() {
            var top;

            top = Number(viewEl.attr('data-top')) + 347;
            viewEl.attr('data-top', top);
            return viewEl.animate({
              top: top
            });
          };
          scope.handleReloadViewForUser = function() {
            var playlistArr;

            playlistArr = Playlists.getUserPlaylists();
            return $timeout(function() {
              return scope.playlistArr = playlistArr;
            });
          };
          scope.handleInitVideoModalFromPlaylistForUser = function(data) {
            var playlistId;

            playlistId = data.playlistId;
            return API.playlists.getSinglePlaylist({
              playlistId: playlistId
            }, function(data) {
              var videosArr;

              videosArr = data.videos;
              if (!videosArr.length) {
                return;
              }
              Playlists.setCurPlaylistVideos(videosArr);
              return $timeout(function() {
                return $rootScope.modal = 'video';
              });
            });
          };
          scope.handleInitVideoModalFromPlaylistForPublic = function() {
            var storageData, videosArr;

            storageData = Storage.get();
            videosArr = storageData.publicPlaylist.videos;
            if (!videosArr.length) {
              return;
            }
            Playlists.setCurPlaylistVideos(videosArr);
            return $timeout(function() {
              return $rootScope.modal = 'video';
            });
          };
          scope.handleHideDeleteOption = function() {
            Playlists.setIsFocusOnPlaylist(false);
            return $timeout(function() {
              return scope.displayDeleteOption = false;
            });
          };
          scope.handleShowDeleteOption = function() {
            Playlists.setIsFocusOnPlaylist(true);
            return $timeout(function() {
              return scope.displayDeleteOption = true;
            });
          };
          scope.handleShowCreateModal = function() {
            return $rootScope.$apply(function() {
              return $rootScope.subModal = 'playlistCreate';
            });
          };
          scope.handleShowDeleteModal = function() {
            var itemEl;

            itemEl = el.find('.nav-current-item-focus:first');
            Playlists.playlistIdToDelete = itemEl.attr('data-playlist-id');
            Playlists.playlistNameToDelete = itemEl.attr('data-playlist-title');
            return $rootScope.$apply(function() {
              return $rootScope.subModal = 'playlistDelete';
            });
          };
          scope.handleShiftFocusToTopNav = function() {
            var focusItemEl;

            el.find('.nav-current-item-focus:first').removeClass('nav-current-item-focus');
            focusItemEl = angular.element('#nav-top .nav-current-item-focus:first');
            if (!focusItemEl.size()) {
              focusItemEl = angular.element('#nav-top .nav-current-item-selected:first');
            }
            focusItemEl.addClass('nav-current-item-focus');
            Nav.curNavFocusItemEl = focusItemEl;
            Nav.curNavZone = 'nav-top';
            viewEl.attr('data-top', 0);
            viewEl.animate({
              top: 0
            });
            return scope.handleHideDeleteOption();
          };
          scope.handleRefocusOnSelected = function() {
            var focusItemEl;

            focusItemEl = el.find('.nav-current-item-focus:first');
            Nav.curNavFocusItemEl = focusItemEl;
            return Nav.curNavZone = focusItemEl.parent().attr('id');
          };
          return scope.handleDeletedPlaylist = function() {
            var arr, newPlaylistArr, playlist, playlistId, _i, _len;

            arr = scope.playlistArr;
            newPlaylistArr = [];
            playlistId = Playlists.playlistIdToDelete;
            for (_i = 0, _len = arr.length; _i < _len; _i++) {
              playlist = arr[_i];
              if (playlist.playlist_id !== playlistId) {
                newPlaylistArr.push(playlist);
              }
            }
            $timeout(function() {
              return scope.playlistArr = newPlaylistArr;
            });
            return scope.handleHideDeleteOption();
          };
        }
      };
    }
  ]);

}).call(this);
