// Generated by CoffeeScript 1.6.2
(function() {
  'use strict';  vevo.directive('ngSearch', [
    '$rootScope', '$timeout', 'UI', 'Nav', 'API', 'ComScore', function($rootScope, $timeout, UI, Nav, API, ComScore) {
      return {
        restrict: 'A',
        scope: true,
        controller: function($scope) {
          var _this = this;

          $scope.init = function() {
            return $timeout(function() {
              return $scope.handleInit();
            });
          };
          $scope.$on('TvInput.ngSearch.focusInSearchBox', function() {
            return $scope.handleFocusInSearchBox();
          });
          $scope.$on('app.updateNavZone', function() {
            return $scope.handleUpdateNavZone();
          });
          $scope.$on('Nav.ngSearch.updateSectionFocus', function(e, data) {
            return $scope.handleUpdateSectionFocus(data);
          });
          $scope.$on('TvInput.ngSearch.handleReturnKeyOnSearchView', function() {
            return $scope.handleReturnKeyOnSearchView();
          });
          $scope.$on('Nav.ngSearch.handleReturnKeyOnSearchView', function() {
            return $scope.handleReturnKeyOnSearchView();
          });
          $scope.$on('ngKeypad.ngSearch.updateKeypadStr', function(e, data) {
            return $scope.handleUpdateKeypadStr(data);
          });
          $scope.$on('ngPlaylistCreateModal.ngSearch.refocusOnSelected', function() {
            return $scope.handleRefocusOnSelected();
          });
          $scope.$on('TvInput.ngSearch.comScoreTrackSearch', function(e, data) {
            return $scope.handleComScoreTrackSearch(data);
          });
          return $scope.$on('$destroy', function() {
            return $scope.handleDestroy();
          });
        },
        link: function(scope, el, attrs) {
          var searchCursorEl, searchMode, topNavEl, topNavViewEl, viewEl, _cursorInterval, _keypadStr, _totalSearchedArtist, _totalSearchedVideo,
            _this = this;

          scope.removeElementToAllowMoreKeypad = false;
          scope.initHide = true;
          scope.artistArr = [];
          scope.videoArr = [];
          scope.search = '';
          scope.isHideSearchField = false;
          _totalSearchedArtist = 0;
          _totalSearchedVideo = 0;
          _keypadStr = '';
          topNavViewEl = $('#top-nav-view');
          topNavEl = $('#nav-top');
          searchCursorEl = $('#search-cursor');
          _cursorInterval = '';
          searchMode = true;
          viewEl = el.find('#search-view');
          scope.handleInit = function() {
            return $timeout(function() {
              return scope.handleFocusInSearchBox();
            });
          };
          scope.handleFocusInSearchBox = function() {
            if (scope.removeElementToAllowMoreKeypad) {
              $timeout(function() {
                return scope.removeElementToAllowMoreKeypad = false;
              });
            }
            $timeout(function() {
              el.find('.keypad-box').animate({
                opacity: 1
              });
              return scope.isHideSearchField = false;
            });
            UI.animateOut(topNavViewEl);
            searchMode = true;
            Nav.curNavZone = 'nav-keypad';
            $timeout(function() {
              return $rootScope.$broadcast('app.updateNavZone');
            });
            Nav.curNavFocusItemEl.removeClass('nav-current-item-focus');
            _cursorInterval = setInterval(function() {
              return searchCursorEl.animate({
                opacity: 0
              }, function() {
                return searchCursorEl.animate({
                  opacity: 1
                });
              });
            }, 1000);
            return scope.$broadcast('ngSearch.ngKeypad.reopen');
          };
          scope.handleFocusOutSearchBox = function() {
            var newCurNavFocusEl;

            $timeout(function() {
              return scope.removeElementToAllowMoreKeypad = true;
            });
            UI.animateIn(topNavViewEl);
            Nav.curNavZone = 'nav-top';
            $timeout(function() {
              $rootScope.$broadcast('app.updateNavZone');
              return scope.isHideSearchField = true;
            });
            Nav.curNavFocusItemEl.removeClass('nav-current-item-focus');
            topNavViewEl.find('.nav-item').removeClass('nav-current-item-focus').removeClass('nav-current-item-selected');
            newCurNavFocusEl = topNavViewEl.find('.search-nav-item');
            newCurNavFocusEl.addClass('nav-current-item-focus');
            newCurNavFocusEl.addClass('nav-current-item-selected');
            Nav.curNavFocusItemEl = newCurNavFocusEl;
            $rootScope.$broadcast('ngSearch.ngKeypad.animateOut');
            return clearInterval(_cursorInterval);
          };
          scope.handleUpdateNavZone = function() {
            return scope.$apply(function() {
              return scope.curNavZone = Nav.curNavZone;
            });
          };
          scope.handleUpdateSectionFocus = function(data) {
            return scope.$apply(function() {
              return scope.sectionFocus = data.list;
            });
          };
          scope.handleReturnKeyOnSearchView = function() {
            if (searchMode) {
              searchMode = false;
            } else {
              viewEl.attr('data-top', 0);
              viewEl.animate({
                top: 0
              });
            }
            return scope.handleFocusOutSearchBox();
          };
          scope.handleUpdateKeypadStr = function(data) {
            var action, char, isMaxStr;

            action = data.action;
            isMaxStr = scope.search.length >= 19;
            if (isMaxStr && (action === 'add' || action === 'space')) {
              return;
            }
            switch (action) {
              case 'add':
                char = data.char;
                _keypadStr += char;
                break;
              case 'space':
                _keypadStr += ' ';
                break;
              case 'delete':
                _keypadStr = _keypadStr.substring(0, _keypadStr.length - 1);
                break;
              case 'clear':
                _keypadStr = '';
            }
            return scope.$apply(function() {
              return scope.search = _keypadStr;
            });
          };
          scope.handleRefocusOnSelected = function() {
            var focusItemEl;

            focusItemEl = el.find('.nav-current-item-focus:first');
            Nav.curNavFocusItemEl = focusItemEl;
            return Nav.curNavZone = focusItemEl.parent().attr('id');
          };
          scope.handleComScoreTrackSearch = function(data) {
            var search;

            search = scope.search;
            if (!search) {
              return;
            }
            return ComScore.trackSearch({
              ns_search_term: search,
              search_value: data.name,
              search_num_artist: _totalSearchedArtist,
              search_num_video: _totalSearchedVideo
            });
          };
          scope.$watch('search', function(newVal, oldVal) {
            if (newVal.length < 3) {
              newVal = '';
            }
            return API.search.getSearchResult({
              query: newVal
            }, function(data) {
              var artistArr, artistRowEl, searchRowEl, videoArr, videoRowEl;

              artistArr = data.Artists;
              videoArr = data.Videos;
              _totalSearchedArtist = artistArr.length;
              _totalSearchedVideo = videoArr.length;
              artistArr = artistArr.slice(0, 9);
              videoArr = videoArr.slice(0, 9);
              searchRowEl = el.find('.search-row');
              artistRowEl = $('#nav-search-artist');
              videoRowEl = $('#nav-search-video');
              if (!artistArr.length && !videoArr.length) {
                $rootScope.topNavLeaveDownSearch = '';
                scope.artistArr = artistArr;
                scope.videoArr = videoArr;
              } else if (artistArr.length && videoArr.length) {
                $rootScope.topNavLeaveDownSearch = 'nav-search-artist';
                scope.artistRowIndex = '0';
                scope.videoRowIndex = '1';
                scope.artistLeaveDown = 'nav-search-video';
                scope.videoLeaveUp = 'nav-search-artist';
                scope.artistArr = artistArr;
                scope.videoArr = videoArr;
              } else if (artistArr.length) {
                $rootScope.topNavLeaveDownSearch = 'nav-search-artist';
                scope.artistRowIndex = '0';
                scope.videoRowIndex = '';
                scope.artistLeaveDown = 'nav-search-video';
                scope.artistArr = artistArr;
                scope.videoArr = videoArr;
              } else if (videoArr.length) {
                $rootScope.topNavLeaveDownSearch = 'nav-search-video';
                scope.artistRowIndex = '';
                scope.videoRowIndex = 0;
                scope.artistLeaveDown = '';
                scope.videoLeaveUp = 'nav-top';
                scope.artistArr = artistArr;
                scope.videoArr = videoArr;
              }
              return scope.initHide = false;
            });
          });
          return scope.handleDestroy = function() {
            var search;

            clearInterval(_cursorInterval);
            search = scope.search;
            if (!search) {
              return;
            }
            return ComScore.trackSearch({
              search_failure: search
            });
          };
        }
      };
    }
  ]);

}).call(this);
