'use strict'

vevo.directive 'ngSearchSlider', ['$rootScope', ($rootScope) ->

    restrict: 'A'
    scope: true

    controller: ($scope) ->

        $scope.$on 'Nav.ngSearchSlider.initSearchSlider', (e, data) =>
            $scope.handleInitSearchSlider(data)

        $scope.$on 'Nav.ngSearchSlider.searchBrowseNext', (e, data) =>
            $scope.handleSearchBrowseNext(data)

        $scope.$on 'Nav.ngSearchSlider.searchBrowsePrev', (e, data) =>
            $scope.handleSearchBrowsePrev(data)

    link: (scope, el, attrs) ->

        curIndex = 0
        curIndexOnScreen = 0
        distance = 0
        viewEl = $('#search-view')

        scope.handleInitSearchSlider = (data) =>
            return if el.attr('data-list') isnt data.list

            curIndexOnScreen = data.curIndexOnScreen
            curIndex = curIndex + data.indexDiff

            if data.direction is 'down' and data.rowIndex isnt 0
                top = Number(viewEl.attr('data-top')) - 416
                viewEl.attr('data-top', top)
                viewEl.animate
                    top: top
            else if data.direction is 'up'
                top = Number(viewEl.attr('data-top')) + 416
                viewEl.attr('data-top', top)
                viewEl.animate
                    top: top


        scope.handleSearchBrowseNext = (data) =>
            return if el.attr('data-list') isnt data.list


            if curIndexOnScreen is 2
                distance -= 394
                el.animate
                    left: distance
            else
                curIndexOnScreen++

            curIndex++

            el.attr 'data-cur-index-on-screen', curIndexOnScreen
            el.attr 'data-cur-index', curIndex

        scope.handleSearchBrowsePrev = (data) =>
            return if el.attr('data-list') isnt data.list

            if curIndexOnScreen is 0
                distance += 394
                el.animate
                    left: distance
            else
                curIndexOnScreen--

            curIndex--
            el.attr 'data-cur-index-on-screen', curIndexOnScreen
            el.attr 'data-cur-index', curIndex



]
