// Generated by CoffeeScript 1.6.2
(function() {
  'use strict';  vevo.directive('ngVevoTv', [
    '$rootScope', '$timeout', 'Player', 'UI', 'App', 'Nav', 'Playlists', 'Util', 'ComScore', 'API', function($rootScope, $timeout, Player, UI, App, Nav, Playlists, Util, ComScore, API) {
      return {
        restrict: 'A',
        scope: true,
        controller: function($scope) {
          var _this = this;

          $scope.init = function() {
            return $timeout(function() {
              return $scope.handleInit();
            });
          };
          $scope.$on('TvInput.ngVevoTv.hideVevoTvElements', function() {
            return $scope.handleHideVevoTvElements();
          });
          $scope.$on('TvInput.ngVevoTv.showVevoTvElements', function() {
            return $scope.handleShowVevoTvElements();
          });
          $scope.$on('TvInput.ngVevoTv.resetFullScreenTimer', function() {
            return $scope.handleResetFullScreenTimer();
          });
          $scope.$on('app.updateNavZone', function() {
            return $scope.handleUpdateNavZone();
          });
          $scope.$on('Player.ngVevoTv.pausedVevoTv', function() {
            return $scope.handlePausedVevoTv();
          });
          $scope.$on('Player.ngVevoTv.playedVevoTv', function() {
            return $scope.handlePlayedVevoTv();
          });
          $scope.$on('Player.ngVevoTv.playedVevoTvAd', function() {
            return $scope.handlePlayedVevoTvAd();
          });
          $scope.$broadcast('FreeWheel.ngVevoTv.playedVevoTvAfterAd', function() {
            return $scope.handlePlayedVevoTvAfterAd();
          });
          $scope.$on('TvInput.ngVevotv.addToPlaylist', function() {
            return $scope.handleAddToPlaylist();
          });
          return $scope.$on('$destroy', function() {
            return $scope.handleDestroy();
          });
        },
        link: function(scope, el, attrs) {
          var _adCounterEl, _darkBackgroundEl, _footerViewEl, _getMetadata, _getSchedule, _handleCancelSetTimeout, _handleNewIsrc, _hideControls, _hideDarkBackground, _hideMetadata, _hideSchedule, _isInitLoad, _metadataEl, _metadataTimeout, _navScheduleEl, _resetSetTimeout, _showAdTimer, _showControls, _showDarkBackground, _showMetadata, _showSchedule, _timeout, _vevoTvScheduleOnDisplay,
            _this = this;

          _timeout = '';
          _darkBackgroundEl = el.find('.dark-background');
          _metadataEl = el.find('#tv-metadata');
          _footerViewEl = el.find('.footer-view');
          _navScheduleEl = el.find('#nav-schedule');
          _adCounterEl = el.find('.ad-counter');
          _vevoTvScheduleOnDisplay = false;
          _isInitLoad = true;
          _metadataTimeout = '';
          scope.schedules = [];
          scope.actionClass = 'pause';
          scope.handleInit = function() {
            ComScore.initStreamSensePlaylistForVevoTv();
            $rootScope.loading = $rootScope.strings.loadingVevoTv;
            $rootScope.loadingType = 'vevotv';
            Player.play();
            scope.handleResetFullScreenTimer();
            return App.VevoTv.isFullScreenMode = true;
          };
          _resetSetTimeout = function() {
            _handleCancelSetTimeout();
            return _timeout = $timeout(function() {
              return scope.handleHideVevoTvElements();
            }, 7000);
          };
          _handleCancelSetTimeout = function() {
            return $timeout.cancel(_timeout);
          };
          _resetSetTimeout();
          scope.handleHideVevoTvElements = function() {
            _hideMetadata();
            _hideControls();
            _hideSchedule();
            _hideDarkBackground();
            $rootScope.$broadcast('ngVevoTv.ngTopNav.hideTopNav');
            App.VevoTv.vevoTvInfoDisplayed = false;
            return App.VevoTv.isFullScreenMode = true;
          };
          scope.handleShowVevoTvElements = function() {
            _showMetadata();
            _showControls();
            _showSchedule();
            _showDarkBackground();
            $rootScope.$broadcast('ngVevoTv.ngTopNav.showTopNav');
            _resetSetTimeout();
            App.VevoTv.vevoTvInfoDisplayed = true;
            return App.VevoTv.isFullScreenMode = false;
          };
          scope.handleResetFullScreenTimer = function() {
            return _resetSetTimeout();
          };
          scope.handleUpdateNavZone = function() {
            return scope.$apply(function() {
              return scope.curNavZone = Nav.curNavZone;
            });
          };
          _showMetadata = function() {
            var credit, creditArr, fullArtistName, videoData, _i, _len;

            videoData = App.VevoTv.metadata;
            if (!videoData) {
              return;
            }
            scope.artist = '';
            scope.title = '';
            scope.director = '';
            scope.explicit = '';
            fullArtistName = Util.getFullArtistName(videoData);
            scope.$apply(function() {
              scope.title = videoData.title;
              scope.artist = fullArtistName;
              return scope.explicit = videoData.explicit;
            });
            creditArr = videoData.credit;
            if (creditArr.length) {
              for (_i = 0, _len = creditArr.length; _i < _len; _i++) {
                credit = creditArr[_i];
                if (credit.Key === 'Director') {
                  scope.$apply(function() {
                    return scope.director = credit.Value;
                  });
                  break;
                }
              }
            }
            UI.animateIn(_metadataEl);
            return _metadataEl.css({
              'background-color': 'rgba(252,0,149,.7)'
            });
          };
          _showDarkBackground = function() {
            return;
            return UI.animateIn(_darkBackgroundEl);
          };
          _hideMetadata = function() {
            return UI.animateOut(_metadataEl);
          };
          _hideDarkBackground = function() {
            return UI.animateOut(_darkBackgroundEl);
          };
          _showControls = function() {
            return UI.animateIn(_footerViewEl, {
              opacity: 0.8
            });
          };
          _hideControls = function() {
            return UI.animateOut(_footerViewEl);
          };
          _showSchedule = function(arr) {
            var date, len, now, schedule, scheduleArr, _i, _len;

            return;
            arr = App.VevoTv.scheduleArr;
            len = arr.length;
            if (!len) {
              return;
            }
            if (!scope.schedules.length && !_vevoTvScheduleOnDisplay) {
              _vevoTvScheduleOnDisplay = true;
              scheduleArr = [];
              now = new Date();
              for (_i = 0, _len = arr.length; _i < _len; _i++) {
                schedule = arr[_i];
                date = new Date(schedule.starttime);
                if (date > now || date.getHours() === now.getHours()) {
                  scheduleArr.push(schedule);
                }
              }
              scope.$apply(function() {
                return scope.schedules = scheduleArr;
              });
            }
            return UI.animateIn(_navScheduleEl);
          };
          _hideSchedule = function() {
            return UI.animateOut(_navScheduleEl);
          };
          scope.handlePausedVevoTv = function() {
            return scope.$apply(function() {
              return scope.actionClass = 'play';
            });
          };
          scope.handlePlayedVevoTv = function() {
            scope.$apply(function() {
              return scope.actionClass = 'pause';
            });
            if (!_isInitLoad) {
              return;
            }
            _resetSetTimeout();
            _getSchedule();
            return _getMetadata();
          };
          _getSchedule = function() {
            return API.vevotv.getSchedule(function(data) {
              return App.VevoTv.scheduleArr = data;
            });
          };
          _handleNewIsrc = function(curVideoData) {
            var curIsrc;

            if (App.getView() !== 'vevotv') {
              return;
            }
            curIsrc = curVideoData.isrc;
            App.VevoTv.isrc = curIsrc;
            if (curIsrc === 'TIVEVSLATE00' && !_isInitLoad) {
              App.VevoTv.metadata = '';
              $rootScope.$broadcast('ngVevoTv.FreeWheel.initPlayVevoTvAd');
              return;
            }
            App.VevoTv.metadata = curVideoData;
            if (curIsrc !== 'TIVEVSLATE00') {
              ComScore.trackVevoTv({
                action: 'newClipPlay'
              });
              App.VevoTv.curClipStartTime = new Date();
            }
            return _getMetadata();
          };
          _getMetadata = function() {
            if (App.getView() !== 'vevotv') {
              return;
            }
            return API.vevotv.getMetadata(function(metadataArr) {
              var curVideoData, delay, firstObj, index, isLastItemInArray, nextVideoData, obj, startTime, tempVideoData, utc, _i, _len;

              if (!metadataArr.length) {
                return;
              }
              utc = new Date().getTime();
              utc = Math.floor(utc / 1000);
              tempVideoData = {};
              curVideoData = {};
              nextVideoData = {};
              startTime = '';
              firstObj = metadataArr[0];
              if (firstObj.StartTime === 0) {
                isLastItemInArray = true;
                curVideoData = metadataArr[metadataArr.length - 1];
                curVideoData = curVideoData.Video;
                startTime = 0;
              } else {
                for (index = _i = 0, _len = metadataArr.length; _i < _len; index = ++_i) {
                  obj = metadataArr[index];
                  if (index === (metadataArr.length - 1)) {
                    curVideoData = obj.Video;
                    isLastItemInArray = true;
                    startTime = obj.StartTime;
                    break;
                  } else if (utc < obj.StartTime) {
                    curVideoData = tempVideoData;
                    nextVideoData = metadataArr[index + 1];
                    isLastItemInArray = false;
                    break;
                  } else {
                    tempVideoData = obj.Video;
                  }
                }
              }
              if (App.VevoTv.isrc !== curVideoData.isrc) {
                delay = App.VevoTv.isrc ? 10000 : 0;
                $timeout(function() {
                  return _handleNewIsrc(curVideoData);
                }, delay);
                return;
              }
              _isInitLoad = false;
              if (isLastItemInArray) {
                return _metadataTimeout = $timeout(function() {
                  return _getMetadata();
                }, 6000);
              }
            });
          };
          scope.handlePlayedVevoTvAd = function() {
            $rootScope.$broadcast('ngVevoTv.ngTopNav.hideTopNav');
            _hideDarkBackground();
            return _showAdTimer();
          };
          scope.handlePlayedVevoTvAfterAd = function() {
            return _getMetadata();
          };
          _showAdTimer = function() {
            var _countDown;

            if (scope.counter) {
              return;
            }
            _countDown = function() {
              return $timeout(function() {
                scope.counter--;
                if (scope.counter > 0) {
                  return _countDown();
                } else {
                  UI.animateOut(_adCounterEl);
                  scope.counter = 0;
                  return $timeout(function() {
                    if (App.VevoTv.adInProgress) {
                      Player.clear();
                      App.VevoTv.adInProgress = false;
                      App.VevoTv.adPlayPosition = 0;
                      App.VevoTv.adArr = [];
                      Player.play();
                      return _getMetadata();
                    }
                  }, 4000);
                }
              }, 1000);
            };
            scope.counter = 32;
            _countDown();
            return UI.animateIn(_adCounterEl, {
              opacity: .5
            });
          };
          scope.handleAddToPlaylist = function() {
            var videoData;

            if (App.VevoTv.adInProgress) {
              return;
            }
            videoData = App.VevoTv.metadata;
            if ($rootScope.storage.username) {
              Playlists.addToUserSamsungPlaylist(videoData);
            } else {
              Playlists.addToPublicPlaylist(videoData);
            }
            scope.handleHideVevoTvElements();
            return ComScore.trackCustomEvent({
              vevotv_events: 'watch_later'
            });
          };
          return scope.handleDestroy = function() {
            clearInterval(Player.vevoTvFreeWheelInterval);
            _handleCancelSetTimeout();
            if (Player.state === Player.PLAYING || Player.state === Player.PAUSED) {
              Player.clear();
            }
            App.VevoTv.vevoTvInfoDisplayed = false;
            App.VevoTv.starttime = '';
            ComScore.endVevoTv();
            return $timeout.cancel(_metadataTimeout);
          };
        }
      };
    }
  ]);

}).call(this);
