// Generated by CoffeeScript 1.6.2
(function() {
  'use strict';  vevo.directive('ngVideoModal', [
    '$rootScope', '$timeout', 'Player', 'API', 'UI', 'App', 'Playlists', 'Util', 'ComScore', 'K', 'Storage', function($rootScope, $timeout, Player, API, UI, App, Playlists, Util, ComScore, K, Storage) {
      return {
        restrict: 'A',
        scope: true,
        controller: function($scope) {
          var _this = this;

          $scope.init = function() {
            return $timeout(function() {
              return $scope.handleInit();
            });
          };
          $scope.$on('TvInput.ngVideoModal.hideVideoElements', function() {
            return $scope.handleHideVideoElements();
          });
          $scope.$on('ngVideoModalBrowseSlider.ngVideoModal.hideVideoElements', function() {
            return $scope.handleHideVideoElements();
          });
          $scope.$on('ngVideoModalSearchSlider.ngVideoModal.hideVideoElements', function() {
            return $scope.handleHideVideoElements();
          });
          $scope.$on('ngVideoModalPlaylistSlider.ngVideoModal.hideVideoElements', function() {
            return $scope.handleHideVideoElements();
          });
          $scope.$on('ngPlaylistSelectModal.ngVideoModal.hideVideoElements', function() {
            return $scope.handleHideVideoElements();
          });
          $scope.$on('TvInput.ngVideoModal.showVideoElements', function() {
            return $scope.handleShowVideoElements();
          });
          $scope.$on('TvInput.ngVideoModal.resetFullScreenTimer', function() {
            return $scope.handleResetFullScreenTimer();
          });
          $scope.$on('Player.ngVideoModal.playedVideo', function() {
            return $scope.handlePlayedVideo();
          });
          $scope.$on('Player.ngVideoModal.playedVideoAd', function() {
            return $scope.handlePlayedVideoAd();
          });
          $scope.$on('Player.ngVideoModal.pausedVideo', function() {
            return $scope.handlePausedVideo();
          });
          $scope.$on('Player.ngVideoModal.updateProgressBar', function(e, data) {
            return $scope.handleUpdateProgressBar(data);
          });
          $scope.$on('TvInput.ngVideoModal.addToPlaylist', function() {
            return $scope.handleAddToPlaylist();
          });
          $scope.$on('Player.ngVideoModal.showTimeBar', function() {
            return $scope.handleShowTimeBar();
          });
          $scope.$on('ngVideoModalBrowseSlider.ngVideoModal.triggerPlayVideo', function() {
            return $scope.handleTriggerPlayVideo();
          });
          $scope.$on('ngVideoModalPlaylistSlider.ngVideoModal.triggerPlayVideo', function() {
            return $scope.handleTriggerPlayVideo();
          });
          $scope.$on('ngVideoModalSearchSlider.ngVideoModal.triggerPlayVideo', function() {
            return $scope.handleTriggerPlayVideo();
          });
          $scope.$on('FreeWheel.ngVideoModal.triggerPlayVideo', function() {
            return $scope.handleTriggerPlayVideo();
          });
          $scope.$on('ngConfirmExplicitModal.ngVideoModal.doneConfirmingExplicit', function() {
            return $scope.handleDoneConfirmingExplicit();
          });
          $scope.$on('$destroy', function() {
            return $scope.handleDestroy();
          });
          BL.onOverlayClose = function() {
            var remoteEl;

            remoteEl = document.getElementById('vevo-remote-key-handler');
            return remoteEl.focus();
          };
          BL.onMicrositeOpen = function() {
            return Player.clear();
          };
          return BL.onMicrositeClose = function() {
            var remoteEl;

            remoteEl = document.getElementById('vevo-remote-key-handler');
            remoteEl.focus();
            $rootScope.$broadcast('Player.FreeWheel.videoAdEnded');
            return $scope.handleTriggerPlayVideo();
          };
        },
        link: function(scope, el, attrs) {
          var _adCounterEl, _checkLoadingError, _checkVideoTimeout, _continuousPlayWrapEl, _darkBackgroundEl, _footerViewEl, _handleCancelSetTimeout, _handleDeepLinking, _handleTriggerPlayVideoForDeepLinking, _hideContinuousPlay, _hideControls, _hideDarkBackground, _hideMetadata, _playVideo, _playVideoAd, _resetSetTimeout, _showAdTimer, _showContinuousPlay, _showControls, _showDarkBackground, _showMetadata, _showPremiereTag, _timeout, _videoMetadataEl,
            _this = this;

          scope.actionClass = 'pause';
          _continuousPlayWrapEl = el.find('#continuous-play-wrap');
          _darkBackgroundEl = el.find('.dark-background:first');
          _footerViewEl = el.find('.footer-view');
          _videoMetadataEl = el.find('#video-metadata');
          _adCounterEl = el.find('.ad-counter');
          _timeout = '';
          _checkVideoTimeout = '';
          scope.handleInit = function() {
            var curPlaylistVideos, curView, section, showName, type;

            if (App.deepLinking) {
              return _handleDeepLinking();
            }
            curView = App.getView();
            App.VideoModal.isFullScreenMode = true;
            ComScore.initStreamSensePlaylistForVideo(curView);
            switch (curView) {
              case 'browse':
                section = $rootScope.app.videoModalType;
                if (section === 'genres') {
                  ComScore.trackCustomEvent({
                    browse_videos_events: $rootScope.app.videoModalGenreType
                  });
                }
                return API.video.getAllVideoOnDemandData(function(data) {
                  var streamData, videoData;

                  streamData = data.streamData;
                  videoData = data.videoData;
                  App.VideoModal.url = streamData.renditions[0].url;
                  App.VideoModal.data = videoData;
                  scope.handleTriggerPlayVideo();
                  return $timeout(function() {
                    return $rootScope.$broadcast('ngVideoModal.ngVideoModalBrowseSlider.initSlider', videoData);
                  }, 2000);
                });
              case 'browseShow':
                showName = $rootScope.app.videoModalShowName;
                showName = showName.split(' ').join('_').toLowerCase();
                ComScore.trackCustomEvent({
                  browse_shows_events: showName
                });
                return API.video.getAllVideoOnDemandData(function(data) {
                  var streamData, videoData;

                  streamData = data.streamData;
                  videoData = data.videoData;
                  App.VideoModal.url = streamData.renditions[0].url;
                  App.VideoModal.data = videoData;
                  scope.handleTriggerPlayVideo();
                  return $timeout(function() {
                    return $rootScope.$broadcast('ngVideoModal.ngVideoModalBrowseSlider.initSlider', videoData);
                  }, 2000);
                });
              case 'search':
                type = App.VideoModal.searchType;
                if (type === 'artist') {
                  return API.video.getArtistVideosData(function(data) {
                    var arr, firstVideoData, streamData, videoData;

                    if (data.success === false) {
                      scope.$broadcast('ngVideoModal.ngConfirmMessage.videoError');
                      return;
                    }
                    streamData = data.streamData;
                    videoData = data.videoData;
                    firstVideoData = videoData[0];
                    App.VideoModal.isrc = firstVideoData.isrc;
                    arr = streamData.renditions;
                    App.VideoModal.renditionsArr = arr;
                    App.VideoModal.renditionsIndex = 0;
                    App.VideoModal.url = arr[0].url;
                    App.VideoModal.data = firstVideoData;
                    scope.handleTriggerPlayVideo();
                    return $timeout(function() {
                      return $rootScope.$broadcast('ngVideoModal.ngVideoModalSearchSlider.initSlider', videoData);
                    }, 2000);
                  });
                } else if (type === 'video') {
                  return API.video.getAllVideoOnDemandData(function(data) {
                    var arr, streamData, videoData;

                    streamData = data.streamData;
                    videoData = data.videoData;
                    arr = streamData.renditions;
                    App.VideoModal.renditionsArr = arr;
                    App.VideoModal.renditionsIndex = 0;
                    App.VideoModal.url = arr[0].url;
                    App.VideoModal.data = videoData;
                    scope.handleTriggerPlayVideo();
                    return $timeout(function() {
                      return $rootScope.$broadcast('ngVideoModal.ngVideoModalSearchSlider.initSlider', videoData);
                    }, 2000);
                  });
                }
                break;
              case 'playlists':
                curPlaylistVideos = Playlists.getCurPlaylistVideos();
                App.VideoModal.isrc = curPlaylistVideos[0].isrc;
                return API.video.getAllVideoOnDemandData(function(data) {
                  var streamData, videoData;

                  streamData = data.streamData;
                  videoData = data.videoData;
                  App.VideoModal.url = streamData.renditions[0].url;
                  App.VideoModal.data = videoData;
                  scope.handleTriggerPlayVideo();
                  return $timeout(function() {
                    return $rootScope.$broadcast('ngVideoModal.ngVideoModalPlaylistSlider.initSlider', curPlaylistVideos);
                  }, 2000);
                });
            }
          };
          _handleDeepLinking = function() {
            var _this = this;

            App.VideoModal.isrc = App.deepLinking;
            return API.video.getAllVideoOnDemandData(function(data) {
              var streamData, videoData;

              streamData = data.streamData;
              videoData = data.videoData;
              App.VideoModal.url = streamData.renditions[0].url;
              App.VideoModal.data = videoData;
              return scope.handleTriggerPlayVideo();
            });
          };
          scope.handleTriggerPlayVideo = function() {
            var params;

            if (App.deepLinking) {
              _handleTriggerPlayVideoForDeepLinking();
              return;
            }
            if (App.VideoModal.adCounter === 5) {
              App.VideoModal.adCounter = 0;
              params = {
                isrc: App.VideoModal.isrc
              };
              return API.freeWheel.getVideoFreeWheel(params, function(data) {
                var adArr, json, _ref;

                json = window.X2JS.xml_str2json(data);
                adArr = json != null ? (_ref = json.VAST) != null ? _ref.Ad_asArray : void 0 : void 0;
                App.VideoModal.adArr = adArr;
                if (adArr && adArr.length) {
                  return _playVideoAd();
                } else {
                  return _playVideo();
                }
              });
            } else {
              App.VideoModal.adCounter++;
              BL.close();
              return _playVideo();
            }
          };
          _handleTriggerPlayVideoForDeepLinking = function() {
            var arr, params, playAd, rand;

            arr = [true, true, false];
            rand = Math.floor(Math.random() * 10) % 3;
            playAd = arr[rand];
            if (playAd && !App.playingAdForDeepLinking) {
              App.playingAdForDeepLinking = true;
              App.VideoModal.adCounter = 0;
              params = {
                isrc: App.VideoModal.isrc
              };
              return API.freeWheel.getVideoFreeWheel(params, function(data) {
                var adArr, json, _ref;

                json = window.X2JS.xml_str2json(data);
                adArr = json != null ? (_ref = json.VAST) != null ? _ref.Ad_asArray : void 0 : void 0;
                App.VideoModal.adArr = adArr;
                if (adArr && adArr.length) {
                  return _playVideoAd();
                } else {
                  return _playVideo();
                }
              });
            } else {
              App.playingAdForDeepLinking = false;
              return _playVideo();
            }
          };
          _playVideoAd = function() {
            var ad, creative, creatives, index, parseCreative, _i, _len, _results;

            index = App.VideoModal.adPlayPosition;
            ad = App.VideoModal.adArr[index];
            creatives = ad.InLine.Creatives.Creative_asArray;
            parseCreative = function(creative) {
              var curVideoTime, htmlResource, mediaFile, _ref, _ref1, _ref2, _ref3, _ref4, _ref5;

              mediaFile = (creative != null ? (_ref = creative.Linear) != null ? (_ref1 = _ref.MediaFiles) != null ? (_ref2 = _ref1.MediaFile) != null ? _ref2.__cdata : void 0 : void 0 : void 0 : void 0);
              htmlResource = (creative != null ? (_ref3 = creative.CompanionAds) != null ? (_ref4 = _ref3.Companion) != null ? (_ref5 = _ref4.HTMLResource) != null ? _ref5.__cdata : void 0 : void 0 : void 0 : void 0);
              if (mediaFile) {
                App.VideoModal.adInProgress = true;
                curVideoTime = Player.getCurVideoTime();
                ComScore.trackVideo({
                  action: 'newAdClipPlay',
                  curVideoTime: curVideoTime
                });
                return Player.playAd(mediaFile);
              } else if (htmlResource) {
                return BL.openOverlay(htmlResource);
              }
            };
            _results = [];
            for (_i = 0, _len = creatives.length; _i < _len; _i++) {
              creative = creatives[_i];
              _results.push(parseCreative(creative));
            }
            return _results;
          };
          _playVideo = function() {
            var ga_view;

            ga_view = '/video/' + App.VideoModal.isrc + '-' + App.VideoModal.data.url_safe_title;
            _gaq.push(['_trackPageview', ga_view]);
            return API.video.getVideoStreamData({
              isrc: App.VideoModal.isrc
            }, function(data) {
              var isExplicit, storageData, url, videoData;

              url = data.url;
              url = url.split('?');
              url = url[0];
              if (/m3u8$/.test(url)) {
                url = url + K.Stream.hlsFullSuffix;
              }
              App.VideoModal.url = url;
              Player.clear();
              videoData = App.VideoModal.data;
              isExplicit = videoData.explicit;
              storageData = Storage.get();
              if (isExplicit && !storageData.confirmExplicit) {
                $timeout(function() {
                  return $rootScope.subModal = 'confirmExplicit';
                });
                return;
              }
              $rootScope.loading = $rootScope.strings.loading;
              ComScore.trackVideo({
                action: 'newClipPlay',
                curVideoTime: 0
              });
              Player.play();
              return _checkLoadingError();
            });
          };
          scope.handleDoneConfirmingExplicit = function() {
            $rootScope.loading = $rootScope.strings.loading;
            ComScore.trackVideo({
              action: 'newClipPlay',
              curVideoTime: 0
            });
            Player.play();
            return _checkLoadingError();
          };
          _checkLoadingError = function() {
            return _checkVideoTimeout = $timeout(function() {
              if ($rootScope.loading) {
                $rootScope.loading = false;
                return scope.$broadcast('ngVideoModal.ngConfirmMessage.videoError');
              }
            }, 10000);
          };
          _resetSetTimeout = function() {
            _handleCancelSetTimeout();
            return _timeout = $timeout(function() {
              return scope.handleHideVideoElements();
            }, 7000);
          };
          _handleCancelSetTimeout = function() {
            return $timeout.cancel(_timeout);
          };
          scope.handleHideVideoElements = function() {
            _hideMetadata();
            _hideControls();
            _hideContinuousPlay();
            _hideDarkBackground();
            App.VideoModal.videoInfoDisplayed = false;
            return App.VideoModal.isFullScreenMode = true;
          };
          scope.handleShowVideoElements = function() {
            var videoSection;

            _showMetadata();
            _showControls();
            videoSection = $rootScope.app.videoModalType;
            _showContinuousPlay();
            _showDarkBackground();
            _resetSetTimeout();
            App.VideoModal.videoInfoDisplayed = true;
            return App.VideoModal.isFullScreenMode = false;
          };
          scope.handleShowTimeBar = function() {
            _showMetadata();
            return _showControls();
          };
          scope.handleResetFullScreenTimer = function() {
            return _resetSetTimeout();
          };
          scope.handlePlayedVideo = function() {
            var isPremiere, totalMinute, totalSecond, totalTime, totalTimeStr, videoData;

            _resetSetTimeout();
            $timeout.cancel(_checkVideoTimeout);
            totalTime = App.VideoModal.totalTime;
            videoData = App.VideoModal.data;
            totalMinute = Math.floor(totalTime / 60);
            totalSecond = Math.floor(totalTime % 60);
            totalTimeStr = totalMinute + ':';
            if (totalSecond === 0) {
              totalTimeStr += '00';
            } else if (totalSecond < 10) {
              totalTimeStr += '0' + totalSecond;
            } else {
              totalTimeStr += totalSecond;
            }
            isPremiere = videoData.premiere;
            if (isPremiere) {
              _showPremiereTag();
            }
            scope.$apply(function() {
              scope.actionClass = 'pause';
              scope.totalTimeStr = '/' + totalTimeStr;
              scope.curTimeStr = '0:00';
              return scope.explicit = videoData.explicit;
            });
            API.video.callSuperBeacon();
            return ComScore.trackPageView({
              view: 'VOD'
            });
          };
          scope.handlePlayedVideoAd = function() {
            _hideDarkBackground();
            return _showAdTimer();
          };
          _showPremiereTag = function() {
            var premiereTagEl;

            premiereTagEl = el.find('.premiere-tag:first');
            premiereTagEl.css({
              opacity: 1
            });
            return $timeout(function() {
              return UI.animateOut(premiereTagEl);
            }, 4000);
          };
          _showAdTimer = function() {
            var ad, duration, index, info, _countDown;

            index = App.VideoModal.adPlayPosition;
            ad = App.VideoModal.adArr[index];
            info = ad.InLine.Creatives.Creative.Linear;
            duration = info.Duration;
            _countDown = function() {
              return $timeout(function() {
                scope.counter--;
                if (scope.counter > 0) {
                  return _countDown();
                } else {
                  return UI.animateOut(_adCounterEl);
                }
              }, 1000);
            };
            if (duration === '00:00:30') {
              scope.counter = 30;
            } else {
              scope.counter = 15;
            }
            _countDown();
            return UI.animateIn(_adCounterEl, {
              opacity: .5
            });
          };
          _showMetadata = function() {
            var credit, creditArr, fullArtistName, videoData, _i, _len;

            videoData = App.VideoModal.data;
            fullArtistName = Util.getFullArtistName(videoData);
            scope.$apply(function() {
              scope.title = videoData.title;
              return scope.artist = fullArtistName;
            });
            creditArr = videoData.credit;
            if (creditArr != null ? creditArr.length : void 0) {
              for (_i = 0, _len = creditArr.length; _i < _len; _i++) {
                credit = creditArr[_i];
                if (credit.Key === 'Director') {
                  scope.director = credit.Value;
                  break;
                }
              }
            }
            UI.animateIn(_videoMetadataEl);
            return _videoMetadataEl.css({
              'background-color': 'rgba(252,0,149,.7)'
            });
          };
          _hideMetadata = function() {
            return UI.animateOut(_videoMetadataEl, {
              speed: 'slow'
            });
          };
          _showControls = function() {
            return UI.animateIn(_footerViewEl);
          };
          _hideControls = function() {
            return UI.animateOut(_footerViewEl, {
              speed: 'slow'
            });
          };
          _showContinuousPlay = function() {
            return UI.animateIn(_continuousPlayWrapEl);
          };
          _showDarkBackground = function() {
            return UI.animateIn(_darkBackgroundEl);
          };
          _hideContinuousPlay = function() {
            return UI.animateOut(_continuousPlayWrapEl, {
              speed: 'slow'
            });
          };
          _hideDarkBackground = function() {
            return UI.animateOut(_darkBackgroundEl, {
              speed: 'slow'
            });
          };
          scope.handlePausedVideo = function() {
            return scope.$apply(function() {
              return scope.actionClass = 'play';
            });
          };
          scope.handleUpdateProgressBar = function(data) {
            var curMinute, curSecond, curTimeStr, time, timePercent;

            time = data.time;
            timePercent = (100 * time) / App.VideoModal.totalTime;
            curMinute = Math.floor(time / 60);
            curSecond = Math.floor(time % 60);
            curTimeStr = curMinute + ':';
            if (curSecond === 0) {
              curTimeStr += '00';
            } else if (curSecond < 10) {
              curTimeStr += '0' + curSecond;
            } else {
              curTimeStr += curSecond;
            }
            return scope.$apply(function() {
              scope.progressBarPercent = timePercent + '%';
              return scope.curTimeStr = curTimeStr;
            });
          };
          scope.handleAddToPlaylist = function() {
            if (App.VideoModal.adInProgress) {
              return;
            }
            if (App.VideoModal.isFullScreenMode) {
              App.VideoModal.isAddCurPlayingVideoToPlaylist = true;
            } else {
              App.VideoModal.isAddCurPlayingVideoToPlaylist = false;
            }
            if ($rootScope.storage.username) {
              return $timeout(function() {
                return $rootScope.subModal = "playlistSelect";
              });
            } else {
              Playlists.addToPublicPlaylist();
              scope.handleHideVideoElements();
              return ComScore.trackCustomEvent({
                watch_page_events: 'add_to_playlist'
              });
            }
          };
          return scope.handleDestroy = function() {
            App.VideoModal.isFullScreenMode = false;
            App.VideoModal.videoBrowseType = '';
            _handleCancelSetTimeout();
            $timeout.cancel(_checkVideoTimeout);
            Player.clear();
            return ComScore.endVideoPlay();
          };
        }
      };
    }
  ]);

}).call(this);
