// Generated by CoffeeScript 1.6.2
(function() {
  'use strict';  vevo.directive('ngVideoModalBrowseSlider', [
    '$rootScope', '$timeout', 'API', 'Player', 'App', function($rootScope, $timeout, API, Player, App) {
      return {
        restrict: 'A',
        scope: true,
        controller: function($scope) {
          var _this = this;

          $scope.$on('ngVideoModal.ngVideoModalBrowseSlider.initSlider', function() {
            return $scope.handleInitSlider();
          });
          $scope.$on('TvInput.ngVideoModalBrowseSlider.moveSlider', function(e, data) {
            return $scope.handleMoveSlider(data);
          });
          $scope.$on('TvInput.ngVideoModalBrowseSlider.autoPlayPrev', function() {
            return $scope.handleAutoPlayPrev();
          });
          $scope.$on('Player.ngVideoModalBrowseSlider.autoPlayPrev', function() {
            return $scope.handleAutoPlayPrev();
          });
          $scope.$on('TvInput.ngVideoModalBrowseSlider.autoPlayNext', function() {
            return $scope.handleAutoPlayNext();
          });
          $scope.$on('Player.ngVideoModalBrowseSlider.autoPlayNext', function() {
            return $scope.handleAutoPlayNext();
          });
          $scope.$on('ngConfirmMessage.ngVideoModalBrowseSlider.autoPlayNext', function() {
            return $scope.handleAutoPlayNext();
          });
          $scope.$on('ngConfirmExplicitModal.ngVideoModalBrowseSlider.autoPlayNext', function() {
            return $scope.handleAutoPlayNext();
          });
          $scope.$on('TvInput.ngVideoModalBrowseSlider.selectVideoToPlay', function() {
            return $scope.handleSelectVideoToPlay();
          });
          return $scope.$on('ngBrowse.ngVideoModalBrowseSlider.updateShowsList', function() {
            return $scope.handleUpdateShowsList();
          });
        },
        link: function(scope, el, attrs) {
          var _browseNext, _browsePrev, _curFocusEl, _curFocusIndex, _curIndexOnScreen, _curPlayingIndex, _curSelectedEl, _distance, _getCurFocusEl, _getCurSelectedEl, _sessionId, _videoList, _videoModalType,
            _this = this;

          _curFocusIndex = 0;
          _curIndexOnScreen = 0;
          _curPlayingIndex = 0;
          _distance = 0;
          _curSelectedEl = '';
          _curFocusEl = '';
          _sessionId = '';
          _videoList = [];
          _videoModalType = $rootScope.app.videoModalType;
          scope.handleInitSlider = function() {
            var artistsArr, len, liftIndex, width;

            _videoList = [];
            _sessionId = '';
            _curFocusIndex = 0;
            _curIndexOnScreen = 0;
            _curPlayingIndex = 0;
            _distance = 0;
            App.VideoModal.curFocusOnSliderIndex = _curFocusIndex;
            App.VideoModal.videoList = _videoList;
            if (_videoModalType === 'shows') {
              _videoList = App.VideoModal.shows;
              App.VideoModal.videoList = _videoList;
              len = _videoList.length;
              width = len * 300;
              el.css({
                width: width
              });
              return $timeout(function() {
                return scope.videoList = _videoList;
              });
            } else if (_videoModalType === 'lift') {
              artistsArr = App.VideoModal.browse.liftArtists;
              liftIndex = $rootScope.app.videoModalLiftIndex;
              _videoList = artistsArr[liftIndex].videos;
              App.VideoModal.videoList = _videoList;
              len = _videoList.length;
              width = len * 300;
              el.css({
                width: width
              });
              return $timeout(function() {
                return scope.videoList = _videoList;
              });
            } else {
              return API.video.initContinuousPlayVideos(function(res) {
                _sessionId = res.sessionId;
                _videoList = res.videoArr;
                App.VideoModal.videoList = _videoList;
                return $timeout(function() {
                  return scope.videoList = _videoList;
                });
              });
            }
          };
          scope.handleMoveSlider = function(data) {
            var key;

            key = data.key;
            if (key === 'right') {
              return _browseNext();
            } else if (key === 'left') {
              return _browsePrev();
            }
          };
          _browseNext = function() {
            var itemEl, nextItemEl;

            itemEl = _getCurFocusEl();
            nextItemEl = itemEl.next('.nav-item');
            if (!nextItemEl.size()) {
              return;
            }
            itemEl.removeClass('cur-focus');
            nextItemEl.addClass('cur-focus');
            _curFocusEl = nextItemEl;
            if (_curIndexOnScreen === 3) {
              _distance -= 273;
              el.animate({
                left: _distance
              });
            } else {
              _curIndexOnScreen++;
            }
            _curFocusIndex++;
            App.VideoModal.curFocusOnSliderIndex = _curFocusIndex;
            if (_videoList.length >= 25) {
              return;
            }
            if (_videoList.length - _curFocusIndex <= 5 && _videoModalType !== 'shows' && _videoModalType !== 'lift') {
              return API.video.getMoreContinuousPlayVideos({
                sessionId: _sessionId
              }, function(dataArr) {
                var len, width;

                $.merge(_videoList, dataArr);
                App.VideoModal.videoList = _videoList;
                len = _videoList.length;
                width = len * 300;
                el.css({
                  width: width
                });
                return scope.videoList = _videoList;
              });
            }
          };
          _browsePrev = function() {
            var itemEl, prevItemEl;

            if (_curFocusIndex === 0) {
              return;
            }
            itemEl = _getCurFocusEl();
            itemEl.removeClass('cur-focus');
            prevItemEl = itemEl.prev('.nav-item');
            prevItemEl.addClass('cur-focus');
            _curFocusEl = prevItemEl;
            if (_curIndexOnScreen === 0) {
              _distance += 273;
              el.animate({
                left: _distance
              });
            } else {
              _curIndexOnScreen--;
            }
            _curFocusIndex--;
            return App.VideoModal.curFocusOnSliderIndex = _curFocusIndex;
          };
          _getCurFocusEl = function() {
            if (_curFocusEl) {
              return _curFocusEl;
            }
            _curFocusEl = el.find('.cur-focus:first');
            return _curFocusEl;
          };
          _getCurSelectedEl = function() {
            if (_curSelectedEl) {
              return _curSelectedEl;
            }
            _curSelectedEl = el.find('.cur-selected:first');
            return _curSelectedEl;
          };
          scope.handleAutoPlayPrev = function() {
            var curFocusEl, itemEl, nextItemEl, videoData;

            _curPlayingIndex--;
            itemEl = _getCurSelectedEl();
            nextItemEl = itemEl.prev('.nav-item');
            if (!nextItemEl.size()) {
              $timeout(function() {
                return $rootScope.modal = '';
              });
              return;
            }
            if (itemEl.hasClass('cur-focus')) {
              _browsePrev();
            }
            itemEl.removeClass('cur-selected');
            nextItemEl.addClass('cur-selected');
            _curSelectedEl = nextItemEl;
            videoData = _videoList[_curPlayingIndex];
            App.VideoModal.isrc = videoData.isrc;
            App.VideoModal.data = videoData;
            $rootScope.$broadcast('ngVideoModalBrowseSlider.ngVideoModal.triggerPlayVideo');
            _distance = _curPlayingIndex * -273;
            el.css({
              left: _distance
            });
            if (!nextItemEl.hasClass('cur-focus')) {
              curFocusEl = _getCurFocusEl();
              curFocusEl.removeClass('cur-focus');
              nextItemEl.addClass('cur-focus');
              _curFocusEl = nextItemEl;
            }
            _curIndexOnScreen = 0;
            _curFocusIndex = _curPlayingIndex;
            return App.VideoModal.curFocusOnSliderIndex = _curFocusIndex;
          };
          scope.handleAutoPlayNext = function() {
            var curFocusEl, itemEl, nextItemEl, videoData;

            _curPlayingIndex++;
            itemEl = _getCurSelectedEl();
            nextItemEl = itemEl.next('.nav-item');
            if (!nextItemEl.size()) {
              $timeout(function() {
                return $rootScope.modal = '';
              });
              return;
            }
            if (itemEl.hasClass('cur-focus')) {
              _browseNext();
            }
            itemEl.removeClass('cur-selected');
            nextItemEl.addClass('cur-selected');
            _curSelectedEl = nextItemEl;
            videoData = _videoList[_curPlayingIndex];
            App.VideoModal.isrc = videoData.isrc;
            App.VideoModal.data = videoData;
            $rootScope.$broadcast('ngVideoModalBrowseSlider.ngVideoModal.triggerPlayVideo');
            _distance = _curPlayingIndex * -273;
            el.css({
              left: _distance
            });
            if (!nextItemEl.hasClass('cur-focus')) {
              curFocusEl = _getCurFocusEl();
              curFocusEl.removeClass('cur-focus');
              nextItemEl.addClass('cur-focus');
              _curFocusEl = nextItemEl;
            }
            _curIndexOnScreen = 0;
            _curFocusIndex = _curPlayingIndex;
            return App.VideoModal.curFocusOnSliderIndex = _curFocusIndex;
          };
          scope.handleSelectVideoToPlay = function() {
            var extraDistance, itemEl, newItemEl, newVideoToPlayData;

            if (_curPlayingIndex === _curFocusIndex) {
              return;
            }
            newVideoToPlayData = _videoList[_curFocusIndex];
            App.VideoModal.isrc = newVideoToPlayData.isrc;
            App.VideoModal.data = newVideoToPlayData;
            $rootScope.$broadcast('ngVideoModalBrowseSlider.ngVideoModal.triggerPlayVideo');
            itemEl = _getCurSelectedEl();
            itemEl.removeClass('cur-selected');
            newItemEl = _getCurFocusEl();
            newItemEl.addClass('cur-selected');
            _curSelectedEl = newItemEl;
            $rootScope.$broadcast('ngVideoModalBrowseSlider.ngVideoModal.hideVideoElements');
            extraDistance = _curIndexOnScreen * 273;
            _distance -= extraDistance;
            $timeout(function() {
              return el.animate({
                left: _distance
              });
            }, 1000);
            _curIndexOnScreen = 0;
            return _curPlayingIndex = _curFocusIndex;
          };
          return scope.handleUpdateShowsList = function() {
            var len, width;

            _videoList = App.VideoModal.shows;
            App.VideoModal.videoList = _videoList;
            len = _videoList.length;
            width = len * 300;
            el.css({
              width: width
            });
            return scope.videoList = _videoList;
          };
        }
      };
    }
  ]);

}).call(this);
