'use strict'


@vevo = angular.module 'vevo', ['ui.if']

vevo.run ['$timeout', 'TvInput', 'App', 'Player', 'Storage', 'Conviva', 'Playlists', 'ComScore', 'FreeWheel', 'Network', 'Strings', 'API', 'Util'
, ($timeout, TvInput, App, Player, Storage, Conviva, Playlists, ComScore, FreeWheel, Network, Strings, API, Util) ->

    window.widgetAPI = new Common.API.Widget()
    window.tvKey = new Common.API.TVKeyValue()
    window.pluginAPI = new Common.API.Plugin()
    window.networkPlugin = document.getElementById("pluginObjectNetwork")

    # deep linking
    App.deepLinking = Util.getQueryVariable "contentId"
    #App.deepLinking = "CAC239500002"

    if not App.deepLinking
        App.deepLinking = Util.getIsWatchOn()

    # init network service
    Network.init()

    # init playlists service
    Playlists.init()

    # init local storage
    Storage.init()

    # init comScore
    ComScore.init()

    # init FreeWheel
    FreeWheel.init()

    # init Strings
    Strings.init()

    # get and set region code
    API.getRegionCode()

    # init App
    App.init()

    # init converter for xml to json
    window.X2JS = new X2JS()

    #init tv remote input
    TvInput.init()

    Player.init()

    # Required to get app to load on TV
    #widgetAPI.sendReadyEvent()

    #$timeout ->
        ## turn off screen saver
        #window.pluginAPI.setOffScreenSaver()

        ## unbind keys below to allow native TV volume control
        #window.pluginAPI.unregistKey(tvKey.KEY_VOL_UP)
        #window.pluginAPI.unregistKey(tvKey.KEY_VOL_DOWN)
        #window.pluginAPI.unregistKey(tvKey.KEY_MUTE)

        #window.pluginObjectNNavi = document.getElementById("pluginObjectNNavi")
        #window.pluginObjectNNavi.SetBannerState(2)

        


    # init Player and play intro clip
    #$timeout -> Player.init()

    # init Conviva
    #Conviva.init()



]

window.onload = ->
    widgetAPI.sendReadyEvent()

window.onShow = ->
    window.pluginAPI.setOffScreenSaver()
    window.pluginAPI.unregistKey(tvKey.KEY_VOL_UP)
    window.pluginAPI.unregistKey(tvKey.KEY_VOL_DOWN)
    window.pluginAPI.unregistKey(tvKey.KEY_MUTE)
    window.pluginObjectNNavi = document.getElementById("pluginObjectNNavi")
    window.pluginObjectNNavi.SetBannerState(1)

