// Generated by CoffeeScript 1.6.2
(function() {
  'use strict';  vevo.service('API', [
    '$rootScope', '$timeout', '$http', '$q', 'K', 'Storage', 'Util', 'App', function($rootScope, $timeout, $http, $q, K, Storage, Util, App) {
      var _handleCookie,
        _this = this;

      this.vevotv = {};
      this.video = {};
      this.browse = {};
      this.activate = {};
      this.freeWheel = {};
      this.common = {};
      this.search = {};
      this.playlists = {};
      this.getRegionCode = function() {
        return $http.get(K.API.regionCodeUrl).success(function(res) {
          return App.setRegionCode(res.country);
        });
      };
      this.vevotv.getMetadata = function(callback) {
        return $http.get(K.API.vevotvMetadataUrl).success(function(res) {
          return callback(res.result);
        });
      };
      this.vevotv.getSchedule = function(callback) {
        return $http.get(K.API.scheduleUrl).success(function(res) {
          return callback(res.result[0].shows);
        });
      };
      this.video.getVideoStreamData = function(params, callback) {
        var isrc, streamUrl;

        isrc = params.isrc;
        streamUrl = K.API.videoStreamUrl.replace('{isrc}', isrc);
        return $timeout(function() {
          var http;

          http = $http.get(streamUrl, {
            headers: {
              'X-VEVO-Private-Key': K.API.headerPriveKey
            }
          });
          return http.success(function(res) {
            var arr, url;

            arr = res.result.renditions;
            App.VideoModal.renditionsArr = arr;
            App.VideoModal.renditionsIndex = 0;
            url = arr[0].url;
            return callback({
              url: url
            });
          });
        });
      };
      this.video.getAllVideoOnDemandData = function(callback) {
        var getVideoData, getVideoStream, isrc, streamUrl, videoUrl;

        isrc = App.VideoModal.isrc;
        streamUrl = K.API.videoStreamUrl.replace('{isrc}', isrc);
        videoUrl = K.API.videoDataUrl.replace('{isrc}', isrc);
        getVideoStream = $http.get(streamUrl, {
          headers: {
            'X-VEVO-Private-Key': K.API.headerPriveKey
          }
        });
        getVideoData = $http.get(videoUrl);
        return $q.all([getVideoStream, getVideoData]).then(function(arr) {
          var result;

          result = {
            streamData: arr[0].data.result,
            videoData: arr[1].data.result
          };
          if (callback) {
            return callback(result);
          }
        });
      };
      this.video.getSingleVideoForShow = function(params, callback) {
        var isrc, videoUrl;

        isrc = params.isrc;
        videoUrl = K.API.videoDataUrl.replace('{isrc}', isrc);
        return $http.get(videoUrl).success(function(res) {
          var result;

          result = res.result;
          if (callback) {
            return callback(result);
          }
        });
      };
      this.video.initContinuousPlayVideos = function(callback) {
        var arr, initRecommendVideosUrl, isrc, videoUrl;

        isrc = App.VideoModal.isrc;
        initRecommendVideosUrl = K.API.initRecommendVideosUrl.replace('{isrc}', isrc);
        videoUrl = K.API.videoDataUrl.replace('{isrc}', isrc);
        arr = [];
        return $http.get(videoUrl).success(function(res) {
          arr.push(res.result);
          return $http.get(initRecommendVideosUrl).success(function(res) {
            var newParam, nextVideoData, result, sessionId, url;

            result = res.result;
            nextVideoData = result.recommended_video;
            arr.push(nextVideoData);
            sessionId = result.session_id;
            newParam = {
              sessionId: sessionId
            };
            url = K.API.nextVideoUrl.replace('{session_id}', sessionId);
            return $http.get(url).success(function(res1) {
              return $http.get(url).success(function(res2) {
                return $http.get(url).success(function(res3) {
                  return $http.get(url).success(function(res4) {
                    var obj, resultArr;

                    resultArr = [];
                    resultArr.push(res1.result.recommended_video);
                    resultArr.push(res2.result.recommended_video);
                    resultArr.push(res3.result.recommended_video);
                    resultArr.push(res4.result.recommended_video);
                    $.merge(arr, resultArr);
                    obj = {
                      sessionId: result.session_id,
                      videoArr: arr
                    };
                    if (callback) {
                      return callback(obj);
                    }
                  });
                });
              });
            });
          });
        });
      };
      this.video.getMoreContinuousPlayVideos = function(params, callback) {
        var sessionId, url;

        sessionId = params.sessionId;
        url = K.API.nextVideoUrl.replace('{session_id}', sessionId);
        return $http.get(url).success(function(res1) {
          var resultArr;

          resultArr = [];
          resultArr.push(res1.result.recommended_video);
          return callback(resultArr);
        });
      };
      this.video.getArtistVideosData = function(callback) {
        var params, result, url;

        url = K.API.artistVideosUrl;
        url = url.replace('{artistId}', App.VideoModal.artistId);
        params = {
          max: App.VideoModal.artistNumVideos
        };
        result = {
          success: true
        };
        return $http.get(url, {
          params: params
        }).success(function(res) {
          var firstVideoData, streamUrl, videoArr;

          videoArr = res.result;
          if (!videoArr.length) {
            return callback({
              success: false
            });
          }
          firstVideoData = videoArr[0];
          result.videoData = videoArr;
          streamUrl = K.API.videoStreamUrl.replace('{isrc}', firstVideoData.isrc);
          return $http.get(streamUrl, {
            headers: {
              'X-VEVO-Private-Key': K.API.headerPriveKey
            }
          }).success(function(res) {
            result.streamData = res.result;
            return callback(result);
          });
        });
      };
      this.video.callSuperBeacon = function() {
        var storageData, url;

        storageData = Storage.get();
        url = K.API.superBeaconUrl;
        url = url.replace('{isrc}', App.VideoModal.isrc);
        url = url.replace('{regionCode}', App.getRegionCode());
        url = url.replace('{userId}', storageData.userId || null);
        return $http.get(url).success(function(res) {});
      };
      this.browse.loadMoreBrowseData = {
        premieres: 0,
        today: 0,
        week: 0,
        certified: 0,
        live: 0
      };
      this.browse.getBrowseData = function(obj, callback) {
        var list, offset, params;

        offset = 5;
        params = {
          max: 5
        };
        list = obj.list;
        switch (list) {
          case 'premieres':
            offset = _this.browse.loadMoreBrowseData.premieres + offset;
            _this.browse.loadMoreBrowseData.premieres = offset;
            params.offset = offset;
            params.order = 'mostrecent';
            params.ispremiere = true;
            break;
          case 'today':
            offset = _this.browse.loadMoreBrowseData.today + offset;
            _this.browse.loadMoreBrowseData.today = offset;
            params.offset = offset;
            params.order = 'mostviewedtoday';
            break;
          case 'week':
            offset = _this.browse.loadMoreBrowseData.week + offset;
            _this.browse.loadMoreBrowseData.week = offset;
            params.offset = offset;
            params.order = 'mostviewedthisweek';
            break;
          case 'certified':
            offset = _this.browse.loadMoreBrowseData.certified + offset;
            _this.browse.loadMoreBrowseData.certified = offset;
            params.offset = offset;
            params.iscertified = true;
            break;
          case 'live':
            offset = _this.browse.loadMoreBrowseData.live + offset;
            _this.browse.loadMoreBrowseData.live = offset;
            params.offset = offset;
            params.islive = true;
        }
        return $http({
          url: K.API.videosUrl,
          method: 'GET',
          params: params
        }).success(function(res) {
          return callback(res.result);
        });
      };
      this.browse.getAllBrowseData = function(callback) {
        var getCertifiedList, getGenreList, getLiftList, getLiveList, getPremieresList, getShowsList, getTodayList, getWeekList, videosUrl;

        videosUrl = K.API.videosUrl;
        getPremieresList = $http({
          url: videosUrl,
          method: 'GET',
          params: {
            max: 5,
            order: 'mostrecent',
            ispremiere: true
          }
        });
        getTodayList = $http({
          url: videosUrl,
          method: 'GET',
          params: {
            max: 5,
            order: 'mostviewedtoday'
          }
        });
        getWeekList = $http({
          url: videosUrl,
          method: 'GET',
          params: {
            max: 5,
            order: 'mostviewedthisweek'
          }
        });
        getCertifiedList = $http({
          url: videosUrl,
          method: 'GET',
          params: {
            max: 5,
            iscertified: true
          }
        });
        getLiveList = $http({
          url: videosUrl,
          method: 'GET',
          params: {
            max: 5,
            islive: true,
            order: 'mostviewedtoday'
          }
        });
        getGenreList = $http({
          url: K.API.genreListUrl,
          method: 'GET'
        });
        getShowsList = $http({
          url: K.API.showsListUrl,
          method: 'GET'
        });
        getLiftList = $http({
          url: K.API.liftArtistsUrl,
          method: 'GET'
        });
        return $q.all([getPremieresList, getTodayList, getWeekList, getCertifiedList, getLiveList, getGenreList, getShowsList, getLiftList]).then(function(arr) {
          var genreListData, result, showsData;

          genreListData = arr[5].data.result;
          showsData = arr[6].data;
          if (showsData.result) {
            showsData = showsData.result;
          }
          result = {
            premieres: arr[0].data.result,
            today: arr[1].data.result,
            week: arr[2].data.result,
            certified: arr[3].data.result,
            live: arr[4].data.result,
            popGenre: genreListData[0].videos[0],
            hiphopGenre: genreListData[1].videos[0],
            alternativeGenre: genreListData[2].videos[0],
            soulGenre: genreListData[3].videos[0],
            electronicGenre: genreListData[4].videos[0],
            rockGenre: genreListData[5].videos[0],
            countryGenre: genreListData[6].videos[0],
            jazzGenre: genreListData[7].videos[0],
            reggaeGenre: genreListData[8].videos[0],
            latinoGenre: genreListData[9].videos[0],
            metalGenre: genreListData[10].videos[0],
            classicalGenre: genreListData[11].videos[0],
            holidayGenre: genreListData[12].videos[0],
            shows: showsData,
            lift: arr[7].data.result.episodes
          };
          if (callback) {
            return callback(result);
          }
        });
      };
      this.browse.getShowsEpisodes = function(params, callback) {
        var url;

        url = K.API.showsEpisodesUrl;
        url = url.replace('{showId}', params.showId);
        return $http({
          url: url,
          method: 'GET'
        }).success(function(res) {
          if (res.success) {
            return callback(res.result);
          }
        });
      };
      this.browse.getLiftArtistPlaylistVideos = function(params, callback) {
        var url;

        url = K.API.getSinglePlaylistUrl;
        url = url.replace('{playlistId}', params.playlistId);
        return $http({
          url: url,
          method: 'GET'
        }).success(function(res) {
          if (res.success) {
            return callback(res.result);
          }
        });
      };
      this.activate.getAuthenticate = function(callback) {
        var newDeviceId, params, storageData;

        storageData = Storage.get();
        if (!storageData.deviceId) {
          newDeviceId = Util.generateDeviceId();
          Storage.set({
            deviceId: newDeviceId
          });
          K.DeviceId = newDeviceId;
        } else {
          K.DeviceId = storageData.deviceId;
        }
        params = {
          provider: 'SamsungTv',
          deviceId: K.DeviceId
        };
        return $http({
          url: K.API.authenticateUrl,
          method: 'GET',
          params: params,
          headers: {
            'X-VEVO-Private-Key': K.API.headerPriveKey
          }
        }).success(function(res) {
          var result;

          result = {
            success: res.success
          };
          if (res.success) {
            result.user_id = res.user_id;
            result.session_token = res.session_token;
            result.result = res.result;
          } else {
            result.activationCode = res.link_token;
          }
          if (callback) {
            return callback(result);
          }
        });
      };
      this.activate.unlinkAccount = function(callback) {
        var params, storageData;

        storageData = Storage.get();
        params = {
          provider: 9,
          identifier: storageData.deviceId
        };
        return $http({
          url: K.API.unlinkAccountUrl,
          method: 'GET',
          params: params,
          headers: {
            'X-VEVO-Session-Token': storageData.sessionToken
          }
        }).success(function(res) {
          if (callback) {
            return callback();
          }
        });
      };
      this.freeWheel.getInitVevoTvFreeWheel = function(params, callback) {
        var randomNum, url;

        url = K.API.freeWheelVevoTvInitCallUrl;
        randomNum = new Date().getTime();
        url = url.replace('{random_num}', randomNum);
        url = url.replace('{vevotv_program}', params.program);
        return $http({
          url: url,
          method: 'GET',
          withCredentials: true,
          headers: {
            'Cookie': document.cookie
          }
        }).success(function(res, status, header, config) {
          _handleCookie(header);
          return callback(res);
        });
      };
      this.freeWheel.getVevoTvFreeWheel = function(params, callback) {
        var randomNum, url;

        url = K.API.freeWheelVevoTvCallUrl;
        randomNum = new Date().getTime();
        url = url.replace('{random_num}', randomNum);
        url = url.replace('{vevotv_program}', params.program);
        url = url.replace('{tpos}', App.VevoTv.tpos);
        App.VevoTv.tpos++;
        return $http({
          url: url,
          method: 'GET',
          withCredentials: true,
          headers: {
            'Cookie': document.cookie
          }
        }).success(function(res, status, header, config) {
          _handleCookie(header);
          return callback(res);
        });
      };
      this.freeWheel.getVideoFreeWheel = function(params, callback) {
        var randomNum, url;

        url = K.API.freeWheelVideoCallUrl;
        randomNum = new Date().getTime();
        url = url.replace('{random_num}', randomNum);
        url = url.replace('{isrc}', params.isrc);
        return $http({
          url: url,
          method: 'GET',
          withCredentials: true,
          headers: {
            'Cookie': document.cookie
          }
        }).success(function(res, status, header, config) {
          _handleCookie(header);
          return callback(res);
        });
      };
      this.common.callUrl = function(params, callback) {
        var url;

        url = params.url;
        return $http({
          url: url,
          method: 'GET',
          withCredentials: true,
          headers: {
            'Cookie': document.cookie
          }
        }).success(function(res, status, header, config) {
          if (callback) {
            return callback(res);
          }
        });
      };
      _handleCookie = function(header) {
        var cookie, cookies, headers, key, val, _i, _len, _results;

        cookies = header('Set-Cookie');
        if (!cookies) {
          headers = header();
          cookies = '';
          for (key in headers) {
            val = headers[key];
            if (/^set_cookie/.test(key)) {
              cookies += val;
            }
          }
        }
        cookies = cookies.split(';');
        _results = [];
        for (_i = 0, _len = cookies.length; _i < _len; _i++) {
          cookie = cookies[_i];
          _results.push(document.cookie = cookie);
        }
        return _results;
      };
      this.search.getSearchResult = function(params, callback) {
        var query, url;

        query = params.query;
        url = K.API.searchUrl;
        url = url.replace('{query}', query);
        return $http.get(url).success(function(res) {
          return callback(res);
        });
      };
      this.playlists.getUserPlaylists = function(callback) {
        var storageData, url;

        storageData = Storage.get();
        url = K.API.userPlaylistsUrl;
        url = url.replace('{userId}', storageData.userId);
        return $http.get(url).success(function(res) {
          if (res.success) {
            return callback(res.result);
          }
        });
      };
      this.playlists.createPublicPlaylistForUserAfterLogin = function(callback) {
        var isrcStr, params, publicPlaylist, storageData, url, video, videoArr, _i, _len;

        storageData = Storage.get();
        publicPlaylist = storageData.publicPlaylist;
        videoArr = publicPlaylist.videos;
        url = K.API.createUserPlaylistUrl;
        isrcStr = '';
        for (_i = 0, _len = videoArr.length; _i < _len; _i++) {
          video = videoArr[_i];
          isrcStr = isrcStr ? isrcStr + ',' + video.isrc : video.isrc;
        }
        params = {
          title: K.Playlists.publicTitle,
          isrcs: isrcStr,
          includePlaylist: true
        };
        return $http({
          url: url,
          method: 'GET',
          headers: {
            'X-VEVO-Session-Token': storageData.sessionToken
          },
          params: params
        }).success(function(res) {
          if (res.success) {
            return callback(res.result);
          }
        });
      };
      this.playlists.createPublicPlaylistForUserAfterAdd = function(params, callback) {
        var isrc, obj, storageData, url;

        storageData = Storage.get();
        isrc = params.isrc;
        url = K.API.createUserPlaylistUrl;
        obj = {
          title: K.Playlists.publicTitle,
          isrcs: isrc,
          includePlaylist: true
        };
        return $http({
          url: url,
          method: 'PUT',
          headers: {
            'X-VEVO-Session-Token': storageData.sessionToken
          },
          params: obj
        }).success(function(res) {
          if (res.success) {
            return callback(res.result);
          }
        });
      };
      this.playlists.createPlaylistForUser = function(params, callback) {
        var obj, storageData, url;

        storageData = Storage.get();
        url = K.API.createUserPlaylistUrl;
        obj = {
          title: params.title,
          includePlaylist: true
        };
        return $http({
          url: url,
          method: 'GET',
          headers: {
            'X-VEVO-Session-Token': storageData.sessionToken
          },
          params: obj
        }).success(function(res) {
          if (res.success) {
            return callback(res.result);
          }
        });
      };
      this.playlists.updatePlaylistForUser = function(params, callback) {
        var isrcs, playlistId, storageData, url;

        storageData = Storage.get();
        playlistId = params.playlistId;
        isrcs = params.isrcs;
        url = K.API.updateUserPlaylistUrl;
        url = url.replace('{playlistId}', playlistId);
        params = {
          isrcs: isrcs,
          append: true
        };
        return $http({
          url: url,
          method: 'GET',
          headers: {
            'X-VEVO-Session-Token': storageData.sessionToken
          },
          params: params
        }).success(function(res) {
          if (res.success) {
            return callback(res.result);
          }
        });
      };
      this.playlists.getSinglePlaylist = function(params, callback) {
        var playlistId, url;

        playlistId = params.playlistId;
        url = K.API.getSinglePlaylistUrl;
        url = url.replace('{playlistId}', playlistId);
        return $http({
          url: url,
          method: 'GET'
        }).success(function(res) {
          if (res.success) {
            return callback(res.result);
          }
        });
      };
      return this.playlists.deletePlaylist = function(params, callback) {
        var playlistId, storageData, url;

        storageData = Storage.get();
        playlistId = params.playlistId;
        url = K.API.deleteUserPlaylistUrl;
        url = url.replace('{playlistId}', playlistId);
        return $http({
          url: url,
          method: 'DELETE',
          headers: {
            'X-VEVO-Session-Token': storageData.sessionToken
          }
        }).success(function(res) {
          if (res.success) {
            return callback();
          }
        });
      };
    }
  ]);

}).call(this);
