'use strict'

vevo.service 'App', ['$rootScope', ($rootScope) ->

    @initLaunch = true
    _view = ''
    _viewArr = []
    _prevView = []
    _appLaunchTimeStamp = new Date()
    _regionCode = 'US'
    @deepLinking = false


    @init = =>

        _setTemplate()
        _setVideoModal()
        _setVevoTv()

        # used everywhere else to store app variables
        $rootScope.app =
            deepLinking: @deepLinking
            modalView: ''
            videoModalGenreType: ''
            videoModalArtistName: ''
            videoModalPlaylistName: ''


    @getView = =>
        _view

    @getViewArr = =>
        _viewArr

    @updateView = (arr) =>

        _prevView = _viewArr
        _viewArr = arr
        _view = arr[1]

        $rootScope.$broadcast 'App.ComScore.trackPageView', {view: _view}

        # google analytics
        ga_view = '/view/' + _view
        _gaq.push(['_trackPageview', ga_view])

        if $rootScope.loading
            $rootScope.loading = false

        $rootScope.$apply ->
            $rootScope.view = arr


    _setTemplate = =>
        # view templates
        template = {}

        template.layout = {}
        template.layout.base = 'app/views/layout/base.html'

        template.view = {}
        template.view.vevoTv = 'app/views/view/vevoTv.html'
        template.view.browse = 'app/views/view/browse.html'
        template.view.search = 'app/views/view/search.html'
        template.view.playlists = 'app/views/view/playlists.html'

        template.modal = {}
        template.modal.video = 'app/views/modal/video.html'
        template.modal.activate = 'app/views/modal/activate.html'


        template.submodal = {}
        template.submodal.exit = 'app/views/submodal/exit.html'
        template.submodal.network = 'app/views/submodal/network.html'
        template.submodal.playlistSelect = 'app/views/submodal/playlistSelect.html'
        template.submodal.playlistCreate = 'app/views/submodal/playlistCreate.html'
        template.submodal.playlistDelete = 'app/views/submodal/playlistDelete.html'
        template.submodal.confirmExplicit = 'app/views/submodal/confirmExplicit.html'

        template.partial = {}
        template.partial.topNav = 'app/views/partial/topNav.html'
        template.partial.videoModalBrowseSlider = 'app/views/partial/videoModalBrowseSlider.html'
        template.partial.videoModalSearchSlider = 'app/views/partial/videoModalSearchSlider.html'
        template.partial.videoModalPlaylistSlider = 'app/views/partial/videoModalPlaylistSlider.html'
        template.partial.keypad = 'app/views/partial/keypad.html'
        template.partial.loading = 'app/views/partial/loading.html'

        $rootScope.template = template


    _setVideoModal = =>
        obj = {}
        obj.curFocusOnSliderIndex = 0
        obj.videoList = []
        obj.isFullScreenMode = false
        obj.videoInfoDisplayed = false
        obj.isAddCurPlayingVideoToPlaylist = false
        obj.data = {}
        obj.url = ''
        obj.videoBrowseType = ''
        obj.totalTime = 0
        obj.curVideotime = 0
        obj.isrc = ''
        
        # for stream url
        # TODO: might not need this
        obj.renditionsArr = []
        obj.renditionsIndex = 0

        # for FreeWheel
        obj.adArr = []
        obj.adInProgress = false
        obj.adPlayPosition = 0
        obj.adCounter = 0

        # cache browse page data
        obj.browse =
            popGenre: {}
            hiphopGenre: {}
            alternativeGenre: {}
            countryGenre: {}
            soulGenre: {}
            rockGenre: {}
            electronicGenre: {}
            jazzGenre: {}
            reggaeGenre: {}
            premieresList: []
            todayList: []
            weekList: []
            certifiedList: []
            liveList: []
            showsList: []
            #showsEpisodes: []
            liftArtists: []
        
        # cache shows. the key will be the shows id and value will be array of video objects only (no playlist)
        obj.shows = []

        # for search view
        obj.searchType = ''
        obj.artistId = ''
        obj.artistNumVideos = ''

        @VideoModal = obj

    _setVevoTv = =>
        obj = {}
        obj.isInitFreeWheelCall = true
        obj.isFullScreenMode = true
        obj.vevoTvInfoDisplayed = true
        obj.metadata = ''
        obj.scheduleArr = []

        # for FreeWheel
        obj.tpos = 1
        obj.adArr = []
        obj.adPlayPosition = 0
        obj.adInProgress = false

        # for comScore
        obj.curClipStartTime = ''
        obj.isrc = ''

        @VevoTv = obj


    @setRegionCode = (code) =>
        _regionCode = code

    @getRegionCode = =>
        _regionCode




]

