// Generated by CoffeeScript 1.6.2
(function() {
  'use strict';
  var __hasProp = {}.hasOwnProperty;

  vevo.service('ComScore', [
    '$rootScope', '$http', '$q', 'K', 'Storage', 'App', function($rootScope, $http, $q, K, Storage, App) {
      var _basePageViewTrackingObj, _basePlayerTrackingObj, _curPlayerIsrc, _curPlaylistType, _getAllArtistNames, _getFullWatchName, _handleTrackBrowseView, _initStreamSense, _setBasePageViewTrackingObj, _setBasePlayerTrackingObj,
        _this = this;

      _basePageViewTrackingObj = {};
      _basePlayerTrackingObj = {};
      _curPlaylistType = '';
      _curPlayerIsrc = '';
      this.init = function() {
        _setBasePageViewTrackingObj();
        _setBasePlayerTrackingObj();
        _initStreamSense();
        $rootScope.$on('Storage.ComScore.userLoggedOut', function() {
          _this.setUserStatus();
          return _this.trackCustomEvent({
            user_status_events: 'fb_logoff_success'
          });
        });
        return $rootScope.$on('App.ComScore.trackPageView', function(e, data) {
          return _this.trackPageView(data);
        });
      };
      this.initStreamSensePlaylistForVevoTv = function() {
        var playlistLabels;

        if (_curPlaylistType === 'vevotv') {
          return;
        }
        _curPlaylistType = 'vevotv';
        playlistLabels = {};
        playlistLabels.ns_st_pl = 'vevotv';
        return ns_.StreamSense.Puppet.newPlaylist(playlistLabels);
      };
      this.initStreamSensePlaylistForVideo = function(view) {
        var playlistLabels;

        if (_curPlaylistType === 'video') {
          return;
        }
        _curPlaylistType = 'video';
        playlistLabels = {};
        switch (view) {
          case 'browse':
            playlistLabels.ns_st_pl = 'Continuous-Play-From-Browse-Page';
            break;
          case 'search':
            playlistLabels.ns_st_pl = 'Continuous-Play-From-Search-Page';
            break;
          case 'playlists':
            playlistLabels.ns_st_pl = 'Continuous-Play-From-Playlists-Page';
        }
        return ns_.StreamSense.Puppet.newPlaylist(playlistLabels);
      };
      this.setUserStatus = function() {
        var storageData;

        storageData = Storage.get();
        if (storageData.username) {
          _basePageViewTrackingObj.user_status = 'fb_logged_in';
          _basePageViewTrackingObj.user_id = storageData.userId;
          return _basePlayerTrackingObj.user_status = 'logged_in';
        } else {
          _basePageViewTrackingObj.user_status = 'logged_out';
          return _basePlayerTrackingObj.user_status = 'anonymous';
        }
      };
      this.trackPageView = function(params) {
        var newTrackingObj, videoData, view, _ref;

        newTrackingObj = $.extend({}, _basePageViewTrackingObj);
        view = params.view;
        switch (view) {
          case 'home':
            newTrackingObj.name = 'splash_page';
            newTrackingObj.category = 'home';
            newTrackingObj.subsection = 'home';
            newTrackingObj.content_type = 'home';
            break;
          case 'vevotv':
            newTrackingObj.name = 'vevotv';
            newTrackingObj.category = 'home';
            newTrackingObj.subsection = 'home';
            newTrackingObj.content_type = 'vevotv';
            break;
          case 'browse':
            _handleTrackBrowseView();
            return;
          case 'search':
            newTrackingObj.name = 'search_page';
            newTrackingObj.category = 'search';
            newTrackingObj.subsection = 'search_landing';
            newTrackingObj.content_type = 'navigation_page';
            break;
          case 'playlists':
            newTrackingObj.name = 'my_playlist_page';
            newTrackingObj.category = 'home';
            newTrackingObj.subsection = 'my_vevo';
            newTrackingObj.content_type = 'navigation_page';
            break;
          case 'VOD':
            videoData = App.VideoModal.data;
            newTrackingObj.name = 'watch';
            newTrackingObj.category = 'watch';
            newTrackingObj.subsection = 'watch_page';
            newTrackingObj.content_type = 'music_video';
            newTrackingObj.content_title = videoData.url_safe_title;
            newTrackingObj.content_id = videoData.isrc;
            newTrackingObj.artists = (_ref = videoData.artists_main[0]) != null ? _ref.url_safename : void 0;
        }
        return $http({
          url: K.API.comScoreUrl,
          method: 'GET',
          withCredentials: true,
          params: newTrackingObj
        }).success(function(res) {});
      };
      this.trackVevoTv = function(params) {
        var action, clipLabels, curProgramTitle, curVevoTvTime, now, videoData, _ref, _ref1;

        action = params.action;
        videoData = App.VevoTv.metadata;
        curProgramTitle = ((_ref = App.VevoTv.scheduleArr[0]) != null ? _ref.title : void 0) || '';
        if (curProgramTitle) {
          curProgramTitle = curProgramTitle.split(' ').join('-');
        }
        now = new Date();
        curVevoTvTime = now - App.VevoTv.curClipStartTime;
        switch (action) {
          case 'newClipPlay':
            clipLabels = {};
            clipLabels.video_id = App.VevoTv.isrc;
            clipLabels.ns_st_ci = App.VevoTv.isrc;
            clipLabels.video_artist = (_ref1 = videoData.artists_main[0]) != null ? _ref1.url_safename : void 0;
            clipLabels.all_artist = _getAllArtistNames(videoData.artists_main);
            clipLabels.ft_artist = _getAllArtistNames(videoData.artists_featured);
            clipLabels.video_content_type = 'vevotv';
            clipLabels.ns_st_pr = curProgramTitle;
            clipLabels.ns_st_ty = 'vtv';
            clipLabels.ad_load = 'no';
            clipLabels.name = _getFullWatchName(videoData);
            clipLabels.ns_st_li = '1';
            clipLabels.ns_st_ev = 'play';
            if (_curPlayerIsrc) {
              ns_.StreamSense.Puppet.notify(ns_.StreamSense.PlayerEvents.END, {}, curVevoTvTime);
            }
            ns_.StreamSense.Puppet.newClip(clipLabels);
            ns_.StreamSense.Puppet.notify(ns_.StreamSense.PlayerEvents.PLAY, {}, 0);
            return _curPlayerIsrc = App.VevoTv.isrc;
          case 'newAdClipPlay':
            clipLabels = {};
            clipLabels.video_id = App.VevoTv.isrc;
            clipLabels.ns_st_ci = App.VevoTv.isrc;
            clipLabels.ns_st_ty = 'vtv';
            clipLabels.name = 'watch.vevotv_ad.' + App.VevoTv.isrc;
            clipLabels.ns_st_li = '1';
            clipLabels.ns_st_ev = 'play';
            clipLabels.ad_load = 'yes';
            clipLabels.ad_type = 'preroll';
            if (_curPlayerIsrc) {
              ns_.StreamSense.Puppet.notify(ns_.StreamSense.PlayerEvents.END, {}, curVevoTvTime);
            }
            ns_.StreamSense.Puppet.newClip(clipLabels);
            return ns_.StreamSense.Puppet.notify(ns_.StreamSense.PlayerEvents.PLAY, {}, 0);
          case 'pause':
            return ns_.StreamSense.Puppet.notify(ns_.StreamSense.PlayerEvents.PAUSE, {}, curVevoTvTime);
          case 'resume':
            return ns_.StreamSense.Puppet.notify(ns_.StreamSense.PlayerEvents.PLAY, {}, curVevoTvTime);
          case 'bufferingStart':
            return ns_.StreamSense.Puppet.notify(ns_.StreamSense.PlayerEvents.BUFFER, {}, 0);
          case 'destroy':
            ns_.StreamSense.Puppet.notify(ns_.StreamSense.PlayerEvents.END, {
              ns_st_pe: 1
            }, curVevoTvTime);
            _curPlaylistType = '';
            return _curPlayerIsrc = '';
        }
      };
      this.trackVideo = function(params) {
        var action, clipLabels, curVideoTime, videoData, _ref;

        action = params.action;
        curVideoTime = params.curVideoTime || 0;
        curVideoTime = curVideoTime * 1000;
        videoData = App.VideoModal.data;
        switch (action) {
          case 'newClipPlay':
            clipLabels = {};
            clipLabels.video_id = App.VideoModal.isrc;
            clipLabels.ns_st_ci = App.VideoModal.isrc;
            clipLabels.video_artist = (_ref = videoData.artists_main[0]) != null ? _ref.url_safename : void 0;
            clipLabels.all_artist = _getAllArtistNames(videoData.artists_main);
            clipLabels.ft_artist = _getAllArtistNames(videoData.artists_featured);
            clipLabels.ns_st_pr = 'music_video';
            clipLabels.ns_st_ty = 'vod';
            clipLabels.ad_load = 'no';
            clipLabels.name = _getFullWatchName(videoData);
            clipLabels.ns_st_ev = 'play';
            if (_curPlayerIsrc) {
              ns_.StreamSense.Puppet.notify(ns_.StreamSense.PlayerEvents.END, {}, curVideoTime);
            }
            ns_.StreamSense.Puppet.newClip(clipLabels);
            ns_.StreamSense.Puppet.notify(ns_.StreamSense.PlayerEvents.PLAY, {}, 0);
            return _curPlayerIsrc = App.VideoModal.isrc;
          case 'newAdClipPlay':
            clipLabels = {};
            clipLabels.video_id = App.VideoModal.isrc;
            clipLabels.ns_st_ci = App.VideoModal.isrc;
            clipLabels.ns_st_ty = 'vod';
            clipLabels.name = 'watch.video_ad.' + App.VideoModal.isrc;
            clipLabels.ns_st_ev = 'play';
            clipLabels.ad_load = 'yes';
            clipLabels.ad_type = 'preroll';
            if (_curPlayerIsrc) {
              ns_.StreamSense.Puppet.notify(ns_.StreamSense.PlayerEvents.END, {}, curVideoTime);
            }
            ns_.StreamSense.Puppet.newClip(clipLabels);
            return ns_.StreamSense.Puppet.notify(ns_.StreamSense.PlayerEvents.PLAY, {}, 0);
          case 'newClipPlayAfterSkip':
            return ns_.StreamSense.Puppet.notify(ns_.StreamSense.PlayerEvents.PLAY, {
              ns_st_ui: 'seeking'
            }, curVideoTime);
          case 'pause':
            return ns_.StreamSense.Puppet.notify(ns_.StreamSense.PlayerEvents.PAUSE, {}, curVideoTime);
          case 'resume':
            return ns_.StreamSense.Puppet.notify(ns_.StreamSense.PlayerEvents.PLAY, {}, curVideoTime);
          case 'bufferingStart':
            return ns_.StreamSense.Puppet.notify(ns_.StreamSense.PlayerEvents.BUFFER, {}, 0);
          case 'bufferingStartAfterSkip':
            return ns_.StreamSense.Puppet.notify(ns_.StreamSense.PlayerEvents.PAUSE, {
              ns_st_ui: 'seeking'
            }, curVideoTime);
          case 'destroy':
            ns_.StreamSense.Puppet.notify(ns_.StreamSense.PlayerEvents.END, {
              ns_st_pe: 1
            }, curVideoTime);
            _curPlaylistType = '';
            return _curPlayerIsrc = '';
        }
      };
      this.trackSearch = function(params) {
        var newTrackingObj;

        newTrackingObj = $.extend({}, _basePageViewTrackingObj);
        if (params.search_failure) {
          newTrackingObj.search_failure = params.search_failure;
        } else {
          newTrackingObj.ns_search_term = params.ns_search_term;
          newTrackingObj.search_value = params.search_value;
          newTrackingObj.search_num_artist = params.search_num_artist;
          newTrackingObj.search_num_video = params.search_num_video;
        }
        return $http({
          url: K.API.comScoreUrl,
          method: 'GET',
          withCredentials: true,
          params: newTrackingObj
        }).success(function(res) {});
      };
      this.trackCustomEvent = function(params) {
        var key, newTrackingObj, val;

        newTrackingObj = $.extend({}, _basePageViewTrackingObj);
        for (key in params) {
          if (!__hasProp.call(params, key)) continue;
          val = params[key];
          newTrackingObj[key] = val;
        }
        return $http({
          url: K.API.comScoreUrl,
          method: 'GET',
          withCredentials: true,
          params: newTrackingObj
        }).success(function(res) {});
      };
      this.endVevoTv = function() {
        return _this.trackVevoTv({
          action: 'destroy'
        });
      };
      this.endVideoPlay = function() {
        var curVideoTime;

        curVideoTime = App.VideoModal.curVideoTime;
        return _this.trackVideo({
          action: 'destroy',
          curVideoTime: curVideoTime
        });
      };
      _initStreamSense = function() {
        ns_.StreamSense.Puppet.newPuppet(K.API.comScoreUrl);
        ns_.StreamSense.Puppet.setLabels(_basePlayerTrackingObj);
        return _this.initStreamSensePlaylistForVevoTv();
      };
      _setBasePageViewTrackingObj = function() {
        _basePageViewTrackingObj.ns_site = 'vevo';
        _basePageViewTrackingObj._site = 'samsung-vevo';
        _basePageViewTrackingObj.device_type = 'samsung_tv';
        _basePageViewTrackingObj.device_name = 'samsung_tv';
        _basePageViewTrackingObj.app_version = '0.100';
        _basePageViewTrackingObj.connect_type = 'wifi';
        return _this.setUserStatus();
      };
      _setBasePlayerTrackingObj = function() {
        _basePlayerTrackingObj.ns_site = 'vevo';
        _basePlayerTrackingObj._site = 'samsung-vevo';
        _basePlayerTrackingObj.video_playback_location = 'samsung_tv';
        _basePlayerTrackingObj.ns_st_cs = '1280x720';
        _basePlayerTrackingObj.ns_st_mp = 'samsung_native_player';
        _basePlayerTrackingObj.player_ver = 'progressive';
        _basePlayerTrackingObj.loc_site = 'vevo';
        _basePlayerTrackingObj.ns_st_ws = 'full';
        return _this.setUserStatus();
      };
      _handleTrackBrowseView = function() {
        var browseArtistsPage, browseArtistsPageObj, browseFeaturedPage, browseFeaturedPageObj, browsePremieresPage, browsePremieresPageObj, browseShowsPage, browseShowsPageObj, browseVideosPage, browseVideosPageObj, newTrackingObj;

        newTrackingObj = $.extend({}, _basePageViewTrackingObj);
        newTrackingObj.category = 'home';
        newTrackingObj.subsection = 'browse';
        newTrackingObj.content_type = 'navigation_page';
        browseFeaturedPageObj = $.extend({}, newTrackingObj);
        browseFeaturedPageObj.name = 'browse_featured_page';
        browseFeaturedPage = $http({
          url: K.API.comScoreUrl,
          method: 'GET',
          withCredentials: true,
          params: browseFeaturedPageObj
        });
        browseVideosPageObj = $.extend({}, newTrackingObj);
        browseVideosPageObj.name = 'browse_videos_page';
        browseVideosPage = $http({
          url: K.API.comScoreUrl,
          method: 'GET',
          withCredentials: true,
          params: browseVideosPageObj
        });
        browseArtistsPageObj = $.extend({}, newTrackingObj);
        browseArtistsPageObj.name = 'browse_artists_page';
        browseArtistsPage = $http({
          url: K.API.comScoreUrl,
          method: 'GET',
          withCredentials: true,
          params: browseArtistsPageObj
        });
        browseShowsPageObj = $.extend({}, newTrackingObj);
        browseShowsPageObj.name = 'browse_shows_page';
        browseShowsPage = $http({
          url: K.API.comScoreUrl,
          method: 'GET',
          withCredentials: true,
          params: browseShowsPageObj
        });
        browsePremieresPageObj = $.extend({}, newTrackingObj);
        browsePremieresPageObj.name = 'browse_premieres_page';
        browsePremieresPage = $http({
          url: K.API.comScoreUrl,
          method: 'GET',
          withCredentials: true,
          params: browsePremieresPageObj
        });
        return $q.all([browseFeaturedPage, browseVideosPage, browseArtistsPage, browseShowsPage, browsePremieresPage]);
      };
      _getFullWatchName = function(videoData) {
        var isrc, mainArtistObj, str, title;

        mainArtistObj = videoData.artists_main[0];
        title = videoData.url_safe_title;
        isrc = videoData.isrc;
        str = 'watch.';
        str += (mainArtistObj != null ? mainArtistObj.url_safename : void 0) + '.';
        str += title + '.';
        str += isrc;
        return str;
      };
      _getAllArtistNames = function(arr) {
        var artist, str, _i, _len;

        str = '';
        for (_i = 0, _len = arr.length; _i < _len; _i++) {
          artist = arr[_i];
          if (!str) {
            str = artist.url_safename;
          } else {
            str += '|' + artist.url_safename;
          }
        }
        return str;
      };
      return window.onunload = function() {
        var duration, exitDate, seconds;

        exitDate = new Date();
        duration = exitDate - _appLaunchTimeStamp;
        seconds = Math.ceil(duration / 1000);
        return _this.trackCustomEvent({
          app_duration_seconds_events: seconds
        });
      };
    }
  ]);

}).call(this);
