// Generated by CoffeeScript 1.6.2
(function() {
  'use strict';  vevo.service('FreeWheel', [
    '$rootScope', '$timeout', 'Player', 'API', 'ComScore', 'App', function($rootScope, $timeout, Player, API, ComScore, App) {
      var _handleInitPlayVevoTvAd, _handleSendTracking, _handleVevoTvAdEnded, _handleVideoAdEnded, _playVevoTvAd,
        _this = this;

      this.init = function() {
        $rootScope.$on('ngVevoTv.FreeWheel.initPlayVevoTvAd', function() {
          return _handleInitPlayVevoTvAd();
        });
        $rootScope.$on('Player.FreeWheel.vevoTvAdEnded', function() {
          return _handleVevoTvAdEnded();
        });
        $rootScope.$on('Player.FreeWheel.videoAdEnded', function() {
          return _handleVideoAdEnded();
        });
        return $rootScope.$on('Player.FreeWheel.sendTracking', function() {
          return _handleSendTracking();
        });
      };
      _handleInitPlayVevoTvAd = function() {
        var program;

        program = encodeURIComponent(App.VevoTv.scheduleArr[0].title);
        if (App.VevoTv.isInitFreeWheelCall) {
          App.VevoTv.isInitFreeWheelCall = false;
          return API.freeWheel.getInitVevoTvFreeWheel({
            program: program
          }, function(data) {
            var adArr, json, _ref, _ref1, _ref2, _ref3, _ref4;

            json = window.X2JS.xml_str2json(data);
            adArr = json != null ? (_ref = json.VMAP) != null ? (_ref1 = _ref.AdBreak) != null ? (_ref2 = _ref1.AdSource) != null ? (_ref3 = _ref2.VASTAdData) != null ? (_ref4 = _ref3.VAST) != null ? _ref4.Ad_asArray : void 0 : void 0 : void 0 : void 0 : void 0 : void 0;
            App.VevoTv.adArr = adArr;
            if (adArr && adArr.length) {
              return _playVevoTvAd();
            }
          });
        } else {
          return API.freeWheel.getVevoTvFreeWheel({
            program: program
          }, function(data) {
            var adArr, json, _ref, _ref1, _ref2, _ref3, _ref4;

            json = window.X2JS.xml_str2json(data);
            adArr = json != null ? (_ref = json.VMAP) != null ? (_ref1 = _ref.AdBreak) != null ? (_ref2 = _ref1.AdSource) != null ? (_ref3 = _ref2.VASTAdData) != null ? (_ref4 = _ref3.VAST) != null ? _ref4.Ad_asArray : void 0 : void 0 : void 0 : void 0 : void 0 : void 0;
            App.VevoTv.adArr = adArr;
            if (adArr && adArr.length) {
              return _playVevoTvAd();
            }
          });
        }
      };
      _playVevoTvAd = function() {
        var ad, index, mediaFile, src;

        index = App.VevoTv.adPlayPosition;
        ad = App.VevoTv.adArr[index];
        mediaFile = ad.InLine.Creatives.Creative.Linear.MediaFiles.MediaFile;
        src = mediaFile[mediaFile.length - 1]['__cdata'];
        App.VevoTv.adInProgress = true;
        ComScore.trackVevoTv({
          action: 'newAdClipPlay'
        });
        App.VevoTv.curClipStartTime = new Date();
        Player.clear();
        return Player.playAd(src);
      };
      _handleVevoTvAdEnded = function() {
        var adArr, adPlayPosition, len, newIndex;

        adArr = App.VevoTv.adArr;
        adPlayPosition = App.VevoTv.adPlayPosition;
        len = adArr.length;
        if (len > 1 && adPlayPosition !== (len - 1)) {
          newIndex = adPlayPosition + 1;
          App.VevoTv.adPlayPosition = newIndex;
          return _playVevoTvAd();
        } else {
          if (App.VevoTv.adInProgress) {
            Player.clear();
            App.VevoTv.adInProgress = false;
            App.VevoTv.adPlayPosition = 0;
            App.VevoTv.adArr = [];
            Player.play();
            return $rootScope.$broadcast('FreeWheel.ngVevoTv.playedVevoTvAfterAd');
          }
        }
      };
      _handleVideoAdEnded = function() {
        App.VideoModal.adInProgress = false;
        return $rootScope.$broadcast('FreeWheel.ngVideoModal.triggerPlayVideo');
      };
      return _handleSendTracking = function() {
        var ad, completeTime, completeUrl, duration, firstQuarterTime, firstQuartileUrl, impressionUrl, index, info, midepointTime, midpointUrl, thirdQuarterTime, thirdQuartileUrl, trackingData;

        if (App.VevoTv.adInProgress) {
          index = App.VevoTv.adPlayPosition;
          ad = App.VevoTv.adArr[index];
        } else {
          index = App.VideoModal.adPlayPosition;
          ad = App.VideoModal.adArr[index];
        }
        info = ad.InLine.Creatives.Creative.Linear;
        duration = info.Duration;
        trackingData = info.TrackingEvents.Tracking;
        impressionUrl = ad.InLine.Impression['__cdata'];
        completeUrl = trackingData[0]['__cdata'];
        firstQuartileUrl = trackingData[1]['__cdata'];
        midpointUrl = trackingData[2]['__cdata'];
        thirdQuartileUrl = trackingData[3]['__cdata'];
        if (duration === '00:00:30') {
          firstQuarterTime = 7500;
          midepointTime = 15000;
          thirdQuarterTime = 22500;
          completeTime = 30000;
        } else {
          firstQuarterTime = 3750;
          midepointTime = 7500;
          thirdQuarterTime = 11250;
          completeTime = 15000;
        }
        API.common.callUrl({
          url: impressionUrl
        });
        $timeout(function() {
          return API.common.callUrl({
            url: firstQuartileUrl
          });
        }, firstQuarterTime);
        $timeout(function() {
          return API.common.callUrl({
            url: midpointUrl
          });
        }, midepointTime);
        $timeout(function() {
          return API.common.callUrl({
            url: thirdQuartileUrl
          });
        }, thirdQuarterTime);
        return $timeout(function() {
          return API.common.callUrl({
            url: completeUrl
          });
        }, completeTime);
      };
    }
  ]);

}).call(this);
