'use strict'

vevo.service 'K', ->

    # randomly generated Device ID
    @DeviceId = ''



    # HLS stream
    @Stream = {}
    @Stream.hlsFullSuffix = '|BITRATES=400000~1200000|COMPONENT=HLS'
    @Stream.hlsSuffix = '|COMPONENT=HLS'
    @Stream.vevoTv = 'http://vevoplaylist-live.hls.adaptive.level3.net/vevo/ch1/appleman.m3u8|BITRATES=1800000~3000000|COMPONENT=HLS'
    #@Stream.vevoTv = 'http://prim.ingest.vevoplaylist-live-hls.adaptive.level3.net/vyvxlab/vyvxlab/appleman.m3u8|BITRATES=1800000~3000000|COMPONENT=HLS'

    # for smooth streaming
    #@vevoTvStream = 'http://vevoplaylist-live.hss.adaptive.level3.net/livefeed/vevo/ch1.isml/Manifest|BITRATES=512000~3500000|STARTBITRATE=CHECK'

    # API
    @API = {}
    @API.headerPriveKey = 'G05bmz9x--_6-J-qpR4_'

    # Region Code
    @API.regionCodeUrl = 'http://api.vevo.com/mobile/v1/userterritory.json'
    @API.superBeaconUrl = 'http://sb.vevo.com/Player/PlayStart.ashx?sourceId=f5eecad0-52f6-427f-8f2f-431c709a244b&videoid={isrc}&userId={userId}&domain=samsungTV&region={regionCode}'

    # Authenticate API
    @API.authenticateUrl = 'https://api.vevo.com/mobile/v1/user/authenticateplatform.json'
    @API.unlinkAccountUrl = 'https://api.vevo.com/mobile/v1/user/unlinkaccount.json'
    
    # FreeWheel API
    @API.freeWheelVevoTvInitCallUrl = "http://9cf9.v.fwmrm.net/ad/g/1?nw=40185&csid=vevotv_samsungtv&caid=VEVOTV123456&vprn={random_num}&resp=vmap1&mode=live&prof=40185:vevo_samsungtv&flag=+exvt+emcr+slcb+amcb+sltp;vevotv_program={vevotv_program};ptgt=a&tpcl=PREROLL&tpos=0&maxa=2&maxd=30mind=30"
    @API.freeWheelVevoTvCallUrl     = "http://9cf9.v.fwmrm.net/ad/g/1?nw=40185&csid=vevotv_samsungtv&caid=VEVOTV123456&vprn={random_num}&resp=vmap1&mode=live&prof=40185:vevo_samsungtv&flag=+emcr+slcb+amcb+sltp;vevotv_program={vevotv_program};ptgt=a&tpcl=PREROLL&tpos={tpos}&maxa=2&maxd=30mind=30"
    # [BrightLine] Start
    #@API.freeWheelVideoCallUrl = 'http://9cf9.v.fwmrm.net/ad/g/1?nw=40185&ssnw=40185&asnw=40185&csid=samsungtv_watchpage&caid={isrc}&vprn={random_num}&resp=vast2&crtp=vast2s&prof=40185:vevo_samsungtv&flag=+exvt+amcb;;ptgt=a&tpcl=PREROLL&tpos=0'
    @API.freeWheelVideoCallUrl = "http://9cf9.v.fwmrm.net/ad/g/1?nw=40185&ssnw=40185&asnw=40185&csid=samsungtv_watchpage&caid=USIV20500353&vprn=33455234123&resp=vast2&crtp=vast2s&prof=40185:vevo_samsungtv&flag=+exvt+amcb;;ptgt=a&tpcl=PREROLL&tpos=0;ptgt=p&w=1280&h=720&slau=Brightline_Companion&slid=brightline&flag=+cmpn+nosa"
    # [BrightLine] End
    

    @API.searchUrl = 'https://search.vevo.com/mobile/v1/lookahead.json?q={query}&fullItems=true&newSearch=yes'
    @API.artistVideosUrl = 'https://api.vevo.com/mobile/v1/artist/{artistId}/videos.json'

    # HLS metadata API
    @API.vevotvMetadataUrl = 'http://api.vevo.com/mobile/v1/vevotvmetadatatimeline.json'

    # Genre API
    @API.genreListUrl = 'http://api.vevo.com/mobile/v3/genre/list.json?videospergenre=1&genres=pop,raphip-hop,alternative,rbsoul,electronicdance,rock,country,jazz,reggae,latino,metal,classical,holiday'

    # Playlists API
    @API.userPlaylistsUrl = 'https://api.vevo.com/mobile/v1/userplaylists/{userId}/list.json'
    @API.createUserPlaylistUrl = 'https://api.vevo.com/mobile/v1/userplaylist/create.json'
    @API.updateUserPlaylistUrl = 'https://api.vevo.com/mobile/v1/userplaylist/update/{playlistId}.json'
    @API.deleteUserPlaylistUrl = 'https://api.vevo.com/mobile/v1/userplaylist/{playlistId}.json'
    @API.getSinglePlaylistUrl = 'https://api.vevo.com/mobile/v1/userplaylist/{playlistId}.json'

    @API.metadataUrl = 'https://api.vevo.com/mobile/v1/vevotvmetadata.json'
    @API.scheduleUrl = 'https://api.vevo.com/mobile/v1/featured/tvschedule.json'
    @API.videoStreamUrl = 'https://api.vevo.com/mobile/v3/video/renditions/{isrc}.json'
    @API.videoDataUrl = 'https://api.vevo.com/mobile/v1/video/{isrc}.json'
    @API.videosUrl = 'https://api.vevo.com/mobile/v1/video/list.json'
    @API.initRecommendVideosUrl = 'https://api.vevo.com/mobile/v1/recommendation/createsession/video/{isrc}.json'
    @API.nextVideoUrl = 'https://api.vevo.com/mobile/v1/recommendation/getnextvideo/{session_id}.json'

    # Lift API
    @API.liftArtistsUrl = 'http://www.vevo.com/c/lift/artists.json'

    # Shows API
    @API.showsListUrl = 'http://www.vevo.com/c/shows.json'

    # ComScore API
    @API.comScoreUrl = 'http://b.scorecardresearch.com/p?c1=2&c2=3005647'

    # Playlists
    @Playlists = {}
    @Playlists.publicTitle = 'Samsung Watch Later'
    @Playlists.publicImage = 'http://img.cache.vevo.com/Content/VevoImages/video/novideo.jpg'


    # keypad
    @Keypad = {}
    @Keypad.letters = [
        'a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i',
        'j', 'k', 'l', 'm', 'n', 'o', 'p', 'q', 'r',
        's', 't', 'u', 'v', 'w', 'x', 'y', 'z'
    ]
    @Keypad.capLetters = [
        'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I',
        'J', 'K', 'L', 'M', 'N', 'O', 'P', 'Q', 'R',
        'S', 'T', 'U', 'V', 'W', 'X', 'Y', 'Z'
    ]
    @Keypad.numbers = ['1', '2', '3', '4', '5', '6', '7', '8', '9', '0']
    @Keypad.specialChars = ['!', '@', '#', '$', '.', ',', '-', '&']

    # animation location
    @File = {}
    @File.launchAnimationUrl = 'img/vevo_animation.mp4'



