'use strict'

vevo.service 'Nav', ['$rootScope', 'App', 'Storage', ($rootScope, App, Storage) ->

    @curNavFocusItemEl = ''

    @curNavZone = 'nav-top'


    @navigate = (key) =>
        zoneType = getCurNavZoneType()

        if zoneType is 'horizontal'
            handleHorizontalNav key
        else if zoneType is 'vertical'
            handleVerticalNav key
        else if zoneType is 'grid'
            handleGridNav key

    getCurNavZoneType = =>
        angular.element('#' + @curNavZone).data 'nav-type'

    @getCurNavFocusItem = =>
        if @curNavFocusItemEl?.length
            return @curNavFocusItemEl

        @curNavFocusItemEl = $('.nav-current-zone:first').find '.nav-current-item-focus:first'
        @curNavFocusItemEl



    handleHorizontalNav = (key) =>

        curView = App.getView()
        curViewArr = App.getViewArr()
        curViewArr = curViewArr.join '-'

        switch key
            when 'right'
                curNavFocusItem = @getCurNavFocusItem()
                nextItem = curNavFocusItem.next('.nav-item')
                if nextItem.size()
                    @curNavFocusItemEl = nextItem
                    nextItem.addClass 'nav-current-item-focus'
                    curNavFocusItem.removeClass 'nav-current-item-focus'

                    # schedule cases
                    if @curNavFocusItemEl.hasClass 'vevotv-schedule-item'
                        # for vevo tv schedule Slider
                        $rootScope.$broadcast 'Nav.ngScheduleSlider.vevoTvScheduleNext'
                    else if @curNavFocusItemEl.hasClass 'browse-row-item'
                        # for browse view Slider

                        parentZone = curNavFocusItem.closest '.nav-wrap'

                        if not nextItem.next('.nav-item').size() and parentZone.attr('data-list') isnt 'genres'
                            # load more
                            $rootScope.$broadcast 'Nav.ngBrowse.loadMoreBrowseVideo', {list: parentZone.data('list')}

                        $rootScope.$broadcast 'Nav.ngBrowseSlider.browseNext', {list: parentZone.data('list')}

                    else if @curNavFocusItemEl.hasClass 'search-row-item'
                        # for search view Slider

                        parentZone = curNavFocusItem.closest '.nav-wrap'

                        $rootScope.$broadcast 'Nav.ngSearchSlider.searchBrowseNext', {list: parentZone.data('list')}

                else


                    parentZone = curNavFocusItem.closest '.nav-wrap'
                    nextZone = parentZone.attr('data-nav-leave-right-' + curViewArr) || parentZone.attr('data-nav-leave-right')

                    if nextZone
                        @curNavZone = nextZone
                        $rootScope.$broadcast 'app.updateNavZone'
                        curNavFocusItem.removeClass 'nav-current-item-focus'

                        newNavFocusItemEl = $('#' + nextZone).find('.nav-item:first')
                        @curNavFocusItemEl = newNavFocusItemEl
                        newNavFocusItemEl.addClass 'nav-current-item-focus'


            when 'left'
                curNavFocusItem = @getCurNavFocusItem()
                prevItem = curNavFocusItem.prev('.nav-item')
                if prevItem.size()
                    @curNavFocusItemEl = prevItem
                    prevItem.addClass 'nav-current-item-focus'
                    curNavFocusItem.removeClass 'nav-current-item-focus'

                    # schedule cases
                    if @curNavFocusItemEl.hasClass 'vevotv-schedule-item'
                        # vevo tv schedule Slider
                        $rootScope.$broadcast 'Nav.ngScheduleSlider.vevoTvSchedulePrev'
                    else if @curNavFocusItemEl.hasClass 'browse-row-item'
                        # browse Slider

                        parentZone = curNavFocusItem.closest '.nav-wrap'
                        $rootScope.$broadcast 'Nav.ngBrowseSlider.browsePrev', {list: parentZone.data('list')}
                    else if @curNavFocusItemEl.hasClass 'search-row-item'
                        # search Slider

                        parentZone = curNavFocusItem.closest '.nav-wrap'
                        $rootScope.$broadcast 'Nav.ngSearchSlider.searchBrowsePrev', {list: parentZone.data('list')}
                    else if $rootScope.dropdown is 'account'
                        $rootScope.$apply -> $rootScope.dropdown = ""

                else

                    parentZone = curNavFocusItem.closest '.nav-wrap'
                    prevZone = parentZone.attr('data-nav-leave-left-' + curViewArr) || parentZone.attr('data-nav-leave-left')
                    if prevZone
                        @curNavZone = prevZone
                        $rootScope.$broadcast 'app.updateNavZone'
                        curNavFocusItem.removeClass 'nav-current-item-focus'

                        newNavFocusItemEl = $('#' + prevZone).find('.nav-item:last')
                        @curNavFocusItemEl = newNavFocusItemEl
                        newNavFocusItemEl.addClass 'nav-current-item-focus'

            when 'down'
                curNavFocusItem = @getCurNavFocusItem()
                parentZone = curNavFocusItem.closest '.nav-wrap'

                #special case for account dropdown
                dropdown = parentZone.data 'nav-leave-down-to-dropdown'

                if dropdown and $rootScope.dropdown is 'account'
                    bottomZone = dropdown
                else
                    bottomZone = parentZone.attr('data-nav-leave-down-' + curViewArr) || parentZone.attr('data-nav-leave-down')

                if bottomZone

                    @curNavZone = bottomZone
                    $rootScope.$broadcast 'app.updateNavZone'
                    curNavFocusItem.removeClass 'nav-current-item-focus'

                    bottomZoneEl = $('#' + bottomZone)
                    curSelectedItemInNewZone = bottomZoneEl.find('.nav-current-item-selected')
                    if curSelectedItemInNewZone.length
                        @curNavFocusItemEl = curSelectedItemInNewZone
                        curSelectedItemInNewZone.addClass 'nav-current-item-focus'
                    else if bottomZoneEl.hasClass 'browse-row'
                        # On browse Slider
                        indexOnScreen = Number(parentZone.attr('data-cur-index-on-screen')) || 0
                        bottomZoneIndexOnScreen = Number bottomZoneEl.attr('data-cur-index-on-screen')
                        index = Number bottomZoneEl.attr('data-cur-index')

                        if indexOnScreen is bottomZoneIndexOnScreen
                            newIndex = index
                        else if indexOnScreen > bottomZoneIndexOnScreen
                            #newIndex = indexOnScreen + index
                            newIndex = index + (indexOnScreen - bottomZoneIndexOnScreen)
                        else
                            newIndex = index - (bottomZoneIndexOnScreen - indexOnScreen)


                        newNavFocusItemEl = bottomZoneEl.find('.nav-item:nth-child(' + (newIndex + 1) + ')')
                        @curNavFocusItemEl = newNavFocusItemEl
                        newNavFocusItemEl.addClass 'nav-current-item-focus'

                        diff = indexOnScreen - Number(bottomZoneEl.attr('data-cur-index-on-screen'))

                        bottomZoneEl.attr 'data-cur-index-on-screen', indexOnScreen
                        bottomZoneEl.attr 'data-cur-index', newIndex

                        section = bottomZoneEl.attr 'data-list'
                        $rootScope.$broadcast 'Nav.ngBrowse.updateSectionFocus', {list: section}
                        $rootScope.$broadcast 'Nav.ngBrowseSlider.initBrowseSlider',
                            list: section
                            rowIndex: Number bottomZoneEl.attr('data-row-index')
                            direction: 'down'
                            curIndexOnScreen: indexOnScreen
                            indexDiff: diff

                    else if bottomZoneEl.hasClass 'search-row'

                        # On search Slider
                        indexOnScreen = Number(parentZone.attr('data-cur-index-on-screen')) || 0
                        bottomZoneIndexOnScreen = Number bottomZoneEl.attr('data-cur-index-on-screen')
                        index = Number bottomZoneEl.attr('data-cur-index')

                        if indexOnScreen is bottomZoneIndexOnScreen
                            newIndex = index
                        else if indexOnScreen > bottomZoneIndexOnScreen
                            #newIndex = indexOnScreen + index
                            newIndex = index + (indexOnScreen - bottomZoneIndexOnScreen)
                        else
                            newIndex = index - (bottomZoneIndexOnScreen - indexOnScreen)


                        newNavFocusItemEl = bottomZoneEl.find('.nav-item:nth-child(' + (newIndex + 1) + ')')
                        @curNavFocusItemEl = newNavFocusItemEl
                        newNavFocusItemEl.addClass 'nav-current-item-focus'

                        diff = indexOnScreen - Number(bottomZoneEl.attr('data-cur-index-on-screen'))

                        bottomZoneEl.attr 'data-cur-index-on-screen', indexOnScreen
                        bottomZoneEl.attr 'data-cur-index', newIndex

                        section = bottomZoneEl.attr 'data-list'
                        $rootScope.$broadcast 'Nav.ngSearch.updateSectionFocus', {list: section}
                        $rootScope.$broadcast 'Nav.ngSearchSlider.initSearchSlider',
                            list: section
                            rowIndex: Number bottomZoneEl.attr('data-row-index')
                            direction: 'down'
                            curIndexOnScreen: indexOnScreen
                            indexDiff: diff

                    else
                        newNavFocusItemEl = bottomZoneEl.find('.nav-item:first')
                        @curNavFocusItemEl = newNavFocusItemEl
                        newNavFocusItemEl.addClass 'nav-current-item-focus'


                    # schedule cases
                    if @curNavFocusItemEl.hasClass 'vevotv-schedule-item'
                        # On vevo tv schedule Slider
                        $rootScope.$broadcast 'Nav.ngScheduleSlider.initVevoTvSchedule'
                    else if @curNavFocusItemEl.hasClass 'playlist-item'
                        # Now on Playlists nav
                        storageData = Storage.get()
                        if storageData?.username
                            $rootScope.$broadcast 'Nav.ngPlaylists.showDeleteOption'


                else
                    # no bottomZone
                    subModal = $rootScope.subModal

                    # special case for exiting the search box
                    if parentZone.attr('id') is 'nav-keypad-controls' and curView is 'search' and subModal isnt 'playlistCreate'

                        artistRowEl = angular.element('#nav-search-artist')
                        videoRowEl = angular.element('#nav-search-video')

                        if not artistRowEl.length and not videoRowEl.length
                            return

                        $rootScope.$broadcast 'Nav.ngSearch.handleReturnKeyOnSearchView'
                        @navigate 'down'


            when 'up'
                curNavFocusItem = @getCurNavFocusItem()
                parentZone = curNavFocusItem.closest '.nav-wrap'
                upZone = parentZone.attr('data-nav-leave-up-' + curViewArr) || parentZone.attr('data-nav-leave-up')

                if upZone

                    @curNavZone = upZone
                    $rootScope.$broadcast 'app.updateNavZone'
                    curNavFocusItem.removeClass 'nav-current-item-focus'

                    upZoneEl = $('#' + upZone)
                    curSelectedItemInNewZone = upZoneEl.find('.nav-current-item-selected')
                    if curSelectedItemInNewZone.length
                        @curNavFocusItemEl = curSelectedItemInNewZone
                        curSelectedItemInNewZone.addClass 'nav-current-item-focus'
                        if parentZone.hasClass 'browse-row'
                            $rootScope.$broadcast 'Nav.ngBrowse.updateSectionFocus', {list: ''}
                    else if upZoneEl.hasClass 'browse-row'
                        # On browse Slider
                        indexOnScreen = Number parentZone.attr('data-cur-index-on-screen')
                        upZoneIndexOnScreen = Number upZoneEl.attr('data-cur-index-on-screen')
                        index = Number upZoneEl.attr('data-cur-index')

                        if indexOnScreen is upZoneIndexOnScreen
                            newIndex = index
                        else if indexOnScreen > upZoneIndexOnScreen
                            newIndex = index + (indexOnScreen - upZoneIndexOnScreen)
                        else
                            newIndex = index - (upZoneIndexOnScreen - indexOnScreen)

                        newNavFocusItemEl = upZoneEl.find('.nav-item:nth-child(' + (newIndex + 1) + ')')
                        @curNavFocusItemEl = newNavFocusItemEl
                        newNavFocusItemEl.addClass 'nav-current-item-focus'

                        diff = indexOnScreen - Number(upZoneEl.attr('data-cur-index-on-screen'))

                        upZoneEl.attr 'data-cur-index-on-screen', indexOnScreen
                        upZoneEl.attr 'data-cur-index', newIndex

                        section = upZoneEl.attr 'data-list'
                        $rootScope.$broadcast 'Nav.ngBrowse.updateSectionFocus', {list: section}
                        $rootScope.$broadcast 'Nav.ngBrowseSlider.initBrowseSlider',
                            list: section
                            rowIndex: Number upZoneEl.attr('data-row-index')
                            direction: 'up'
                            curIndexOnScreen: indexOnScreen
                            indexDiff: diff

                    else if upZoneEl.hasClass 'search-row'
                        # On search Slider
                        indexOnScreen = Number parentZone.attr('data-cur-index-on-screen')
                        upZoneIndexOnScreen = Number upZoneEl.attr('data-cur-index-on-screen')
                        index = Number upZoneEl.attr('data-cur-index')

                        if indexOnScreen is upZoneIndexOnScreen
                            newIndex = index
                        else if indexOnScreen > upZoneIndexOnScreen
                            newIndex = index + (indexOnScreen - upZoneIndexOnScreen)
                        else
                            newIndex = index - (upZoneIndexOnScreen - indexOnScreen)

                        newNavFocusItemEl = upZoneEl.find('.nav-item:nth-child(' + (newIndex + 1) + ')')

                        if newNavFocusItemEl.size()
                            diff = indexOnScreen - Number(upZoneEl.attr('data-cur-index-on-screen'))

                            upZoneEl.attr 'data-cur-index-on-screen', indexOnScreen
                            upZoneEl.attr 'data-cur-index', newIndex

                            section = upZoneEl.attr 'data-list'
                            $rootScope.$broadcast 'Nav.ngSearch.updateSectionFocus', {list: section}
                            $rootScope.$broadcast 'Nav.ngSearchSlider.initSearchSlider',
                                list: section
                                rowIndex: Number upZoneEl.attr('data-row-index')
                                direction: 'up'
                                curIndexOnScreen: indexOnScreen
                                indexDiff: diff
                        else
                            newNavFocusItemEl = upZoneEl.find('.nav-item:nth-child(1)')

                            upZoneEl.attr 'data-cur-index-on-screen', 0
                            upZoneEl.attr 'data-cur-index', 0

                            section = upZoneEl.attr 'data-list'
                            $rootScope.$broadcast 'Nav.ngSearch.updateSectionFocus', {list: section}
                            $rootScope.$broadcast 'Nav.ngSearchSlider.initSearchSlider',
                                list: section
                                rowIndex: Number upZoneEl.attr('data-row-index')
                                direction: 'up'
                                curIndexOnScreen: 0
                                indexDiff: 0

                        @curNavFocusItemEl = newNavFocusItemEl
                        newNavFocusItemEl.addClass 'nav-current-item-focus'

                    else if upZoneEl.hasClass 'js-search-keys'
                        # special case for search key box
                        newNavFocusItemEl = upZoneEl.find('.nav-item').filter('[data-char=8]')
                        @curNavFocusItemEl = newNavFocusItemEl
                        newNavFocusItemEl.addClass 'nav-current-item-focus'
                    else
                        newNavFocusItemEl = upZoneEl.find('.nav-item:first')
                        @curNavFocusItemEl = newNavFocusItemEl
                        newNavFocusItemEl.addClass 'nav-current-item-focus'


    handleVerticalNav = (key) =>
        curViewArr = App.getViewArr()
        curViewArr = curViewArr.join '-'

        switch key
            when 'down'
                curNavFocusItem = @getCurNavFocusItem()
                nextItem = curNavFocusItem.next('.nav-item')
                if nextItem.size()
                    @curNavFocusItemEl = nextItem
                    nextItem.addClass 'nav-current-item-focus'
                    curNavFocusItem.removeClass 'nav-current-item-focus'
                else
                    parentZone = curNavFocusItem.closest '.nav-wrap'
                    nextZone = parentZone.attr('data-nav-leave-down-' + curViewArr) || parentZone.attr('data-nav-leave-down')

                    if nextZone
                        @curNavZone = nextZone
                        $rootScope.$broadcast 'app.updateNavZone'
                        curNavFocusItem.removeClass 'nav-current-item-focus'

                        newNavFocusItemEl = $('#' + nextZone).find('.nav-item:first')
                        @curNavFocusItemEl = newNavFocusItemEl
                        newNavFocusItemEl.addClass 'nav-current-item-focus'
            when 'up'
                curNavFocusItem = @getCurNavFocusItem()
                prevItem = curNavFocusItem.prev('.nav-item')
                if prevItem.size()
                    @curNavFocusItemEl = prevItem
                    prevItem.addClass 'nav-current-item-focus'
                    curNavFocusItem.removeClass 'nav-current-item-focus'

                else

                    parentZone = curNavFocusItem.closest '.nav-wrap'
                    prevZone = parentZone.attr('data-nav-leave-up-' + curViewArr) || parentZone.attr('data-nav-leave-up')
                    if prevZone
                        @curNavZone = prevZone
                        $rootScope.$broadcast 'app.updateNavZone'
                        curNavFocusItem.removeClass 'nav-current-item-focus'

                        newNavFocusItemEl = $('#' + prevZone).find('.nav-item:last')
                        @curNavFocusItemEl = newNavFocusItemEl
                        newNavFocusItemEl.addClass 'nav-current-item-focus'

                        # schedule cases
                        if parentZone.attr('id') is 'nav-account-dropdown'
                            # for auto removing drop down
                            $rootScope.$apply -> $rootScope.dropdown = ""

    @collapseDropdown = =>
        curViewArr = App.getViewArr()
        curViewArr = curViewArr.join '-'
        curNavFocusItem = @getCurNavFocusItem()
        parentZone = curNavFocusItem.closest '.nav-wrap'
        prevZone = parentZone.attr('data-nav-leave-up-' + curViewArr) || parentZone.attr('data-nav-leave-up')
        if prevZone
            @curNavZone = prevZone
            $rootScope.$broadcast 'app.updateNavZone'
            curNavFocusItem.removeClass 'nav-current-item-focus'

            newNavFocusItemEl = $('#' + prevZone).find('.nav-item:last')
            @curNavFocusItemEl = newNavFocusItemEl
            newNavFocusItemEl.addClass 'nav-current-item-focus'

            # schedule cases
            if parentZone.attr('id') is 'nav-account-dropdown'
                # for auto removing drop down
                $rootScope.$apply ->
                    $rootScope.dropdown = ""


    handleGridNav = (key) =>
        curView = App.getView()
        curViewArr = App.getViewArr()
        curViewArr = curViewArr.join '-'
        subModal = $rootScope.subModal

        switch key
            when 'right'
                curNavFocusItem = @getCurNavFocusItem()
                nextItem = curNavFocusItem.next('.nav-item')

                if nextItem.size()
                    @curNavFocusItemEl = nextItem
                    nextItem.addClass 'nav-current-item-focus'
                    curNavFocusItem.removeClass 'nav-current-item-focus'

                    if curView is 'playlists' and not subModal
                        parentZone = curNavFocusItem.closest '.nav-wrap'
                        index = nextItem.index()
                        numPerRow = Number parentZone.attr('data-num-per-row')
                        if index % numPerRow is 0
                            $rootScope.$broadcast 'Nav.ngPlaylists.navigateDown'

            when 'left'
                curNavFocusItem = @getCurNavFocusItem()
                prevItem = curNavFocusItem.prev('.nav-item')

                if prevItem.size()
                    @curNavFocusItemEl = prevItem
                    prevItem.addClass 'nav-current-item-focus'
                    curNavFocusItem.removeClass 'nav-current-item-focus'

                    if curView is 'playlists' and not subModal
                        parentZone = curNavFocusItem.closest '.nav-wrap'
                        index = prevItem.index()
                        numPerRow = Number parentZone.attr('data-num-per-row')
                        if numPerRow - (index % numPerRow) is 1
                            $rootScope.$broadcast 'Nav.ngPlaylists.navigateUp'


            when 'down'
                curNavFocusItem = @getCurNavFocusItem()
                parentZone = curNavFocusItem.closest '.nav-wrap'
                numPerRow = Number parentZone.attr('data-num-per-row')
                newIndex = curNavFocusItem.index() + numPerRow

                totalKeys = Number parentZone.attr('data-total-keys')

                if newIndex < totalKeys
                    newNavFocusItemEl = parentZone.find('.nav-item').eq newIndex

                    if newNavFocusItemEl.size()
                        newNavFocusItemEl.addClass 'nav-current-item-focus'
                        curNavFocusItem.removeClass 'nav-current-item-focus'
                        @curNavFocusItemEl = newNavFocusItemEl

                        if curView is 'playlists' and not subModal
                            $rootScope.$broadcast 'Nav.ngPlaylists.navigateDown'



                else
                    downZone = parentZone.attr('data-nav-leave-down-' + curViewArr) || parentZone.attr('data-nav-leave-down')


                    if downZone
                        downZoneEl = $('#' + downZone)
                        @curNavZone = downZone
                        $rootScope.$broadcast 'app.updateNavZone'
                        curNavFocusItem.removeClass 'nav-current-item-focus'
                        newNavFocusItemEl = downZoneEl.find('.nav-item:first')
                        @curNavFocusItemEl = newNavFocusItemEl
                        newNavFocusItemEl.addClass 'nav-current-item-focus'




            when 'up'
                curNavFocusItem = @getCurNavFocusItem()
                parentZone = curNavFocusItem.closest '.nav-wrap'
                numPerRow = Number parentZone.attr('data-num-per-row')
                newIndex = curNavFocusItem.index() - numPerRow
                if newIndex >= 0
                    newNavFocusItemEl = parentZone.find('.nav-item').eq newIndex

                    if newNavFocusItemEl.size()
                        newNavFocusItemEl.addClass 'nav-current-item-focus'
                        curNavFocusItem.removeClass 'nav-current-item-focus'
                        @curNavFocusItemEl = newNavFocusItemEl

                        if curView is 'playlists' and not subModal
                            $rootScope.$broadcast 'Nav.ngPlaylists.navigateUp'

                else
                    upZone = parentZone.attr('data-nav-leave-up-' + curViewArr) || parentZone.attr('data-nav-leave-up')

                    if upZone

                        @curNavZone = upZone
                        $rootScope.$broadcast 'app.updateNavZone'
                        curNavFocusItem.removeClass 'nav-current-item-focus'

                        upZoneEl = $('#' + upZone)

                        curSelectedItemInNewZone = upZoneEl.find('.nav-current-item-selected')
                        if curSelectedItemInNewZone.length
                            @curNavFocusItemEl = curSelectedItemInNewZone
                            curSelectedItemInNewZone.addClass 'nav-current-item-focus'
                        else
                            newNavFocusItemEl = upZoneEl.find('.nav-item:first')
                            @curNavFocusItemEl = newNavFocusItemEl
                            newNavFocusItemEl.addClass 'nav-current-item-focus'

                        if curView is 'playlists'
                            $rootScope.$broadcast 'Nav.ngPlaylists.hideDeleteOption'







]


