// Generated by CoffeeScript 1.6.2
(function() {
  'use strict';  vevo.service('Nav', [
    '$rootScope', 'App', 'Storage', function($rootScope, App, Storage) {
      var getCurNavZoneType, handleGridNav, handleHorizontalNav, handleVerticalNav,
        _this = this;

      this.curNavFocusItemEl = '';
      this.curNavZone = 'nav-top';
      this.navigate = function(key) {
        var zoneType;

        zoneType = getCurNavZoneType();
        if (zoneType === 'horizontal') {
          return handleHorizontalNav(key);
        } else if (zoneType === 'vertical') {
          return handleVerticalNav(key);
        } else if (zoneType === 'grid') {
          return handleGridNav(key);
        }
      };
      getCurNavZoneType = function() {
        return angular.element('#' + _this.curNavZone).data('nav-type');
      };
      this.getCurNavFocusItem = function() {
        var _ref;

        if ((_ref = _this.curNavFocusItemEl) != null ? _ref.length : void 0) {
          return _this.curNavFocusItemEl;
        }
        _this.curNavFocusItemEl = $('.nav-current-zone:first').find('.nav-current-item-focus:first');
        return _this.curNavFocusItemEl;
      };
      handleHorizontalNav = function(key) {
        var artistRowEl, bottomZone, bottomZoneEl, bottomZoneIndexOnScreen, curNavFocusItem, curSelectedItemInNewZone, curView, curViewArr, diff, dropdown, index, indexOnScreen, newIndex, newNavFocusItemEl, nextItem, nextZone, parentZone, prevItem, prevZone, section, storageData, subModal, upZone, upZoneEl, upZoneIndexOnScreen, videoRowEl;

        curView = App.getView();
        curViewArr = App.getViewArr();
        curViewArr = curViewArr.join('-');
        switch (key) {
          case 'right':
            curNavFocusItem = _this.getCurNavFocusItem();
            nextItem = curNavFocusItem.next('.nav-item');
            if (nextItem.size()) {
              _this.curNavFocusItemEl = nextItem;
              nextItem.addClass('nav-current-item-focus');
              curNavFocusItem.removeClass('nav-current-item-focus');
              if (_this.curNavFocusItemEl.hasClass('vevotv-schedule-item')) {
                return $rootScope.$broadcast('Nav.ngScheduleSlider.vevoTvScheduleNext');
              } else if (_this.curNavFocusItemEl.hasClass('browse-row-item')) {
                parentZone = curNavFocusItem.closest('.nav-wrap');
                if (!nextItem.next('.nav-item').size() && parentZone.attr('data-list') !== 'genres') {
                  $rootScope.$broadcast('Nav.ngBrowse.loadMoreBrowseVideo', {
                    list: parentZone.data('list')
                  });
                }
                return $rootScope.$broadcast('Nav.ngBrowseSlider.browseNext', {
                  list: parentZone.data('list')
                });
              } else if (_this.curNavFocusItemEl.hasClass('search-row-item')) {
                parentZone = curNavFocusItem.closest('.nav-wrap');
                return $rootScope.$broadcast('Nav.ngSearchSlider.searchBrowseNext', {
                  list: parentZone.data('list')
                });
              }
            } else {
              parentZone = curNavFocusItem.closest('.nav-wrap');
              nextZone = parentZone.attr('data-nav-leave-right-' + curViewArr) || parentZone.attr('data-nav-leave-right');
              if (nextZone) {
                _this.curNavZone = nextZone;
                $rootScope.$broadcast('app.updateNavZone');
                curNavFocusItem.removeClass('nav-current-item-focus');
                newNavFocusItemEl = $('#' + nextZone).find('.nav-item:first');
                _this.curNavFocusItemEl = newNavFocusItemEl;
                return newNavFocusItemEl.addClass('nav-current-item-focus');
              }
            }
            break;
          case 'left':
            curNavFocusItem = _this.getCurNavFocusItem();
            prevItem = curNavFocusItem.prev('.nav-item');
            if (prevItem.size()) {
              _this.curNavFocusItemEl = prevItem;
              prevItem.addClass('nav-current-item-focus');
              curNavFocusItem.removeClass('nav-current-item-focus');
              if (_this.curNavFocusItemEl.hasClass('vevotv-schedule-item')) {
                return $rootScope.$broadcast('Nav.ngScheduleSlider.vevoTvSchedulePrev');
              } else if (_this.curNavFocusItemEl.hasClass('browse-row-item')) {
                parentZone = curNavFocusItem.closest('.nav-wrap');
                return $rootScope.$broadcast('Nav.ngBrowseSlider.browsePrev', {
                  list: parentZone.data('list')
                });
              } else if (_this.curNavFocusItemEl.hasClass('search-row-item')) {
                parentZone = curNavFocusItem.closest('.nav-wrap');
                return $rootScope.$broadcast('Nav.ngSearchSlider.searchBrowsePrev', {
                  list: parentZone.data('list')
                });
              } else if ($rootScope.dropdown === 'account') {
                return $rootScope.$apply(function() {
                  return $rootScope.dropdown = "";
                });
              }
            } else {
              parentZone = curNavFocusItem.closest('.nav-wrap');
              prevZone = parentZone.attr('data-nav-leave-left-' + curViewArr) || parentZone.attr('data-nav-leave-left');
              if (prevZone) {
                _this.curNavZone = prevZone;
                $rootScope.$broadcast('app.updateNavZone');
                curNavFocusItem.removeClass('nav-current-item-focus');
                newNavFocusItemEl = $('#' + prevZone).find('.nav-item:last');
                _this.curNavFocusItemEl = newNavFocusItemEl;
                return newNavFocusItemEl.addClass('nav-current-item-focus');
              }
            }
            break;
          case 'down':
            curNavFocusItem = _this.getCurNavFocusItem();
            parentZone = curNavFocusItem.closest('.nav-wrap');
            dropdown = parentZone.data('nav-leave-down-to-dropdown');
            if (dropdown && $rootScope.dropdown === 'account') {
              bottomZone = dropdown;
            } else {
              bottomZone = parentZone.attr('data-nav-leave-down-' + curViewArr) || parentZone.attr('data-nav-leave-down');
            }
            if (bottomZone) {
              _this.curNavZone = bottomZone;
              $rootScope.$broadcast('app.updateNavZone');
              curNavFocusItem.removeClass('nav-current-item-focus');
              bottomZoneEl = $('#' + bottomZone);
              curSelectedItemInNewZone = bottomZoneEl.find('.nav-current-item-selected');
              if (curSelectedItemInNewZone.length) {
                _this.curNavFocusItemEl = curSelectedItemInNewZone;
                curSelectedItemInNewZone.addClass('nav-current-item-focus');
              } else if (bottomZoneEl.hasClass('browse-row')) {
                indexOnScreen = Number(parentZone.attr('data-cur-index-on-screen')) || 0;
                bottomZoneIndexOnScreen = Number(bottomZoneEl.attr('data-cur-index-on-screen'));
                index = Number(bottomZoneEl.attr('data-cur-index'));
                if (indexOnScreen === bottomZoneIndexOnScreen) {
                  newIndex = index;
                } else if (indexOnScreen > bottomZoneIndexOnScreen) {
                  newIndex = index + (indexOnScreen - bottomZoneIndexOnScreen);
                } else {
                  newIndex = index - (bottomZoneIndexOnScreen - indexOnScreen);
                }
                newNavFocusItemEl = bottomZoneEl.find('.nav-item:nth-child(' + (newIndex + 1) + ')');
                _this.curNavFocusItemEl = newNavFocusItemEl;
                newNavFocusItemEl.addClass('nav-current-item-focus');
                diff = indexOnScreen - Number(bottomZoneEl.attr('data-cur-index-on-screen'));
                bottomZoneEl.attr('data-cur-index-on-screen', indexOnScreen);
                bottomZoneEl.attr('data-cur-index', newIndex);
                section = bottomZoneEl.attr('data-list');
                $rootScope.$broadcast('Nav.ngBrowse.updateSectionFocus', {
                  list: section
                });
                $rootScope.$broadcast('Nav.ngBrowseSlider.initBrowseSlider', {
                  list: section,
                  rowIndex: Number(bottomZoneEl.attr('data-row-index')),
                  direction: 'down',
                  curIndexOnScreen: indexOnScreen,
                  indexDiff: diff
                });
              } else if (bottomZoneEl.hasClass('search-row')) {
                indexOnScreen = Number(parentZone.attr('data-cur-index-on-screen')) || 0;
                bottomZoneIndexOnScreen = Number(bottomZoneEl.attr('data-cur-index-on-screen'));
                index = Number(bottomZoneEl.attr('data-cur-index'));
                if (indexOnScreen === bottomZoneIndexOnScreen) {
                  newIndex = index;
                } else if (indexOnScreen > bottomZoneIndexOnScreen) {
                  newIndex = index + (indexOnScreen - bottomZoneIndexOnScreen);
                } else {
                  newIndex = index - (bottomZoneIndexOnScreen - indexOnScreen);
                }
                newNavFocusItemEl = bottomZoneEl.find('.nav-item:nth-child(' + (newIndex + 1) + ')');
                _this.curNavFocusItemEl = newNavFocusItemEl;
                newNavFocusItemEl.addClass('nav-current-item-focus');
                diff = indexOnScreen - Number(bottomZoneEl.attr('data-cur-index-on-screen'));
                bottomZoneEl.attr('data-cur-index-on-screen', indexOnScreen);
                bottomZoneEl.attr('data-cur-index', newIndex);
                section = bottomZoneEl.attr('data-list');
                $rootScope.$broadcast('Nav.ngSearch.updateSectionFocus', {
                  list: section
                });
                $rootScope.$broadcast('Nav.ngSearchSlider.initSearchSlider', {
                  list: section,
                  rowIndex: Number(bottomZoneEl.attr('data-row-index')),
                  direction: 'down',
                  curIndexOnScreen: indexOnScreen,
                  indexDiff: diff
                });
              } else {
                newNavFocusItemEl = bottomZoneEl.find('.nav-item:first');
                _this.curNavFocusItemEl = newNavFocusItemEl;
                newNavFocusItemEl.addClass('nav-current-item-focus');
              }
              if (_this.curNavFocusItemEl.hasClass('vevotv-schedule-item')) {
                return $rootScope.$broadcast('Nav.ngScheduleSlider.initVevoTvSchedule');
              } else if (_this.curNavFocusItemEl.hasClass('playlist-item')) {
                storageData = Storage.get();
                if (storageData != null ? storageData.username : void 0) {
                  return $rootScope.$broadcast('Nav.ngPlaylists.showDeleteOption');
                }
              }
            } else {
              subModal = $rootScope.subModal;
              if (parentZone.attr('id') === 'nav-keypad-controls' && curView === 'search' && subModal !== 'playlistCreate') {
                artistRowEl = angular.element('#nav-search-artist');
                videoRowEl = angular.element('#nav-search-video');
                if (!artistRowEl.length && !videoRowEl.length) {
                  return;
                }
                $rootScope.$broadcast('Nav.ngSearch.handleReturnKeyOnSearchView');
                return _this.navigate('down');
              }
            }
            break;
          case 'up':
            curNavFocusItem = _this.getCurNavFocusItem();
            parentZone = curNavFocusItem.closest('.nav-wrap');
            upZone = parentZone.attr('data-nav-leave-up-' + curViewArr) || parentZone.attr('data-nav-leave-up');
            if (upZone) {
              _this.curNavZone = upZone;
              $rootScope.$broadcast('app.updateNavZone');
              curNavFocusItem.removeClass('nav-current-item-focus');
              upZoneEl = $('#' + upZone);
              curSelectedItemInNewZone = upZoneEl.find('.nav-current-item-selected');
              if (curSelectedItemInNewZone.length) {
                _this.curNavFocusItemEl = curSelectedItemInNewZone;
                curSelectedItemInNewZone.addClass('nav-current-item-focus');
                if (parentZone.hasClass('browse-row')) {
                  return $rootScope.$broadcast('Nav.ngBrowse.updateSectionFocus', {
                    list: ''
                  });
                }
              } else if (upZoneEl.hasClass('browse-row')) {
                indexOnScreen = Number(parentZone.attr('data-cur-index-on-screen'));
                upZoneIndexOnScreen = Number(upZoneEl.attr('data-cur-index-on-screen'));
                index = Number(upZoneEl.attr('data-cur-index'));
                if (indexOnScreen === upZoneIndexOnScreen) {
                  newIndex = index;
                } else if (indexOnScreen > upZoneIndexOnScreen) {
                  newIndex = index + (indexOnScreen - upZoneIndexOnScreen);
                } else {
                  newIndex = index - (upZoneIndexOnScreen - indexOnScreen);
                }
                newNavFocusItemEl = upZoneEl.find('.nav-item:nth-child(' + (newIndex + 1) + ')');
                _this.curNavFocusItemEl = newNavFocusItemEl;
                newNavFocusItemEl.addClass('nav-current-item-focus');
                diff = indexOnScreen - Number(upZoneEl.attr('data-cur-index-on-screen'));
                upZoneEl.attr('data-cur-index-on-screen', indexOnScreen);
                upZoneEl.attr('data-cur-index', newIndex);
                section = upZoneEl.attr('data-list');
                $rootScope.$broadcast('Nav.ngBrowse.updateSectionFocus', {
                  list: section
                });
                return $rootScope.$broadcast('Nav.ngBrowseSlider.initBrowseSlider', {
                  list: section,
                  rowIndex: Number(upZoneEl.attr('data-row-index')),
                  direction: 'up',
                  curIndexOnScreen: indexOnScreen,
                  indexDiff: diff
                });
              } else if (upZoneEl.hasClass('search-row')) {
                indexOnScreen = Number(parentZone.attr('data-cur-index-on-screen'));
                upZoneIndexOnScreen = Number(upZoneEl.attr('data-cur-index-on-screen'));
                index = Number(upZoneEl.attr('data-cur-index'));
                if (indexOnScreen === upZoneIndexOnScreen) {
                  newIndex = index;
                } else if (indexOnScreen > upZoneIndexOnScreen) {
                  newIndex = index + (indexOnScreen - upZoneIndexOnScreen);
                } else {
                  newIndex = index - (upZoneIndexOnScreen - indexOnScreen);
                }
                newNavFocusItemEl = upZoneEl.find('.nav-item:nth-child(' + (newIndex + 1) + ')');
                if (newNavFocusItemEl.size()) {
                  diff = indexOnScreen - Number(upZoneEl.attr('data-cur-index-on-screen'));
                  upZoneEl.attr('data-cur-index-on-screen', indexOnScreen);
                  upZoneEl.attr('data-cur-index', newIndex);
                  section = upZoneEl.attr('data-list');
                  $rootScope.$broadcast('Nav.ngSearch.updateSectionFocus', {
                    list: section
                  });
                  $rootScope.$broadcast('Nav.ngSearchSlider.initSearchSlider', {
                    list: section,
                    rowIndex: Number(upZoneEl.attr('data-row-index')),
                    direction: 'up',
                    curIndexOnScreen: indexOnScreen,
                    indexDiff: diff
                  });
                } else {
                  newNavFocusItemEl = upZoneEl.find('.nav-item:nth-child(1)');
                  upZoneEl.attr('data-cur-index-on-screen', 0);
                  upZoneEl.attr('data-cur-index', 0);
                  section = upZoneEl.attr('data-list');
                  $rootScope.$broadcast('Nav.ngSearch.updateSectionFocus', {
                    list: section
                  });
                  $rootScope.$broadcast('Nav.ngSearchSlider.initSearchSlider', {
                    list: section,
                    rowIndex: Number(upZoneEl.attr('data-row-index')),
                    direction: 'up',
                    curIndexOnScreen: 0,
                    indexDiff: 0
                  });
                }
                _this.curNavFocusItemEl = newNavFocusItemEl;
                return newNavFocusItemEl.addClass('nav-current-item-focus');
              } else if (upZoneEl.hasClass('js-search-keys')) {
                newNavFocusItemEl = upZoneEl.find('.nav-item').filter('[data-char=8]');
                _this.curNavFocusItemEl = newNavFocusItemEl;
                return newNavFocusItemEl.addClass('nav-current-item-focus');
              } else {
                newNavFocusItemEl = upZoneEl.find('.nav-item:first');
                _this.curNavFocusItemEl = newNavFocusItemEl;
                return newNavFocusItemEl.addClass('nav-current-item-focus');
              }
            }
        }
      };
      handleVerticalNav = function(key) {
        var curNavFocusItem, curViewArr, newNavFocusItemEl, nextItem, nextZone, parentZone, prevItem, prevZone;

        curViewArr = App.getViewArr();
        curViewArr = curViewArr.join('-');
        switch (key) {
          case 'down':
            curNavFocusItem = _this.getCurNavFocusItem();
            nextItem = curNavFocusItem.next('.nav-item');
            if (nextItem.size()) {
              _this.curNavFocusItemEl = nextItem;
              nextItem.addClass('nav-current-item-focus');
              return curNavFocusItem.removeClass('nav-current-item-focus');
            } else {
              parentZone = curNavFocusItem.closest('.nav-wrap');
              nextZone = parentZone.attr('data-nav-leave-down-' + curViewArr) || parentZone.attr('data-nav-leave-down');
              if (nextZone) {
                _this.curNavZone = nextZone;
                $rootScope.$broadcast('app.updateNavZone');
                curNavFocusItem.removeClass('nav-current-item-focus');
                newNavFocusItemEl = $('#' + nextZone).find('.nav-item:first');
                _this.curNavFocusItemEl = newNavFocusItemEl;
                return newNavFocusItemEl.addClass('nav-current-item-focus');
              }
            }
            break;
          case 'up':
            curNavFocusItem = _this.getCurNavFocusItem();
            prevItem = curNavFocusItem.prev('.nav-item');
            if (prevItem.size()) {
              _this.curNavFocusItemEl = prevItem;
              prevItem.addClass('nav-current-item-focus');
              return curNavFocusItem.removeClass('nav-current-item-focus');
            } else {
              parentZone = curNavFocusItem.closest('.nav-wrap');
              prevZone = parentZone.attr('data-nav-leave-up-' + curViewArr) || parentZone.attr('data-nav-leave-up');
              if (prevZone) {
                _this.curNavZone = prevZone;
                $rootScope.$broadcast('app.updateNavZone');
                curNavFocusItem.removeClass('nav-current-item-focus');
                newNavFocusItemEl = $('#' + prevZone).find('.nav-item:last');
                _this.curNavFocusItemEl = newNavFocusItemEl;
                newNavFocusItemEl.addClass('nav-current-item-focus');
                if (parentZone.attr('id') === 'nav-account-dropdown') {
                  return $rootScope.$apply(function() {
                    return $rootScope.dropdown = "";
                  });
                }
              }
            }
        }
      };
      this.collapseDropdown = function() {
        var curNavFocusItem, curViewArr, newNavFocusItemEl, parentZone, prevZone;

        curViewArr = App.getViewArr();
        curViewArr = curViewArr.join('-');
        curNavFocusItem = _this.getCurNavFocusItem();
        parentZone = curNavFocusItem.closest('.nav-wrap');
        prevZone = parentZone.attr('data-nav-leave-up-' + curViewArr) || parentZone.attr('data-nav-leave-up');
        if (prevZone) {
          _this.curNavZone = prevZone;
          $rootScope.$broadcast('app.updateNavZone');
          curNavFocusItem.removeClass('nav-current-item-focus');
          newNavFocusItemEl = $('#' + prevZone).find('.nav-item:last');
          _this.curNavFocusItemEl = newNavFocusItemEl;
          newNavFocusItemEl.addClass('nav-current-item-focus');
          if (parentZone.attr('id') === 'nav-account-dropdown') {
            return $rootScope.$apply(function() {
              return $rootScope.dropdown = "";
            });
          }
        }
      };
      return handleGridNav = function(key) {
        var curNavFocusItem, curSelectedItemInNewZone, curView, curViewArr, downZone, downZoneEl, index, newIndex, newNavFocusItemEl, nextItem, numPerRow, parentZone, prevItem, subModal, totalKeys, upZone, upZoneEl;

        curView = App.getView();
        curViewArr = App.getViewArr();
        curViewArr = curViewArr.join('-');
        subModal = $rootScope.subModal;
        switch (key) {
          case 'right':
            curNavFocusItem = _this.getCurNavFocusItem();
            nextItem = curNavFocusItem.next('.nav-item');
            if (nextItem.size()) {
              _this.curNavFocusItemEl = nextItem;
              nextItem.addClass('nav-current-item-focus');
              curNavFocusItem.removeClass('nav-current-item-focus');
              if (curView === 'playlists' && !subModal) {
                parentZone = curNavFocusItem.closest('.nav-wrap');
                index = nextItem.index();
                numPerRow = Number(parentZone.attr('data-num-per-row'));
                if (index % numPerRow === 0) {
                  return $rootScope.$broadcast('Nav.ngPlaylists.navigateDown');
                }
              }
            }
            break;
          case 'left':
            curNavFocusItem = _this.getCurNavFocusItem();
            prevItem = curNavFocusItem.prev('.nav-item');
            if (prevItem.size()) {
              _this.curNavFocusItemEl = prevItem;
              prevItem.addClass('nav-current-item-focus');
              curNavFocusItem.removeClass('nav-current-item-focus');
              if (curView === 'playlists' && !subModal) {
                parentZone = curNavFocusItem.closest('.nav-wrap');
                index = prevItem.index();
                numPerRow = Number(parentZone.attr('data-num-per-row'));
                if (numPerRow - (index % numPerRow) === 1) {
                  return $rootScope.$broadcast('Nav.ngPlaylists.navigateUp');
                }
              }
            }
            break;
          case 'down':
            curNavFocusItem = _this.getCurNavFocusItem();
            parentZone = curNavFocusItem.closest('.nav-wrap');
            numPerRow = Number(parentZone.attr('data-num-per-row'));
            newIndex = curNavFocusItem.index() + numPerRow;
            totalKeys = Number(parentZone.attr('data-total-keys'));
            if (newIndex < totalKeys) {
              newNavFocusItemEl = parentZone.find('.nav-item').eq(newIndex);
              if (newNavFocusItemEl.size()) {
                newNavFocusItemEl.addClass('nav-current-item-focus');
                curNavFocusItem.removeClass('nav-current-item-focus');
                _this.curNavFocusItemEl = newNavFocusItemEl;
                if (curView === 'playlists' && !subModal) {
                  return $rootScope.$broadcast('Nav.ngPlaylists.navigateDown');
                }
              }
            } else {
              downZone = parentZone.attr('data-nav-leave-down-' + curViewArr) || parentZone.attr('data-nav-leave-down');
              if (downZone) {
                downZoneEl = $('#' + downZone);
                _this.curNavZone = downZone;
                $rootScope.$broadcast('app.updateNavZone');
                curNavFocusItem.removeClass('nav-current-item-focus');
                newNavFocusItemEl = downZoneEl.find('.nav-item:first');
                _this.curNavFocusItemEl = newNavFocusItemEl;
                return newNavFocusItemEl.addClass('nav-current-item-focus');
              }
            }
            break;
          case 'up':
            curNavFocusItem = _this.getCurNavFocusItem();
            parentZone = curNavFocusItem.closest('.nav-wrap');
            numPerRow = Number(parentZone.attr('data-num-per-row'));
            newIndex = curNavFocusItem.index() - numPerRow;
            if (newIndex >= 0) {
              newNavFocusItemEl = parentZone.find('.nav-item').eq(newIndex);
              if (newNavFocusItemEl.size()) {
                newNavFocusItemEl.addClass('nav-current-item-focus');
                curNavFocusItem.removeClass('nav-current-item-focus');
                _this.curNavFocusItemEl = newNavFocusItemEl;
                if (curView === 'playlists' && !subModal) {
                  return $rootScope.$broadcast('Nav.ngPlaylists.navigateUp');
                }
              }
            } else {
              upZone = parentZone.attr('data-nav-leave-up-' + curViewArr) || parentZone.attr('data-nav-leave-up');
              if (upZone) {
                _this.curNavZone = upZone;
                $rootScope.$broadcast('app.updateNavZone');
                curNavFocusItem.removeClass('nav-current-item-focus');
                upZoneEl = $('#' + upZone);
                curSelectedItemInNewZone = upZoneEl.find('.nav-current-item-selected');
                if (curSelectedItemInNewZone.length) {
                  _this.curNavFocusItemEl = curSelectedItemInNewZone;
                  curSelectedItemInNewZone.addClass('nav-current-item-focus');
                } else {
                  newNavFocusItemEl = upZoneEl.find('.nav-item:first');
                  _this.curNavFocusItemEl = newNavFocusItemEl;
                  newNavFocusItemEl.addClass('nav-current-item-focus');
                }
                if (curView === 'playlists') {
                  return $rootScope.$broadcast('Nav.ngPlaylists.hideDeleteOption');
                }
              }
            }
        }
      };
    }
  ]);

}).call(this);
