'use strict'

vevo.service 'Network', ['$rootScope', 'App', 'Player', ($rootScope, App, Player) ->

    @init = ->

        setInterval =>
            if not _checkConnection()
                # lost connection
                $rootScope.$apply -> $rootScope.subModal = 'network'
            else
                # re-connected
                if $rootScope.subModal is 'network'
                    $rootScope.$apply -> $rootScope.subModal = ''

                    curView = App.getView()
                    if curView is 'vevotv' or $rootScope.modal is 'video'
                        # reload player
                        Player.reload()
        , 4000

    _checkConnection = =>
        physicalConnection = 0
        httpStatus = 0

        # Get active connection type - wired or wireless.
        currentInterface = networkPlugin.GetActiveType()

        # If no active connection.
        if currentInterface is -1
            return false

        # Check physical connection of current interface.
        physicalConnection = networkPlugin.CheckPhysicalConnection(currentInterface)

        # If not connected or error.
        if physicalConnection isnt 1
            return false

        # Check HTTP transport.
        httpStatus = networkPlugin.CheckHTTP(currentInterface)

        # If HTTP is not avaliable.
        if httpStatus isnt 1
            return false

        # Everything went OK.
        true

]
