// Generated by CoffeeScript 1.6.2
(function() {
  'use strict';  vevo.service('Player', [
    '$rootScope', '$timeout', 'K', 'App', 'API', 'ComScore', function($rootScope, $timeout, K, App, API, ComScore) {
      var _curVideoTime, _handlePlayerBufferingComplete, _handlePlayerBufferingStart, _handlePlayerEnded, _handlePlayerTimeUpdate, _handleRenderError, _inProcessOfSkip, _isSkipForward, _playerCrashCounter, _playerCrashTime,
        _this = this;

      this.plugin = null;
      this.state = -1;
      this.originalSource = null;
      this.STOPPED = 0;
      this.PLAYING = 1;
      this.PAUSED = 2;
      _playerCrashCounter = 0;
      _playerCrashTime = 0;
      _inProcessOfSkip = false;
      _isSkipForward = false;
      _curVideoTime = 0;
      this.launchAppAnimation = true;
      this.initVevoTvFreeWheelCall = true;
      this.curVevoTvProgram = '';
      this.init = function() {
        _this.state = _this.STOPPED;
        _this.plugin = document.getElementById("pluginPlayer");
        _this.plugin.OnBufferingStart = function() {
          return _handlePlayerBufferingStart();
        };
        _this.plugin.OnBufferingComplete = function() {
          return _handlePlayerBufferingComplete();
        };
        _this.plugin.OnCurrentPlayTime = function(time) {
          return _handlePlayerTimeUpdate(time);
        };
        _this.plugin.OnRenderingComplete = function() {
          return _handlePlayerEnded();
        };
        _this.plugin.OnRenderError = function(code) {
          return _handleRenderError(code);
        };
        _this.playIntroClip();
        return window.onunload = function() {
          if (_this.plugin) {
            return _this.plugin.Stop();
          }
        };
      };
      this.playIntroClip = function() {
        var rootPath, url;

        rootPath = window.location.href.split('index.html')[0];
        if (unescape(window.location.toString()).indexOf("/usb/") !== -1) {
          url = 'file://localhost/dtv/usb/sda1/VEVO/' + K.File.launchAnimationUrl;
        } else {
          url = unescape(rootPath).split("file://")[1] + K.File.launchAnimationUrl;
        }
        _this.plugin.SetDisplayArea(0, 0, 960, 540);
        _this.plugin.Play(url);
        _this.state = _this.PLAYING;
        return _gaq.push(['_trackPageview', '/intro']);
      };
      this.play = function() {
        var curView;

        window.pluginAPI.setOffScreenSaver();
        curView = App.getView();
        if (curView === 'vevotv' && _this.state === _this.PAUSED) {
          _this.clear();
          ComScore.trackVevoTv({
            action: 'resume'
          });
        }
        if (_this.state === _this.PAUSED) {
          return _this.resume();
        }
        if ($rootScope.modal === 'video') {
          _this.plugin.Play(App.VideoModal.url);
        } else {
          _this.plugin.Play(K.Stream.vevoTv);
        }
        return _this.state = _this.PLAYING;
      };
      this.playAd = function(src) {
        window.pluginAPI.setOffScreenSaver();
        if (_this.state === _this.PLAYING) {
          _this.plugin.Stop();
          _this.state = _this.STOPPED;
        }
        if (/m3u8$/.test(src)) {
          src = src + '|BITRATES=1000000~3000000|COMPONENT=HLS';
        }
        _this.plugin.Play(src);
        _this.state = _this.PLAYING;
        if ($rootScope.modal === 'video') {
          return $rootScope.$broadcast('Player.ngVideoModal.playedVideoAd');
        } else {
          return $rootScope.$broadcast('Player.ngVevoTv.playedVevoTvAd');
        }
      };
      this.clear = function() {
        if (_this.state === _this.PLAYING || _this.state === _this.PAUSED || App.VevoTv.adInProgress || App.VideoModal.adInProgress) {
          window.pluginAPI.setOnScreenSaver();
          _this.plugin.Stop();
          return _this.state = _this.STOPPED;
        }
      };
      this.resume = function() {
        _this.plugin.Resume();
        _this.state = _this.PLAYING;
        window.pluginAPI.setOffScreenSaver();
        if ($rootScope.modal === 'video') {
          $rootScope.$broadcast('Player.ngVideoModal.playedVideo');
          return ComScore.trackVideo({
            action: 'resume',
            curVideoTime: _curVideoTime
          });
        }
      };
      this.pause = function() {
        if (_this.state === _this.PLAYING) {
          _this.plugin.Pause();
          _this.state = _this.PAUSED;
          if ($rootScope.modal === 'video') {
            $rootScope.$broadcast('Player.ngVideoModal.pausedVideo');
            return ComScore.trackVideo({
              action: 'pause',
              curVideoTime: _curVideoTime
            });
          } else {
            $rootScope.$broadcast('Player.ngVevoTv.pausedVevoTv');
            return ComScore.trackVevoTv({
              action: 'pause'
            });
          }
        }
      };
      this.reload = function() {
        if (_this.state !== _this.PLAYING) {
          return;
        }
        window.pluginAPI.setOffScreenSaver();
        $rootScope.loading = $rootScope.strings.loading;
        _this.clear();
        return _this.play();
      };
      this.skipForward = function() {
        if ($rootScope.modal === 'video') {
          _inProcessOfSkip = true;
          _isSkipForward = true;
          return _this.plugin.JumpForward(20);
        }
      };
      this.skipBack = function() {
        if ($rootScope.modal === 'video') {
          _inProcessOfSkip = true;
          _isSkipForward = false;
          return _this.plugin.JumpBackward(20);
        }
      };
      this.getCurVideoTime = function() {
        return _curVideoTime;
      };
      _handleRenderError = function(code) {
        var index, obj;

        index = App.VideoModal.renditionsIndex + 1;
        obj = App.VideoModal.renditionsArr[0];
        if (obj) {
          App.VideoModal.url = obj.url;
          App.VideoModal.renditionsIndex = index;
          return _this.play();
        }
      };
      _handlePlayerBufferingStart = function() {
        if ($rootScope.modal === 'video') {
          if (_inProcessOfSkip) {
            return ComScore.trackVideo({
              action: 'bufferingStartAfterSkip',
              curVideoTime: _curVideoTime
            });
          } else {
            return ComScore.trackVideo({
              action: 'bufferingStart'
            });
          }
        } else {
          return ComScore.trackVevoTv({
            action: 'bufferingStart'
          });
        }
      };
      _handlePlayerBufferingComplete = function() {
        var curView, fullScreenRatio, heightDiff, loadingDelay, newTime, playerHeight, playerWidth, totalTime, videoHeight, videoRatio, videoWidth, widthDiff, xCoord, yCoord;

        window.pluginAPI.setOffScreenSaver();
        loadingDelay = 0;
        if ($rootScope.loadingType === 'vevotv') {
          loadingDelay = 1000;
          $rootScope.loadingType = '';
        }
        $timeout(function() {
          return $rootScope.loading = false;
        }, loadingDelay);
        if (App.VideoModal.adInProgress || App.VevoTv.adInProgress) {
          $rootScope.$broadcast('Player.FreeWheel.sendTracking');
          _this.plugin.SetDisplayArea(0, 0, 960, 540);
          return;
        }
        if ($rootScope.modal === 'video') {
          if (_inProcessOfSkip) {
            _inProcessOfSkip = false;
            newTime = _curVideoTime;
            if (_isSkipForward) {
              newTime += 20;
            } else {
              newTime -= 20;
            }
            ComScore.trackVideo({
              action: 'newClipPlayAfterSkip',
              curVideoTime: newTime
            });
            $rootScope.$broadcast('Player.ngVideoModal.showTimeBar');
            return;
          }
          videoWidth = Number(_this.plugin.GetVideoWidth());
          videoHeight = Number(_this.plugin.GetVideoHeight());
          fullScreenRatio = 0.5625;
          videoRatio = videoHeight / videoWidth;
          if (videoRatio === fullScreenRatio) {
            xCoord = 0;
            yCoord = 0;
            playerWidth = 960;
            playerHeight = 540;
          } else if (videoRatio < fullScreenRatio) {
            playerWidth = 960;
            playerHeight = (960 * videoHeight) / videoWidth;
            heightDiff = 540 - playerHeight;
            xCoord = 0;
            yCoord = heightDiff / 2;
          } else {
            playerHeight = 540;
            playerWidth = (540 * videoWidth) / videoHeight;
            widthDiff = 960 - playerWidth;
            yCoord = 0;
            xCoord = widthDiff / 2;
          }
          if (App.VideoModal.renditionsIndex === 0) {
            _this.plugin.SetDisplayArea(xCoord, yCoord, playerWidth, playerHeight);
          } else {
            _this.plugin.SetDisplayArea(0, 0, 960, 540);
            App.VideoModal.renditionsIndex = 0;
          }
          totalTime = _this.plugin.GetDuration();
          totalTime = totalTime / 1000;
          totalTime = Math.floor(totalTime);
          App.VideoModal.totalTime = Number(totalTime);
          return $rootScope.$broadcast('Player.ngVideoModal.playedVideo');
        } else {
          curView = App.getView();
          if (curView && curView !== 'vevotv') {
            _this.plugin.Stop();
            _this.state = _this.STOPPED;
            return;
          }
          _this.plugin.SetDisplayArea(0, 0, 960, 540);
          return $rootScope.$broadcast('Player.ngVevoTv.playedVevoTv');
        }
      };
      _handlePlayerTimeUpdate = function(time) {
        var now;

        time = time / 1000;
        time = Math.floor(time);
        now = new Date();
        if (time === _playerCrashTime) {
          _playerCrashCounter++;
        }
        if (_this.state === _this.PLAYING && _playerCrashCounter >= 6) {
          _playerCrashCounter = 0;
        } else {
          _playerCrashCounter = 0;
        }
        if ($rootScope.modal === 'video') {
          if (time !== _curVideoTime) {
            if ($rootScope.loading) {
              $rootScope.loading = false;
            }
            if (App.VideoModal.adInProgress) {
              _curVideoTime = Math.floor(_this.plugin.GetDuration() / 1000);
            } else {
              _curVideoTime = time;
            }
            App.VideoModal.curVideoTime = _curVideoTime;
            return $rootScope.$broadcast('Player.ngVideoModal.updateProgressBar', {
              time: time
            });
          }
        }
      };
      return _handlePlayerEnded = function() {
        var modalView;

        if (_this.launchAppAnimation) {
          _this.launchAppAnimation = false;
          _this.clear();
          if (App.deepLinking) {
            App.VideoModal.searchType = "video";
            App.VideoModal.isrc = App.deepLinking;
            $rootScope.$apply(function() {
              return $rootScope.modal = 'video';
            });
          } else {
            App.updateView(['base', 'vevotv']);
          }
          return;
        }
        if (App.deepLinking && !App.playingAdForDeepLinking) {
          widgetAPI.sendReturnEvent();
          return;
        }
        if ($rootScope.modal === 'video') {
          if (App.VideoModal.adInProgress) {
            return $rootScope.$broadcast('Player.FreeWheel.videoAdEnded');
          } else {
            modalView = $rootScope.app.modalView;
            switch (modalView) {
              case 'browse':
                return $rootScope.$broadcast('Player.ngVideoModalBrowseSlider.autoPlayNext');
              case 'browseShow':
                return $rootScope.$broadcast('Player.ngVideoModalBrowseSlider.autoPlayNext');
              case 'search':
                return $rootScope.$broadcast('Player.ngVideoModalSearchSlider.autoPlayNext');
              case 'playlists':
                return $rootScope.$broadcast('Player.ngVideoModalPlaylistSlider.autoPlayNext');
            }
          }
        } else if (App.VevoTv.adInProgress) {
          return $rootScope.$broadcast('Player.FreeWheel.vevoTvAdEnded');
        }
      };
    }
  ]);

}).call(this);
