// Generated by CoffeeScript 1.6.2
(function() {
  'use strict';  vevo.service('Playlists', [
    '$rootScope', 'Storage', 'API', 'K', 'App', function($rootScope, Storage, API, K, App) {
      var _curPlaylistVideos, _handleAddPublicPlaylistToUser, _handleCreatePublicPlaylist, _handleFetchUserPlaylists, _handleGetUserPlaylistsAfterLogin, _handleUserLoggedOut, _isFocusOnPlaylist, _userPlaylists,
        _this = this;

      _userPlaylists = [];
      _curPlaylistVideos = [];
      _isFocusOnPlaylist = false;
      this.playlistIdToDelete = '';
      this.playlistNameToDelete = '';
      this.init = function() {
        $rootScope.$on('Storage.Playlists.createPublicPlaylist', function() {
          return _handleCreatePublicPlaylist();
        });
        $rootScope.$on('ngActivateModal.Playlists.getUserPlaylistsAfterLogin', function() {
          return _handleGetUserPlaylistsAfterLogin();
        });
        $rootScope.$on('Storage.Playlists.getUserPlaylistsOnAppLoad', function() {
          return _handleFetchUserPlaylists();
        });
        return $rootScope.$on('TvInput.Playlists.userLoggedOut', function() {
          return _handleUserLoggedOut();
        });
      };
      this.getIsFocusOnPlaylist = function() {
        return _isFocusOnPlaylist;
      };
      this.setIsFocusOnPlaylist = function(val) {
        return _isFocusOnPlaylist = val;
      };
      this.getCurPlaylistVideos = function() {
        return _curPlaylistVideos;
      };
      this.setCurPlaylistVideos = function(arr) {
        return _curPlaylistVideos = arr;
      };
      this.deleteSinglePlaylist = function() {
        var arr, userPlaylist, _i, _len;

        arr = [];
        for (_i = 0, _len = _userPlaylists.length; _i < _len; _i++) {
          userPlaylist = _userPlaylists[_i];
          if (userPlaylist.playlist_id !== _this.playlistIdToDelete) {
            arr.push(userPlaylist);
          }
        }
        return _userPlaylists = arr;
      };
      this.getUserPlaylists = function() {
        return _userPlaylists;
      };
      this.addNewUserPlaylist = function(playlist) {
        return _userPlaylists.unshift(playlist);
      };
      this.getPublicPlaylist = function() {
        var storageData;

        storageData = Storage.get();
        return storageData.publicPlaylist;
      };
      this.addToPublicPlaylist = function() {
        var publicPlaylist, videoData, videosArr;

        publicPlaylist = _this.getPublicPlaylist();
        videosArr = publicPlaylist.videos;
        if ($rootScope.modal === 'video') {
          videoData = App.VideoModal.data;
        } else {
          videoData = App.VevoTv.metadata;
        }
        if (!videoData) {
          return;
        }
        if (!videosArr.length) {
          publicPlaylist.image_url = videoData.image_url;
        }
        if (videosArr.length >= 7) {
          $rootScope.$broadcast('Playlists.ngConfirmMessage.reachedMaxVideosInPublicPlaylist');
          return;
        }
        videosArr.push(videoData);
        publicPlaylist.videos = videosArr;
        publicPlaylist.videocount = videosArr.length;
        Storage.set({
          publicPlaylist: publicPlaylist
        });
        $rootScope.$broadcast('Playlists.ngConfirmMessage.addedToWatchLaterPlaylist', {
          title: videoData.title
        });
        return $rootScope.$broadcast('Playlists.ngVideoModalPlaylistSlider.addedNewVideoToPlaylist');
      };
      this.addToUserPlaylist = function(data, callback) {
        var image_url, params, playlistId;

        playlistId = data.playlistId;
        params = {
          playlistId: playlistId,
          isrcs: data.isrcs
        };
        image_url = data.image_url;
        return API.playlists.updatePlaylistForUser(params, function(data) {
          var index, obj, userPlaylist, videocount, _i, _len;

          for (index = _i = 0, _len = _userPlaylists.length; _i < _len; index = ++_i) {
            userPlaylist = _userPlaylists[index];
            if (userPlaylist.playlist_id === playlistId) {
              obj = userPlaylist;
              videocount = Number(userPlaylist.videocount);
              if (videocount === 0) {
                obj.image_url = image_url;
              }
              obj.videocount = videocount + 1;
              _userPlaylists.splice(index, 1);
              _userPlaylists.unshift(obj);
              $rootScope.$broadcast('Playlists.ngVideoModalPlaylistSlider.addedNewVideoToPlaylist');
              break;
            }
          }
          if (callback) {
            return callback();
          }
        });
      };
      this.addToUserSamsungPlaylist = function(videoData) {
        var params, playlistId, userHasSamsungPlaylist, userPlaylist, _i, _j, _len, _len1;

        userHasSamsungPlaylist = false;
        for (_i = 0, _len = _userPlaylists.length; _i < _len; _i++) {
          userPlaylist = _userPlaylists[_i];
          if (userPlaylist.title === K.Playlists.publicTitle) {
            userHasSamsungPlaylist = true;
            break;
          }
        }
        if (userHasSamsungPlaylist) {
          for (_j = 0, _len1 = _userPlaylists.length; _j < _len1; _j++) {
            userPlaylist = _userPlaylists[_j];
            if (userPlaylist.title === K.Playlists.publicTitle) {
              playlistId = userPlaylist.playlist_id;
              break;
            }
          }
          params = {
            playlistId: playlistId,
            isrcs: videoData.isrc
          };
          return API.playlists.updatePlaylistForUser(params, function(data) {
            var index, obj, videocount, _k, _len2;

            for (index = _k = 0, _len2 = _userPlaylists.length; _k < _len2; index = ++_k) {
              userPlaylist = _userPlaylists[index];
              if (userPlaylist.title === K.Playlists.publicTitle) {
                obj = userPlaylist;
                videocount = Number(userPlaylist.videocount);
                if (videocount === 0) {
                  obj.image_url = videoData.image_url;
                }
                obj.videocount = videocount + 1;
                _userPlaylists.splice(index, 1);
                _userPlaylists.unshift(obj);
                break;
              }
            }
            return $rootScope.$broadcast('Playlists.ngConfirmMessage.addedToWatchLaterPlaylist', {
              title: videoData.title
            });
          });
        } else {
          params = {
            isrc: videoData.isrc
          };
          return API.playlists.createPublicPlaylistForUserAfterAdd(params, function(data) {
            _userPlaylists.unshift(data);
            return $rootScope.$broadcast('Playlists.ngConfirmMessage.addedToWatchLaterPlaylist', {
              title: videoData.title
            });
          });
        }
      };
      this.fetchUserPlaylists = function(callback) {
        return API.playlists.getUserPlaylists(function(data) {
          _userPlaylists = data;
          return callback();
        });
      };
      _handleUserLoggedOut = function() {
        return _userPlaylists = [];
      };
      _handleGetUserPlaylistsAfterLogin = function() {
        return API.playlists.getUserPlaylists(function(data) {
          _userPlaylists = data;
          return _handleAddPublicPlaylistToUser(data);
        });
      };
      _handleFetchUserPlaylists = function() {
        return API.playlists.getUserPlaylists(function(data) {
          return _userPlaylists = data;
        });
      };
      _handleAddPublicPlaylistToUser = function(userPlaylistsArr) {
        var publicPlaylist, storageData, userHasPublicPlaylist, userPlaylist, _i, _len;

        storageData = Storage.get();
        publicPlaylist = storageData.publicPlaylist;
        if (publicPlaylist.videocount === 0) {
          return;
        }
        userHasPublicPlaylist = false;
        for (_i = 0, _len = userPlaylistsArr.length; _i < _len; _i++) {
          userPlaylist = userPlaylistsArr[_i];
          if (userPlaylist.title === K.Playlists.publicTitle) {
            userHasPublicPlaylist = true;
            break;
          }
        }
        if (!userHasPublicPlaylist) {
          return API.playlists.createPublicPlaylistForUserAfterLogin(function(data) {
            _userPlaylists.unshift(data);
            return $rootScope.$broadcast('Playlists.ngPlaylists.reloadViewAfterCreatingNewPublicPlaylistForUser');
          });
        }
      };
      return _handleCreatePublicPlaylist = function() {
        return Storage.set({
          publicPlaylist: {
            title: K.Playlists.publicTitle,
            image_url: K.Playlists.publicImage,
            videocount: 0,
            videos: []
          }
        });
      };
    }
  ]);

}).call(this);
