'use strict'

vevo.service 'Storage', ['$rootScope', '$timeout', ($rootScope, $timeout) ->

    _storage = {}

    _fileSystemObj = null

    @init = =>
        _fileSystemObj = new FileSystem()
        bValid = _fileSystemObj.isValidCommonPath(curWidget.id + '/vevo.txt')
        if (bValid == 0)
            _fileSystemObj.createCommonDir(curWidget.id)
            $rootScope.$apply -> $rootScope.storage = {}
            $rootScope.$broadcast 'Storage.Playlists.createPublicPlaylist'
        else

            jsFileObj = _fileSystemObj.openCommonFile(curWidget.id + "/vevo.txt","r")

            fileData = jsFileObj.readAll()
            if fileData
                _storage = JSON.parse(fileData)

                $rootScope.$apply => $rootScope.storage = _storage

                _fileSystemObj.closeCommonFile(jsFileObj)

                if not _storage.publicPlaylist
                    $rootScope.$broadcast 'Storage.Playlists.createPublicPlaylist'

                if _storage.username
                    $rootScope.$broadcast 'Storage.Playlists.getUserPlaylistsOnAppLoad'
            else
                _storage = {}

    @set = (obj) =>
        for key, val of obj
            _storage[key] = val

        $timeout => $rootScope.$apply => $rootScope.storage = _storage

        jsFileObj = _fileSystemObj.openCommonFile(curWidget.id + "/vevo.txt","w")
        jsFileObj.writeLine(JSON.stringify(_storage))
        _fileSystemObj.closeCommonFile(jsFileObj)

    @get = =>
        _storage

    @removeAll = =>
        _storage = {}
        $rootScope.$apply -> $rootScope.storage = {}
        _fileSystemObj.deleteCommonFile(curWidget.id + "/vevo.txt")

    @handleUserLogout = =>
        delete _storage.username
        delete _storage.userId
        delete _storage.sessionToken
        delete _storage.userData

        $timeout => $rootScope.$apply => $rootScope.storage = _storage

        jsFileObj = _fileSystemObj.openCommonFile(curWidget.id + "/vevo.txt","w")
        jsFileObj.writeLine(JSON.stringify(_storage))
        _fileSystemObj.closeCommonFile(jsFileObj)

        $rootScope.$broadcast 'Storage.ComScore.userLoggedOut'


]

