// Generated by CoffeeScript 1.6.2
(function() {
  'use strict';  vevo.service('TvInput', [
    '$rootScope', '$timeout', 'App', 'Nav', 'Player', 'Storage', 'Playlists', 'API', function($rootScope, $timeout, App, Nav, Player, Storage, Playlists, API) {
      var _handleEvent, _handleExit, _handleExitFullScreenMode, _handleHotkey, _handleNavigate, _handlePlayer, _handleReturn, _keyInProgress,
        _this = this;

      _keyInProgress = false;
      this.init = function() {
        var allowedKeys, remoteEl;

        allowedKeys = {};
        allowedKeys[tvKey.KEY_UP] = 1;
        allowedKeys[tvKey.KEY_DOWN] = 1;
        allowedKeys[tvKey.KEY_RIGHT] = 1;
        allowedKeys[tvKey.KEY_LEFT] = 1;
        allowedKeys[tvKey.KEY_ENTER] = 1;
        allowedKeys[tvKey.KEY_INFO] = 1;
        allowedKeys[tvKey.KEY_PAUSE] = 'playerControls';
        allowedKeys[tvKey.KEY_STOP] = 'playerControls';
        allowedKeys[tvKey.KEY_PLAY] = 'playerControls';
        remoteEl = document.getElementById('vevo-remote-key-handler');
        remoteEl.focus();
        return angular.element(remoteEl).keydown(function(e) {
          var curView, isAllowedKeys, isExitModal, isFullScreenMode, isPlayerView, isVevoTvView, isVideoModal, keyCode, modal, subModal;

          keyCode = e.keyCode;
          if (keyCode === tvKey.KEY_RETURN || keyCode === tvKey.KEY_PANEL_RETURN) {
            widgetAPI.blockNavigation(e);
          }
          if ($rootScope.modal === 'video' && $rootScope.loading) {
            widgetAPI.blockNavigation(e);
            return;
          }
          if (_keyInProgress) {
            return;
          }
          _keyInProgress = true;
          $timeout(function() {
            return _keyInProgress = false;
          }, 300);
          if (App.VideoModal.adInProgress || App.VevoTv.adInProgress) {
            if (App.deepLinking) {
              if (keyCode === tvKey.KEY_EXIT) {
                widgetAPI.sendExitEvent();
              } else if (keyCode === tvKey.KEY_RETURN) {
                widgetAPI.sendReturnEvent();
                widgetAPI.blockNavigation(e);
              }
            } else {
              widgetAPI.blockNavigation(e);
            }
            return;
          }
          if ($rootScope.loading && (keyCode === tvKey.KEY_RIGHT || keyCode === tvKey.KEY_LEFT || keyCode === tvKey.KEY_UP || keyCode === tvKey.KEY_DOWN)) {
            return;
          }
          subModal = $rootScope.subModal;
          modal = $rootScope.modal;
          curView = App.getView();
          isAllowedKeys = allowedKeys[keyCode];
          isFullScreenMode = App.VevoTv.isFullScreenMode || App.VideoModal.isFullScreenMode;
          isVideoModal = modal === 'video' && !subModal;
          isVevoTvView = curView === 'vevotv';
          isPlayerView = isVevoTvView || isVideoModal;
          isExitModal = subModal === 'exit';
          if (isAllowedKeys && isFullScreenMode && isPlayerView && !isExitModal) {
            if ($rootScope.modal === 'video') {
              curView = App.getView();
              if (keyCode === tvKey.KEY_RIGHT) {
                switch (curView) {
                  case 'browse':
                    $rootScope.$broadcast('TvInput.ngVideoModalBrowseSlider.autoPlayNext');
                    break;
                  case 'search':
                    $rootScope.$broadcast('TvInput.ngVideoModalSearchSlider.autoPlayNext');
                    break;
                  case 'playlists':
                    $rootScope.$broadcast('TvInput.ngVideoModalPlaylistSlider.autoPlayNext');
                }
              } else if (keyCode === tvKey.KEY_LEFT) {
                switch (curView) {
                  case 'browse':
                    $rootScope.$broadcast('TvInput.ngVideoModalBrowseSlider.autoPlayPrev');
                    break;
                  case 'search':
                    $rootScope.$broadcast('TvInput.ngVideoModalSearchSlider.autoPlayPrev');
                    break;
                  case 'playlists':
                    $rootScope.$broadcast('TvInput.ngVideoModalPlaylistSlider.autoPlayPrev');
                }
              } else {
                if (keyCode !== tvKey.KEY_STOP) {
                  _handleExitFullScreenMode();
                }
              }
            } else {
              _handleExitFullScreenMode();
            }
            if (allowedKeys[keyCode] !== 'playerControls') {
              return;
            }
          } else if (!isExitModal) {
            if (isVideoModal) {
              $rootScope.$broadcast('TvInput.ngVideoModal.resetFullScreenTimer');
            } else if (isVevoTvView) {
              $rootScope.$broadcast('TvInput.ngVevoTv.resetFullScreenTimer');
            }
          }
          switch (keyCode) {
            case tvKey.KEY_UP:
              return _handleNavigate('up');
            case tvKey.KEY_DOWN:
              return _handleNavigate('down');
            case tvKey.KEY_RIGHT:
              return _handleNavigate('right');
            case tvKey.KEY_LEFT:
              return _handleNavigate('left');
            case tvKey.KEY_ENTER:
              return _handleEvent();
            case tvKey.KEY_PAUSE:
              return _handlePlayer('pause');
            case tvKey.KEY_STOP:
              return _handlePlayer('stop');
            case tvKey.KEY_PLAY:
              return _handlePlayer('play');
            case tvKey.KEY_RETURN:
            case tvKey.KEY_PANEL_RETURN:
              _handleReturn();
              return widgetAPI.blockNavigation(e);
            case tvKey.KEY_FF:
              return _handlePlayer('skipForward');
            case tvKey.KEY_RW:
              return _handlePlayer('skipBack');
            case tvKey.KEY_RED:
              return _handleHotkey('A');
            case tvKey.KEY_GREEN:
              return _handleHotkey('B');
            case tvKey.KEY_YELLOW:
              return _handleHotkey('C');
            case tvKey.KEY_BLUE:
              return _handleHotkey('D');
            case tvKey.KEY_EXIT:
              _handleExit();
              return widgetAPI.blockNavigation(e);
          }
        });
      };
      _handleNavigate = function(key) {
        var modalView, subModal;

        subModal = $rootScope.subModal;
        if (subModal === 'playlistSelect') {
          if (key === 'up' || key === 'down') {
            return $rootScope.$broadcast('TvInput.ngPlaylistSelectModal.navigate', {
              key: key
            });
          }
        } else if (subModal === 'exit') {
          if (key === 'left' || key === 'right') {
            return $rootScope.$broadcast('TvInput.ngExitModal.navigate', {
              key: key
            });
          }
        } else if (subModal === 'confirmExplicit') {
          if (key === 'left' || key === 'right') {
            return $rootScope.$broadcast('TvInput.ngConfirmExplicitModal.navigate', {
              key: key
            });
          }
        } else if (subModal === 'playlistDelete') {
          if (key === 'left' || key === 'right') {
            return $rootScope.$broadcast('TvInput.ngPlaylistDeleteModal.navigate', {
              key: key
            });
          }
        } else if ($rootScope.modal === 'video' && subModal !== 'playlistCreate') {
          modalView = $rootScope.app.modalView;
          switch (modalView) {
            case 'browse':
              return $rootScope.$broadcast('TvInput.ngVideoModalBrowseSlider.moveSlider', {
                key: key
              });
            case 'browseShow':
              return $rootScope.$broadcast('TvInput.ngVideoModalBrowseSlider.moveSlider', {
                key: key
              });
            case 'search':
              return $rootScope.$broadcast('TvInput.ngVideoModalSearchSlider.moveSlider', {
                key: key
              });
            case 'playlists':
              return $rootScope.$broadcast('TvInput.ngVideoModalPlaylistSlider.moveSlider', {
                key: key
              });
          }
        } else {
          return Nav.navigate(key);
        }
      };
      _handleHotkey = function(key) {
        var curView, isFocusOnPlaylist, storageData, subModal;

        if (App.deepLinking) {
          return;
        }
        curView = App.getView();
        subModal = $rootScope.subModal;
        storageData = Storage.get();
        switch (key) {
          case 'A':
            if ($rootScope.modal === 'video') {
              return $rootScope.$broadcast('TvInput.ngVideoModal.addToPlaylist');
            } else if (curView === 'vevotv') {
              return $rootScope.$broadcast('TvInput.ngVevotv.addToPlaylist');
            } else if (curView === 'playlists' && (storageData != null ? storageData.username : void 0)) {
              return $rootScope.$broadcast('TvInput.ngPlaylists.showCreateModal');
            }
            break;
          case 'B':
            if (curView === 'playlists') {
              isFocusOnPlaylist = Playlists.getIsFocusOnPlaylist();
              if (isFocusOnPlaylist) {
                return $rootScope.$broadcast('TvInput.ngPlaylists.showDeleteModal');
              }
            }
        }
      };
      _handleReturn = function() {
        var accountNavItemEl, curView, modal, subModal;

        if (App.deepLinking) {
          widgetAPI.sendReturnEvent();
          return;
        }
        curView = App.getView();
        modal = $rootScope.modal;
        subModal = $rootScope.subModal;
        if ($rootScope.dropdown === 'account') {
          accountNavItemEl = angular.element('#nav-item-account');
          accountNavItemEl.addClass('nav-current-item-focus');
          Nav.curNavFocusItemEl = accountNavItemEl;
          Nav.curNavZone = accountNavItemEl.parent().attr('id');
          return $rootScope.$apply(function() {
            return $rootScope.dropdown = '';
          });
        }
        if (subModal === 'network') {
          return widgetAPI.sendExitEvent();
        } else if (subModal === 'confirmExplicit') {
          return $timeout(function() {
            $rootScope.subModal = '';
            return $rootScope.modal = '';
          });
        } else if (subModal === 'playlistSelect' || subModal === 'playlistCreate' || subModal === 'playlistDelete' || subModal === 'exit') {
          return $rootScope.$apply(function() {
            return $rootScope.subModal = '';
          });
        } else if (modal === 'video') {
          if (App.VideoModal.isFullScreenMode) {
            return $rootScope.$apply(function() {
              $rootScope.modal = '';
              return $rootScope.loading = false;
            });
          } else {
            return $rootScope.$broadcast('TvInput.ngVideoModal.hideVideoElements');
          }
        } else if (modal === 'activate') {
          return $rootScope.$broadcast('TvInput.ngActivateModal.closeModal');
        } else if (curView === 'browse') {
          $rootScope.$broadcast('TvInput.ngBrowse.handleReturnKey');
          return $rootScope.$broadcast('TvInput.ngTopNav.handleReturnKey');
        } else if (curView === 'search') {
          return $rootScope.$broadcast('TvInput.ngSearch.handleReturnKeyOnSearchView');
        } else if (curView === 'playlists') {
          return $rootScope.$broadcast('TvInput.ngPlaylists.shiftFocusToTopNav');
        } else if (curView === 'vevotv') {
          if (App.VevoTv.isFullScreenMode) {
            return _handleExit();
          } else {
            return $rootScope.$broadcast('TvInput.ngVevoTv.hideVevoTvElements');
          }
        }
      };
      _handleExit = function() {
        var subModal;

        if (App.deepLinking) {
          widgetAPI.sendExitEvent();
          return;
        }
        subModal = $rootScope.subModal;
        if (subModal === 'network') {
          return widgetAPI.sendExitEvent();
        } else if (subModal !== 'exit') {
          return $rootScope.$apply(function() {
            return $rootScope.subModal = 'exit';
          });
        } else {
          return widgetAPI.sendExitEvent();
        }
      };
      _handleExitFullScreenMode = function() {
        var curView;

        curView = App.getView();
        if (curView === 'vevotv') {
          return $rootScope.$broadcast('TvInput.ngVevoTv.showVevoTvElements');
        } else if ($rootScope.modal === 'video') {
          return $rootScope.$broadcast('TvInput.ngVideoModal.showVideoElements');
        }
      };
      _handlePlayer = function(action) {
        var curView;

        curView = App.getView();
        if (curView !== 'vevotv' && $rootScope.modal !== 'video') {
          return;
        }
        if (action === 'pause' && Player.state === Player.PLAYING) {
          return Player.pause();
        } else if (action === 'stop') {
          if (curView === 'vevotv' && Player.state === Player.PLAYING) {
            return Player.pause();
          } else if ($rootScope.modal === 'video') {
            if (App.deepLinking) {
              widgetAPI.sendReturnEvent();
              return;
            }
            return $rootScope.modal = '';
          }
        } else if (action === 'play' && Player.state !== Player.PLAYING) {
          return Player.play();
        } else if (action === 'skipForward') {
          if ($rootScope.modal === 'video') {
            return Player.skipForward();
          }
        } else if (action === 'skipBack') {
          if ($rootScope.modal === 'video') {
            return Player.skipBack();
          }
        }
      };
      return _handleEvent = function() {
        var artistName, artistRowEl, char, curFocusItemEl, curView, event, modalView, name, obj, playlistId, playlistName, section, showId, showName, storageData, subModal, type, updateSelected, videoRowEl;

        subModal = $rootScope.subModal;
        if (subModal === 'playlistSelect') {
          $rootScope.$broadcast('TvInput.ngPlaylistSelectModal.enterKey');
          return;
        } else if (subModal === 'exit') {
          $rootScope.$broadcast('TvInput.ngExitModal.enterKey');
          return;
        } else if (subModal === 'confirmExplicit') {
          $rootScope.$broadcast('TvInput.ngConfirmExplicitModal.enterKey');
          return;
        } else if (subModal === 'playlistDelete') {
          $rootScope.$broadcast('TvInput.ngPlaylistDeleteModal.enterKey');
          return;
        } else if ($rootScope.modal === 'video' && subModal !== 'playlistCreate') {
          modalView = $rootScope.app.modalView;
          if (modalView === 'browse' || modalView === 'browseShow') {
            $rootScope.$broadcast('TvInput.ngVideoModalBrowseSlider.selectVideoToPlay');
          } else if (modalView === 'search') {
            $rootScope.$broadcast('TvInput.ngVideoModalSearchSlider.selectVideoToPlay');
          } else if (modalView === 'playlists') {
            $rootScope.$broadcast('TvInput.ngVideoModalPlaylistSlider.selectVideoToPlay');
          }
          return;
        }
        curFocusItemEl = Nav.getCurNavFocusItem();
        event = curFocusItemEl.data('enter');
        if (!event) {
          return;
        }
        curView = App.getView();
        updateSelected = function() {
          angular.element('.nav-current-item-selected').removeClass('nav-current-item-selected');
          return curFocusItemEl.addClass('nav-current-item-selected');
        };
        switch (event) {
          case 'showVevoTvView':
            updateSelected();
            App.updateView(['base', 'vevotv']);
            break;
          case 'showPlaylistsView':
            updateSelected();
            App.updateView(['base', 'playlists']);
            break;
          case 'showVideoModalFromBrowse':
            section = curFocusItemEl.closest('.section-wrap').attr('data-section');
            App.VideoModal.isrc = curFocusItemEl.data('isrc');
            $rootScope.$apply(function() {
              $rootScope.app.modalView = 'browse';
              $rootScope.app.videoModalType = section;
              $rootScope.app.videoModalGenreType = curFocusItemEl.attr('data-genre' || '');
              $rootScope.app.videoModalLiftIndex = curFocusItemEl.attr('data-lift-index' || '');
              $rootScope.app.videoModalLiftName = curFocusItemEl.attr('data-lift-name' || '');
              return $rootScope.modal = 'video';
            });
            break;
          case 'showVideoModalFromBrowseShows':
            showId = curFocusItemEl.attr('data-show-id');
            showName = curFocusItemEl.attr('data-show-name');
            $rootScope.app.videoModalShowName = showName;
            obj = {
              showId: showId,
              showName: showName
            };
            $rootScope.$broadcast('TvInput.ngBrowse.playShow', obj);
            break;
          case 'showBrowseView':
            updateSelected();
            App.updateView(['base', 'browse']);
            break;
          case 'showSearchView':
            updateSelected();
            if (curView === 'search') {
              $rootScope.$broadcast('TvInput.ngSearch.focusInSearchBox');
            } else {
              App.updateView(['base', 'search']);
            }
            break;
          case 'showAccount':
            storageData = Storage.get();
            if (storageData != null ? storageData.username : void 0) {
              if ($rootScope.dropdown === 'account') {
                $rootScope.$apply(function() {
                  return $rootScope.dropdown = '';
                });
              } else {
                $rootScope.$apply(function() {
                  return $rootScope.dropdown = 'account';
                });
              }
            } else {
              $rootScope.$apply(function() {
                return $rootScope.modal = 'activate';
              });
            }
            break;
          case 'logout':
            API.activate.unlinkAccount(function() {});
            Storage.handleUserLogout();
            Nav.collapseDropdown();
            $rootScope.$broadcast('TvInput.Playlists.userLoggedOut');
            $rootScope.$broadcast('TvInput.ngPlaylists.userLoggedOut');
            break;
          case 'keypadKey':
            char = curFocusItemEl.attr('data-char');
            $rootScope.$broadcast('TvInput.ngKeypad.enterKeypadKey', {
              char: char
            });
            break;
          case 'keypadDone':
            if (subModal === 'playlistCreate') {
              $rootScope.$broadcast('TvInput.ngPlaylistCreateModal.createPlaylist');
            } else if (curView === 'search') {
              artistRowEl = angular.element('#nav-search-artist');
              videoRowEl = angular.element('#nav-search-video');
              $rootScope.$broadcast('TvInput.ngSearch.handleReturnKeyOnSearchView');
              if (artistRowEl.length || videoRowEl.length) {
                Nav.navigate('down');
              }
            }
            break;
          case 'keypadSpace':
            $rootScope.$broadcast('TvInput.ngKeypad.enterKeypadSpace');
            break;
          case 'keypadDelete':
            $rootScope.$broadcast('TvInput.ngKeypad.enterKeypadDelete');
            break;
          case 'keypadClear':
            $rootScope.$broadcast('TvInput.ngKeypad.enterKeypadClear');
            break;
          case 'keypadCaps':
            $rootScope.$broadcast('TvInput.ngKeypad.enterKeypadCaps');
            break;
          case 'keypadShift':
            $rootScope.$broadcast('TvInput.ngKeypad.enterKeypadShift');
            break;
          case 'showVideoModalFromSearch':
            type = curFocusItemEl.attr('data-search-type');
            App.VideoModal.searchType = type;
            if (type === 'artist') {
              App.VideoModal.artistId = curFocusItemEl.attr('data-artist-id');
              App.VideoModal.artistNumVideos = curFocusItemEl.attr('data-num-videos');
              artistName = curFocusItemEl.attr('data-artist-name');
              name = artistName;
            } else if (type === 'video') {
              App.VideoModal.isrc = curFocusItemEl.attr('data-isrc');
              name = curFocusItemEl.attr('data-video-name');
            }
            section = curFocusItemEl.closest('.section-wrap').attr('data-section');
            $rootScope.$broadcast('TvInput.ngSearch.comScoreTrackSearch', {
              name: name
            });
            $rootScope.$apply(function() {
              $rootScope.modal = 'video';
              $rootScope.app.modalView = 'search';
              $rootScope.app.videoModalType = section;
              return $rootScope.app.videoModalArtistName = artistName;
            });
            break;
          case 'showVideoModalFromPlaylists':
            playlistName = curFocusItemEl.attr('data-playlist-title');
            $rootScope.$apply(function() {
              $rootScope.app.modalView = 'playlists';
              $rootScope.app.videoModalType = 'playlist';
              return $rootScope.app.videoModalPlaylistName = playlistName;
            });
            if ($rootScope.storage.username) {
              playlistId = curFocusItemEl.attr('data-playlist-id');
              $rootScope.$broadcast('TvInput.ngPlaylists.initVideoModalFromPlaylistForUser', {
                playlistId: playlistId
              });
            } else {
              $rootScope.$broadcast('TvInput.ngPlaylists.initVideoModalFromPlaylistForPublic');
            }
        }
        if (event !== 'showAccount' && $rootScope.dropdown === 'account') {
          return $rootScope.$apply(function() {
            return $rootScope.dropdown = '';
          });
        }
      };
    }
  ]);

}).call(this);
